//--*-coding:utf-8-*--

package {

    import com.adobe.serialization.json.JSON;
    import flash.media.Sound;
    import flash.net.URLRequest;
    import mx.controls.Image;
    import mx.core.UIComponent;
    import mx.effects.Move;
    import mx.events.EffectEvent;
    import flash.events.Event;
    import mx.controls.VideoDisplay;
    
    public class CutInImage extends CutInBase {
        
        private var moveEffect:Move;
        
        public function CutInImage():void {
            moveEffect = new Move();
        }
        
        override protected function getMarkString():String {
            return "###CutInImage###";
        }
        
        private function initCutIn():void {
            moveEffect.addEventListener(EffectEvent.EFFECT_END, 
                                        this.completeHandlerForCutIn);
        }
        
        private function completeHandlerForCutIn(event:EffectEvent):void {
            var move:Move = event.currentTarget as Move;
            var targetImage:Image = move.target as Image;
            try {
                dodontoF.removeChild(targetImage);
            } catch(error:Error) {
            }
        }
        
        /*
        override protected function getPrintMessageText(params:Object):String {
            return "【" + params.message + "】";
            //return "カットイン「" + params.message + "」：" + params.source;
        }
        */
        
        override protected function executeEffect(params:Object):void {
            var image:Image = new Image();
            image.width = params.width;
            image.height = params.height;
            image.x = params.startX;
            image.y = params.startY;
            
            image.addEventListener(Event.COMPLETE, function(event:Event):void {
                    var sound:Sound = null;
                    
                    if( isSoundOn(params) ) {
                        sound = new Sound();
                        var request:URLRequest = new URLRequest(params.soundSource);
                        sound.load(request);
                    }
                    
                    effectAndSound(params, image, sound);
                });
            
            dodontoF.addChild(image);
            initCutIn();
            
            image.source = params.source;
        }
        
        private function effectAndSound(params:Object, image:Image, sound:Sound):void {
            moveEffect.target = image;
            moveEffect.xTo = params.endX;
            moveEffect.yTo = params.endY;
            moveEffect.duration = params.duration;
            moveEffect.play();
            
            if( sound != null ) {
                sound.play(0);
            }
        }
        
        private function isSoundOn(params:Object):Boolean {
            if( bSoundOn &&
                (params.soundSource != null) &&
                (params.soundSource != "" ) ) {
                return true;
            }
            return false;
        }
    }
}
