//--*-coding:utf-8-*--
package {
    import mx.core.Application;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import mx.core.UIComponent;
    import flash.display.Sprite;
    import flash.events.KeyboardEvent;
    import flash.events.MouseEvent;
    import flash.text.TextField;
    import flash.ui.Keyboard;
    import mx.containers.Box;
    import mx.controls.Alert;
    import mx.events.CloseEvent;
    import mx.collections.ArrayCollection;
    import flash.system.Capabilities;
    import mx.core.IFlexDisplayObject;
    import flash.utils.ByteArray;
    import flash.utils.setTimeout;
	import flash.net.URLLoader;
    import flash.net.URLRequest;
    import flash.net.URLRequestHeader;
    import flash.net.URLLoaderDataFormat;
    import mx.utils.StringUtil;
    
    
	public class DodontoF_Main extends UIComponent {
        
        [Bindable] public var standingGraphicInfos:ArrayCollection = new ArrayCollection();

        [Bindable] public var visibleDirectionLayer:Boolean = false;
        
        public function setVisibleDirectionLayer(b:Boolean):void {
            visibleDirectionLayer = b;
        }
        
        
        private var cardPreview:CardPickup = null;
        private var playoomName:String = "";
        
        public function getPlayRoomName():String {
            return playoomName;
        }
        
        public function setPlayRoomName(local_playRoomName:String):void {
            playoomName = local_playRoomName;
        }
        
        
        public function setEffects(effects:ArrayCollection):void {
            var tmpCutInInfos:ArrayCollection = new ArrayCollection();
            var tmpStandingGraphicInfos:ArrayCollection =  new ArrayCollection();
            
            for(var i:int = 0 ; i < effects.length ; i++) {
                var effect:Object = effects[i];
                if( effect.type == StandingGraphics.getTypeStatic() ) {
                    tmpStandingGraphicInfos.addItem(effect);
                } else {
                    tmpCutInInfos.addItem(effect);
                }
            }
            
            CutInBase.setCutInInfos(tmpCutInInfos);
            standingGraphicInfos = tmpStandingGraphicInfos;
            
            chatWindow.setStandingGraphics(standingGraphicInfos);
        }
        
        
        private static var staticThis:DodontoF_Main;
        private var thisObj:DodontoF_Main;
        protected var dodontoF:DodontoF;
        private var sender:SharedDataSender;
        private var guiInputSender:GuiInputSender = new GuiInputSender();
        private var map:Map = new Map();
        private var roundTimer:RoundTimer = new RoundTimer();
        
        
        public function setDodontoF(dodontoF_:DodontoF):void {
            dodontoF = dodontoF_;
        }
        
        public function getDodontoF():DodontoF {
            return dodontoF;
        }
        
        public static function getInstance():DodontoF_Main {
            return staticThis;
        }
        
        public function setUniqueId(uniqueId_:String):void {
            this.sender.setUniqueId(uniqueId_);
        }
        
        public function setRefreshTimeout(refreshTimeout:int):void {
            this.sender.setRefreshTimeout(refreshTimeout);
        }
        
        public function getScreenWidth():int {
            return dodontoF.getScreenWidth();
        }
        
        public function getScreenHeight():int {
            return dodontoF.getScreenHeight();
        }
        
        /*
		// コンポーネントのサイズを設定する
		protected override function measure():void {
			measuredWidth = badge.x + badge.width;
			measuredHeight = reflection.y + reflection.height;
		}
        */
        
        //////////////////////////////////////////
        
        public function getGuiInputSender():GuiInputSender {
            return guiInputSender;
        }
        
        public function getRoundTimer():RoundTimer {
            return roundTimer;
        }
        
        public function getMap():Map {
            return map;
        }
        
		public function DodontoF_Main() {
            init();
        }
        
        protected function newSharedDataSender():SharedDataSender {
            return new SharedDataSender();
        }
        
        public function getStandingGraphicLayer():UIComponent {
            return dodontoF.getStandingGraphicLayer();
        }
    
        private function init():void {
            try {
                Log.logging("init start.");
                
                sender = newSharedDataSender();
                
                thisObj = this;
                staticThis = this;
                
                Log.logging("Log init.");
                Log.init(map.getLogLayer());
                Log.logging("map init.");
                map.init(this);
                
                Log.logging("init sender.");
                sender.setMap(map);
                
                Log.logging("init character.");
                MovablePiece.setSharedDataSender(sender);
                guiInputSender.setSender(sender);
                
                Log.logging("init RoundTimer.");
                roundTimer.setSender( sender );
                roundTimer.setReciever( sender.getReciever() );
                
                initCardPreview();
                this.addChild(cardPreview.getView());
                
                Log.logging("init end.");
                
            } catch(e:Error) {
                Log.loggingException("DodontoF_Main.DodontoF_Main()", e);
            }
        }
        
        public function login():void {
            if( isReplayEditMode() ) {
                DodontoF.popup(EditReplayWindow, true);
                return;
            }
            
            DodontoF.popup(LoginWindow, true);
        }
        
        public function logout():void {
            var result:Alert = Alert.show("ログアウトしてよろしいですか？", "ログアウト確認", 
                                          Alert.OK | Alert.CANCEL, null, 
                                          function(e : CloseEvent) : void {
                                              if (e.detail == Alert.OK) {
                                                  thisObj.logoutExecute();
                                              }});
        }
        
        public function logoutExecute():void {
            dodontoF.stopSessionRecording();
            
            chatWindow.sendSystemMessage("がログアウトしました。");
            
            sender.logout();
            dodontoF.mainMenu.visible = false;
            dodontoF.visible = false;
            map.setVisible(false);
            InitiativeWindow.getInstance().visible = false;
            chatWindow.visible = false;
            diceBox.visible = false;
            if( chatPalette != null ) {
                chatPalette.visible = false;
            }
            Alert.show("「どどんとふ」からログアウトしました。お疲れ様でした。");
        }
        
        public function start(isStart:Boolean):void {
            Log.logging("DodontoF_Main start begin");
            
            dodontoF.startWindows();
            
            Log.logging("DodontoF_Main setEvents");
            setEvents();
            Log.logging("DodontoF_Main setEvents");
            if( isStart ) {
                sender.startRefresh();
            }
            
            Log.logging("DodontoF_Main start end");
        }
        
        private function setEvents():void {
            Log.logging("setEventsWheel");
            setEventsWheel();
            
            Log.logging("this addEventListener MOUSE_DOWN");
            this.addEventListener(MouseEvent.MOUSE_DOWN, function(event:MouseEvent):void {
                    //deckStateManager.stopAllDrag();
                });
            
            Log.logging("map.setEvents() calling...");
            map.setEvents();
        }
        
        private function zoomCheck(isZoom:Boolean, mouseX:int, mouseY:int):void {
            if( map.getCardLayer().visible && 
                map.getCardLayer().hitTestPoint(mouseX, mouseY) ) {
                map.zoomCardLayer(isZoom);
            } else {
                map.zoom(isZoom);
            }
        }
        
        private function setEventsWheel():void {
            var mapWheelEvent:Function = function (event:MouseEvent):void {
                var isZoom:Boolean = (event.delta > 0);
                map.zoom(isZoom);
            };
            map.getView().addEventListener(MouseEvent.MOUSE_WHEEL, mapWheelEvent);
            
            var cardWheelEvent:Function = function (event:MouseEvent):void {
                var isZoom:Boolean = (event.delta > 0);
                map.zoomCardLayer(isZoom);
            };
            map.getCardLayer().addEventListener(MouseEvent.MOUSE_WHEEL, cardWheelEvent);
        }
        
        public function zoom(isZoom:Boolean):void {
            zoomCheck(isZoom, 0, 0);
        }
        
        public function setCardPreviewPosition():void {
            var cardView:Sprite = cardPreview.getView();
            var x:int = 10;
            var y:int = 40;
            cardView.x = x;
            cardView.y = y;
        }
        
        public function getCardPreview():CardPickup {
            return cardPreview;
        }
        
        public function setRulerMode():void {
            map.setRulerMode();
        }
        
        static public function getFlashVersion():int {
            var fullVersionString:String = flash.system.Capabilities.version
            Log.loggingTuning(fullVersionString, "fullVersionString"); //output MAC 9,0,115,0
            
            var versionNoString:String = fullVersionString.split(" ")[1].split(",")[0];
            Log.loggingTuning(versionNoString, "versionNoString"); //9
            
            var version:int = parseInt(versionNoString);
            Log.loggingTuning("version", version); //9
            
            return version;
        }
        
        static public function isFileRefecenseLoadMethodSupportVersion():Boolean {
            var version:int = getFlashVersion();
            
            if ( version < 10) {
                return false;
            }
            return true;
        }
        
        public function getUniqueId():String {
            return sender.getUniqueId();
        }
        
        public function clearCards():void {
            sender.clearCards();
        }
        public function initCards(cardTypes:Array):void {
            sender.initCards(cardTypes);
        }
        
        private  function getShffledIndexs(max:int):Array {
            return shuffle(getIndexs(max));
        }
        
        private  function getIndexs(max:int):Array {
            var indexs:Array = new Array();
            for(var i:int = 0 ; i < max ; i++) {
                indexs.push(i);
            }
            return indexs
        }
        
        private  function shuffle(arr:Array):Array {
            var l:int = arr.length;
            var newArr:Array = arr;
            
            while(l){
                var m:int = Math.floor(Math.random()*l);
                var n:int = newArr[--l];
                newArr[l] = newArr[m];
                newArr[m] = n;
            }
            
            return newArr;
        }
        
        
        private function getZeroPaddingString(number:Number, size:uint):String {
            var str:String = number.toString(10);
            while (str.length < size) {
                str = "0" + str;
            }
            return str;
        }
        
        private function initCardPreview():void {
            cardPreview = new CardPickup(Card.getJsonData("", "", 0, 0));
            
            cardPreview.getView().visible = false;
            cardPreview.setRate(1.7);//1.3);
        }
        
        
        private var isReplayModeOn:Boolean = false;
        
        public function isReplayMode():Boolean {
            return isReplayModeOn;
        }
        
        public function replayFromSessionRecord():void {
            setReplayMode();
            getReplay().replayFromSessionRecord();
        }
        
        public function editReplayData():void {
            var window:EditReplayWindow = DodontoF.popup(EditReplayWindow, true) as EditReplayWindow;
            window.loadReplayData();
        }
        
        private function setReplayMode():void {
            isReplayModeOn = true;
            
            diceBox.height = 0;
            diceBox.visible = false;
            
            chatWindow.nameBox.width = 0;
            chatWindow.nameBox.visible = false;
            
            dodontoF.mainMenuBody.width = 0;
            dodontoF.mainMenuBody.visible = false;
            dodontoF.speedBox.percentWidth = 100;
            dodontoF.speedBox.visible = true;
            
            chatWindow.nameBox.height = 0;
            chatWindow.chatControlBox.height = 0;
            chatWindow.chatMessageLogBox.percentHeight = 100;
            
            var isReplayMode:Boolean = true;
            var chatFontSizeForReplayMode:int = 30;//40;
            chatWindow.setChatFontSize(chatFontSizeForReplayMode, isReplayMode);
        }
        
        
        public function setReplaySpeed(speed:Number):void {
            getReplay().setReplaySpeed(speed);
        }
        
        public function clearForReplay():void {
            getChatWindow().clearForReplay();
            sender.clearLastUpdateTimes();
            sender.getReciever().clearChatLastWrittenTime();
            roundTimer.clearForReplay();
        }
        
        public function changeReplayPoint(point:int):void {
            getReplay().changeReplayPoint(point);
        }
        
        
        private var initiativeWindow:InitiativeWindow;
        
        public function setInitiativeWindow(window:IFlexDisplayObject, eventName:String):void {
            initiativeWindow = window as InitiativeWindow;
            initiativeWindow.setChangeVisibleEvent( function(visible:Boolean):void {
                    dodontoF.changeMainMenuToggle(eventName, visible);
                });
        }
        
        public function getInitiativeWindow():InitiativeWindow {
            return initiativeWindow;
        }
        
        private var chatWindow:ChatWindow;
        
        public function setChatWindow(window:IFlexDisplayObject, eventName:String):void {
            chatWindow = window as ChatWindow;
            chatWindow.setChangeVisibleEvent( function(visible:Boolean):void {
                    dodontoF.changeMainMenuToggle(eventName, visible);
                });
        }
        
        public function getChatWindow():ChatWindow {
            return chatWindow;
        }
        
        private var chatPalette:ChatPalette;
        
        public function setChatPaletteWindow(window:IFlexDisplayObject, eventName:String):void {
            chatPalette = window as ChatPalette;
            chatPalette.setChangeVisibleEvent( function(visible:Boolean):void {
                    dodontoF.changeMainMenuToggle(eventName, visible);
                });
        }
        
        public function setChatPaletteVisible(v:Boolean):void {
            chatPalette.setVisibleState(v);
        }
        
        private var diceBox:DiceBox;
        
        public function setDiceWindow(window:IFlexDisplayObject, eventName:String):void {
            diceBox = window as DiceBox;
            diceBox.setChangeVisibleEvent( function(visible:Boolean):void {
                    dodontoF.changeMainMenuToggle(eventName, visible);
                });
        }
        
        public function getDiceBox():DiceBox {
            return diceBox;
        }
        
        static public function zeroPaddingNumber(number:int, count:int = 2):String {
            var baseNumber:int = Math.pow(10, (count - 1));
            
            var result:String = "";
            
            while( baseNumber > number ) {
                result += "0";
                baseNumber = baseNumber / 10;
            }
            
            result += number;
            
            return result;
        }
        
        static public function getDateString():String {
            var date:Date = new Date();
            
            var dateString:String
            = StringUtil.substitute("{0}{1}{2}_{3}{4}{5}", 
                                    zeroPaddingNumber(date.fullYear, 4),
                                    zeroPaddingNumber(date.month + 1),
                                    zeroPaddingNumber(date.date),
                                    zeroPaddingNumber(date.hours),
                                    zeroPaddingNumber(date.minutes),
                                    zeroPaddingNumber(date.seconds));
            
            return dateString;
        }
        
        private function getWindowInfoSaveData(window:IFlexDisplayObject):Object {
            var windowInfo:Object = new Object();
            
            windowInfo.visible = window.visible;
            windowInfo.x = window.x;
            windowInfo.y = window.y;
            windowInfo.width = window.width;
            windowInfo.height = window.height;
            
            return windowInfo;
        }
        
        public function setDiceBoxVisible(v:Boolean):void {
            diceBox.setVisibleState(v);
        }
        
        public function replayFromDataUrl(url:String):void {
            setReplayMode();
            
            var textLoader:URLLoader = new URLLoader();
            textLoader.dataFormat = URLLoaderDataFormat.TEXT;//URLLoaderDataFormat.BINARY;
			textLoader.addEventListener(Event.COMPLETE, replayFromDataUrlOnComplete);
            
            
			var urlRequest:URLRequest = new URLRequest(url);
            //URL呼び出しデータのキャッシュを回避するには以下の2行が必須
            var header:URLRequestHeader = new URLRequestHeader("pragma", "no-cache");
            urlRequest.requestHeaders.push(header);
            textLoader.load(urlRequest);
        }
        
        private function replayFromDataUrlOnComplete(event:Event):void {
            var textLoader:URLLoader = event.currentTarget as URLLoader;
            var dataString:String = textLoader.data;
            //Alert.show(dataString);
            //getReplay().playReplayFromDataString( dataString );
            
            setTimeout(function():void {
                    getReplay().playReplayFromDataString( dataString );
                }, 3 * 1000);
		}

        public function pauseAndPlay():void {
            getReplay().pauseAndPlay();
        }
        
        private var replay:Replay = null;
        
        public function getReplay():Replay {
            if( replay != null ) {
                return replay;
            }
            
            replay = new Replay();
            replay.setSender(sender);
            
            return replay;
        }
        
        public function addRestChatMessageForReplay(messageData:Object):void {
            getReplay().addRestChatMessageForReplay(messageData);
        }
        
        public function getGlobalZoomRate():Number {
            var zoomRate:String = getParams('zoomRate') as String;
            if( zoomRate == null ) {
                return 1;
            }
            
            return parseFloat(zoomRate);
        }
        
        public function isSampleMode():Boolean {
            return ( dodontoF.parameters['isSampleMode'] == "true" );
        }
        
        public function isReplayEditMode():Boolean {
            return ( getParams('isReplayEditMode') == "true" );
        }
        
        public function getReplayDataUrl():String {
            var url:String = getParams('replay');
            url = Config.getInstance().getUrlString(url); //PLEASE_DELETE
            return url
        }
        
        public function getReplayStartPosition():int {
            return parseInt( getParams('replayStartPosition') );
        }
        
        //無効な場合は-1を返す
        public function getLoginRoom():int {
            var value:String = getParams('loginRoom') as String;
            if( value == null ) {
                return -1;
            }
            
            return parseInt( value );
        }
        
        public function getParams(key:String):String {
            return dodontoF.parameters[key];
        }
        
        private var isMentenanceModeOn:Boolean = false;
        
        public function setMentenanceModeOn(b:Boolean):void {
            isMentenanceModeOn = b;
            
            if( isMentenanceModeOn ) {
                dodontoF.mentenanceModeButton.visible = true;
            }
            dodontoF.mentenanceModeButton.selected = isMentenanceModeOn;
        }
        
        public function getMentenanceModeOn():Boolean {
            return isMentenanceModeOn;
        }
        
        public function initForFirstRefresh():void {
            chatWindow.initForFirstRefresh(isMentenanceModeOn);
            
            Config.getInstance().loadViewStateInfo();
            dodontoF.findMainMenuItem("pass_display").enabled = true;
        }

	}
}
