//--*-coding:utf-8-*--

package {
    import mx.controls.ComboBox;
    import mx.collections.ArrayCollection;
    import mx.controls.Alert;
    import mx.core.Application;
    import mx.utils.URLUtil;
    import mx.core.UIComponent;
    
    public class Utils {
        
        static public function setSkin(component:UIComponent):void {
            //component.setStyle("borderSkin", CustomSkin);
        }
        
        static public function getInitiativeInt(initiative:Number):int {
            return Math.floor(initiative);
        }
        
        static public function getInitiativeModify(initiative:Number):int {
            var initiativeModify:int = Math.round(initiative * 100) %100;
            return initiativeModify;
        }
        
        static public function getInitiative(initiativeInt:int, initiativeModify:int):Number {
            var initiative:Number = initiativeInt + (initiativeModify / 100);
            
            return initiative;
        }
        
        static public function getToolTipMessage(piece:InitiativedPiece):String {
            var toolTipMessage:String = "";
            
            toolTipMessage += "[" + piece.getName() + "]";
            
            var addInfos:Array = piece.getAdditionalInfos();
            toolTipMessage += addInfos.join("\n");
            toolTipMessage += "\n";
            
            toolTipMessage += piece.getInfo();
            
            return toolTipMessage;
        }
        
        
        static public function selectComboBox(comboBox:ComboBox, key:String, field:String = "data"):void {
            comboBox.validateNow();
            
            var list:ArrayCollection = comboBox.dataProvider as  ArrayCollection;
            for (var i:int=0; i < list.length ;i++){
                if(list[i][field] == key){
                    comboBox.selectedIndex = i;
                    return;
                }
            }
            
            comboBox.selectedIndex = 0;
        }
        
        
        public static function getOwnUrl():String {
            //Alert.show( URLUtil.getServerName(mx.core.Application.application.url) );
            var regExp:RegExp = /(.+\.swf)\?/i;
            var regResult:Object = regExp.exec(mx.core.Application.application.url);
            if( regResult == null ) {
                return "CanNotGetOwnUrl";
            }
            
            var ownUrl:String = regResult[1];
            
            return ownUrl;
        }
        
        public static function changeZenkakuToHankakuOnDiceBot(str:String):String{
            str = changeZenkakuToHankakuOnAlphabet(str);
            str = changeZenkakuToHankakuOnNumber(str);
            str = changeZenkakuToHankakuOnOperator(str);
            str = changeZenkakuToHankakuOnMark(str);
            return str;
        }
        
        // 文字列の中の全角記号を半角に直して戻す
        public static function changeZenkakuToHankakuOnMark(str:String):String {
            str = changeZenkakuToHankakuOnAll(str, "＠", null, "@");
            str = changeZenkakuToHankakuOnAll(str, "「", null, "[");
            str = changeZenkakuToHankakuOnAll(str, "」", null, "]");
            str = changeZenkakuToHankakuOnAll(str, "［", null, "[");
            str = changeZenkakuToHankakuOnAll(str, "］", null, "]");
            str = changeZenkakuToHankakuOnAll(str, "、", null, ",");
            str = changeZenkakuToHankakuOnAll(str, "，", null, ",");
            return str;
        }
        
        // 文字列の中の全角算術記号を半角に直して戻す
        public static function changeZenkakuToHankakuOnOperator(str:String):String {
            str = changeZenkakuToHankakuOnAll(str, "＋", null, "+");
            str = changeZenkakuToHankakuOnAll(str, String.fromCharCode(65293),  null, "-");
            str = changeZenkakuToHankakuOnAll(str, "＝", null, "=");
            str = changeZenkakuToHankakuOnAll(str, "＞", null, ">");
            str = changeZenkakuToHankakuOnAll(str, "＜", null, "<");
            return str;
        }
        
        // 文字列の中の全角英字を半角英字に直して戻す
        public static function changeZenkakuToHankakuOnAlphabet(str:String):String {
            str = changeZenkakuToHankakuOnAll(str, "Ａ", "Ｚ", "A");
            str = changeZenkakuToHankakuOnAll(str, "ａ", "ｚ", "a");
            return str;
        }
        
        // 文字列の中の全角数字を半角数字に直して戻す
        public static function changeZenkakuToHankakuOnNumber(str:String):String {
            str = changeZenkakuToHankakuOnAll(str, "０", "９", "0");
            return str;
        }
        
        public static function getChangedCharacterZenkakuToHankaku(targetChar:String,
                                                                   startCode:Number, endCode:Number,
                                                                   changeStartCode:Number):String {
            var code:Number = targetChar.charCodeAt(0);
            
            if( (code >= startCode) && (code <= endCode) ) {
                var diff:Number = (code - startCode);
                code = changeStartCode + diff;
            }
            
            return String.fromCharCode(code);
        }
        
        public static function changeZenkakuToHankakuOnAll(str:String,
                                                           startString:String, endString:String,
                                                           changeStartString:String):String {
            var startCode:Number = startString.charCodeAt(0);
            if( endString == null ) {
                endString = startString;
            }
            var endCode:Number = endString.charCodeAt(0);
            var changeStartCode:Number = changeStartString.charCodeAt(0);
            
            var resultString:String = "";
            var isDiceStringEnd:Boolean = false;
            
            for(var i:int = 0 ; i < str.length ; i++){
                var targetChar:String = str.charAt(i);
                
                if( isDiceStringEnd ) {
                    resultString += targetChar;
                    continue;
                }
                
                if( (targetChar == " ") || (targetChar == "　") ) {
                    isDiceStringEnd = true;
                } else {
                    targetChar = getChangedCharacterZenkakuToHankaku(targetChar, startCode, endCode, changeStartCode);
                }
                
                resultString += targetChar;
            }
            
            return resultString;
        }
    }
}

