#!/usr/local/bin/perl

####################################################################
# Perlのバージョンチェックは自動で行うため設定は不要です。
# ありがとうFacelessさん！

my $isPerl_5_8 = ($] >= 5.008  );

####################################################################

use lib src_perl;
use torgtaitaiIRC;
use CGI;

my $torgtaitaiMessage = "";
my $game_type = "";
my $rand_seed = 0;
my $isChangeReturnCode = 0;

if( ($#ARGV + 1) > 0 ) {
    $torgtaitaiMessage = @ARGV[0];
    $isChangeReturnCode = 1;
    $game_type = "DoubleCross";
} else {
    my $taitaiCgi = new CGI;
    
    if( $isPerl_5_8 ) {
        print $taitaiCgi->header(-charset=>'UTF-8');
    } else {
        print $taitaiCgi->header();
    }
    
    $torgtaitaiMessage = $taitaiCgi->param('message');
    $game_type = $taitaiCgi->param('gameType');
    $game_type ||= 'diceBot';
    $rand_seed = $taitaiCgi->param('randomSeed');
}

sub decode {
    my $code = shift;
    my $str = shift;
    #print("code : " . $code . "\n");
    #print("str  : " . $str . "\n");
    return $str;
}

sub encode {
    my $code = shift;
    my $str = shift;
    #print("encode_ code : " . $code . "\n");
    #print("encode_ str  : " . $str . "\n");
    return $str;
}

my $irc = new torgtaitaiIRC( ($torgtaitaiMessage), $game_type );
print("###customBot BEGIN###");
print($torgtaitaiMessage);

#=================================================================================
#【ソフト名】  ゲーム設定型ダイスボット「ボーンズ＆カーズ(bcdice.pl)」Ver.1.2.6
#【著作権者】  Faceless
#【対応環境】  Perl5.8以降の動作可能な環境。
#              必要モジュール NET::IRC, Math::Random::MT::Perl
#【開発言語】  ActivePerl v.5.10.0
#【開発環境】  WindowsXP Pro SP2 + P4
#【 種  別 】  フリーウエア(修正BSDライセンスに準拠)
#【転載条件】  修正BSDライセンス上で許可
#【連絡先 及び １次配布】  http://faceless-tools.cocolog-nifty.com/blog/
# 上記を元にCGIとして動作するように拡張してあります。
# 元のダイスボットで必須であった、NET::IRC、Math::Random::MT::Perlはいずれも不要です。
#===============================================================================
if( $isPerl_5_8 ) {
    require 5.008;							# Perl 5.8以降向け
}
use strict;
use utf8;                               # このソースはUTF-8で書かれています

# ========== モジュールなど ==========
use constant CHARCODE => 'utf8';		# 文字コードを指定(コンソールやカードファイル等)

if( $isPerl_5_8 ) {
    binmode STDIN, ':bytes';					# 入力コードが不定なのでbyteで読み込む
    binmode STDOUT, ":encoding(".CHARCODE.")";	# 標準出力も指定
    binmode STDERR, ":encoding(".CHARCODE.")";	# エラー出力も指定
}

if( $isPerl_5_8 ) {
    require "Encode.pm";
}

#use Encode;                                 # 多バイト文字モジュール
#use Net::IRC;                               # IRCモジュール
BEGIN {     # メルセンヌ・ツイスターがインストールされていれば通常の乱数とコンパチで使う
    my @list = ("Math::Random::MT::Perl",
                "Math::Random::MT",
                );
    foreach my $mod (@list) {
        eval "use $mod qw(srand rand)";
        if (! $@ ) {
            last;
        }
    }
}

#** 動作設定(ユーザによる変更ポイント)
my $NOTICE_SW = 1;                  # 送信の際に、どちらのコマンドを使うか？(notice=1, msg=0)
my $SEND_MODE = 2;                  # デフォルトの送信形式(0=結果のみ,1=0+式,2=1+ダイス個別)
my $SEND_STR_MAX = 400;             # 最大送信文字数(本来は500byte上限)
my $VOID_DICE = 1;                  # 発言の度に空ダイスを振るか？(Yes=1, No=0)
my $DICE_MAXCNT = 200;              # ダイスが振れる最大個数
my $DICE_MAXNUM = 1000;             # ダイスの最大面数
my $IRC_CODE = 'iso-2022-jp';       # IRCサーバとの通信に使うコードを指定
my $HAND_SRT = 1;                   # 手札をソートする必要があるか？(Yes=1, No=0)
my $END_MSG = 'お疲れ様';           # 終了用のTalkコマンド
my $QUIT_MSG = 'さようなら';        # 終了時のメッセージ
my $OPEN_DICE = 'Open Dice!';       # シークレットダイスの出目表示コマンド
my $OPEN_PLOT = 'Open Plot!';       # プロットの表示コマンド
my $ADD_PLOT = 'PLOT';              # プロットの入力コマンド
my $READY_CMD = '#HERE';            # 自分の居るチャンネルの宣言コマンド

my $server = "localhost";           # サーバー
my $port = "6667";                  # ポート番号
my $chan = "#Dice_Test";            # ボットが最初に参加するチャンネル名
my $nick = "bcDICE";                # ニックネーム
my $uern = "bones&cards_v1.2.6";    # ユーザー名
my $ircn = "perldice";              # IRCネーム
#** 動作設定終わり

#============================== 起動法 ==============================
# 上記設定をしてダブルクリック、
# もしくはコマンドラインで
#
# perl bcdice.pl
#
# とタイプして起動します。
#
# このとき起動オプションを指定することで、ソースを書き換えずに設定を変更出来ます。
#
# -s サーバ設定      「-s(サーバ):(ポート番号)」     (ex. -sirc.trpg.net:6667)
# -c チャンネル設定  「-c(チャンネル名)」            (ex. -c#CoCtest)
# -n Nick設定        「-n(Nick)」                    (ex. -nDicebot)
# -g ゲーム設定      「-g(ゲーム指定文字列)」        (ex. -gCthulhu)
# -m メッセージ設定  「-m(Notice_flgの番号)」        (ex. -m0)
# -e エクストラカード「-e(カードセットのファイル名)」(ex. -eTORG_SET.txt)
# -i IRC文字コード   「-i(文字コード名称)」          (ex. -iISO-2022-JP)
#
# ex. perl bcdice.pl -sirc.trpg.net:6667 -c#CoCtest -gCthulhu
#
# プレイ環境ごとにバッチファイルを作っておくと便利です。
#
# 終了時はボットにTalkで「お疲れ様」と発言します。($END_MSGで変更出来ます。)
#====================================================================

#** その他の変数定義(初期化)
#my $game_type = "";
#my $rand_seed = time;   # 乱数シード
my $DodontoFlg = 1;     # どどんとふらぐ(0=IRC, 1=どどんとふ)
#my $irc = new Net::IRC;

my %card_ttl;
my @card_val = ('0',
    'S1','S2','S3','S4','S5','S6','S7','S8','S9','S10','S11','S12','S13',
    'H1','H2','H3','H4','H5','H6','H7','H8','H9','H10','H11','H12','H13',
    'D1','D2','D3','D4','D5','D6','D7','D8','D9','D10','D11','D12','D13',
    'C1','C2','C3','C4','C5','C6','C7','C8','C9','C10','C11','C12','C13',
    'J1',);
my $card_reg = '[DHSCJdhscj][\d]+'; #カード指定文字列の正規表現
my @card_re = @card_val;
my $CARD_MAX = (scalar @card_val)-1;
my $card_m = $CARD_MAX;
my $card_buried = 0;
my %deal_cards = ('card_played' => '');
my @card_spell = (
'A','B','C','D','E','F','G','H','I','J','K','L','M','N','P','Q','R','S','T','U','V','W','X','Y','Z',
'a','b','c','d','e','f','g','h','i','j','k','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
'0','1','2','3','4','5','6','7','8','9','+','-','*','/',
    );  # 64種類の記号
my %card_channel;

my $master = "";
my $modeflg = $SEND_MODE;
my $upperinf = 0;
my $upper_dice = 0;
my $max_dice = 0;
my $min_dice = 0;
my $reroll_cnt = 0;
my $reroll_n = 0;
my $rating_table = 0;
my $d66_on = 0;
my $sort_flg = 0;
my $d66_now = 0;
my $double_up = 0;
my $card_place = 1;
my $can_tap = 1;
my $short_spell = 1;
my $suc_def = "";
my $round_flg = 0;
my $double_type = 0;
my $IRC_NICK_REG = '[A-Za-z\d\-\[\]\\\'^{}_]+';
my %hold_member_list;
my %hold_dice;
my %plot_channel;
my %point_counter;

&game_set($game_type) if($DodontoFlg);


##########################################################################
#**                              メイン
##########################################################################
# 起動時パラメータの解釈
foreach my $arg_wk (@ARGV) {   # コンソールからのパラメータ指定処理
    if($arg_wk =~/^-([scngmeir])(.+)$/i) {
        my $cmd = "\L$1";
        my $prm = $2;
        if($cmd eq "s") {      # サーバ設定(Server:Port)
            my @sp = split(/:/, $prm);
            $server = $sp[0];
            $port = $sp[1] if($sp[1]);
        } elsif($cmd eq "c") { # チャンネル設定
            $chan = decode(CHARCODE, $prm);
        } elsif($cmd eq "n") { # Nick設定
            $nick = $prm;
        } elsif($cmd eq "g") { # ゲーム設定
            &game_set($prm);
        } elsif($cmd eq "m") { # メッセージ設定(出力)
            $NOTICE_SW = int($prm);
        } elsif($cmd eq "e") { # エクストラカードの読み込み
            my $dummy = &card_setup($prm);
            if($dummy ne '_OK_') {
                &debug_out("${dummy}\n");
                die;
            }
        } elsif($cmd eq "i") { # IRCサーバの文字コード変更
            $IRC_CODE = $prm;
        }
    }
}

srand($rand_seed);             # 乱数のタネを明示的に設定(メルセンヌ・ツイスターでは明示的に宣言するべき)

&debug_out("Creating connection to IRC server...\n");
my $conn = $irc->newconn(
    Server   => ($server),
    Port     => ($port),
    Nick     => ($nick),
    Ircname  => ($uern),
    Username => ($ircn))
    or die "$nick : Can't connect to IRC server.\n";

sub on_connect {
    my $self = shift;

    &debug_out("Joining ${chan} ...\n");
    $self->join(encode($IRC_CODE,$chan));
    $self->topic(encode($IRC_CODE,$chan));
}
sub on_init {
    my ($self, $event) = @_;
    my (@args) = ($event->args);

    shift (@args);
    &debug_out("*** @args\n");
}
sub on_part {
    my ($self, $event) = @_;
    my $channel = decode($IRC_CODE,($event->to)[0]);

    &debug_out("*** %s has left channel %s\n", $event->nick, $channel);
}
sub on_join {
    my ($self, $event) = @_;
    my $channel = decode($IRC_CODE,($event->to)[0]);
    my ($nick_j) = $event->nick;
    my ($host_j) = $event->userhost;

    &debug_out("*** %s (%s) has joined channel %s\n",
    $nick_j, $host_j, $channel);
    if ($event->userhost =~ /^someone\@somewhere\.else\.com$/) {  # Auto-ops anyone who
        &debug_out("Give @ to ${nick_j}\n");
        $self->mode(encode($IRC_CODE, $channel), "+o", $nick_j);      # matches hostmask.
    }
}
sub on_invite {
    my ($self, $event) =@_;
    my $channel = decode($IRC_CODE,($event->args)[0]);

    &debug_out("*** %s (%s) has invited me to channel %s\n",
    $event->nick, $event->userhost, $channel);
    
    $chan = &chan_add($chan, $channel);
    $self->join(encode($IRC_CODE, $channel));
    $self->topic(encode($IRC_CODE, $channel));
}
sub on_kick {
    my ($self, $event) = @_;
    my $channel = decode($IRC_CODE,($event->args)[0]);
    my ($nick_e, $mynick) = ($event->nick, $self->nick);
    my ($target) = ($event->to)[0];

    &debug_out("%s Kicked on %s by %s.\n", $target, $channel, $nick_e);
    if($mynick eq $target) {
        $chan = &chan_del($chan, $channel);
    }
}

sub on_msg {
    my ($self, $event) = @_;
    my ($nick_e) = $event->nick;
    my $temp = decode($IRC_CODE,($event->args)[0]);
    my ($output_msg, $arg, $tnick, $cnt);

    &debug_out("*$nick_e*  ", ($temp), "\n");
    my @CHAN_TO = split(/,/, $chan);
    if($temp =~ /->/) {
        ($arg, $tnick) = split(/->/, $temp);
    } else {
        $arg = $temp;
        $tnick = "";
    }
    $arg = parren_killer($arg);

    # ===== 設定関係 ========
    if($arg =~ /^set[\s]/i) {
        # マスター登録
        if($arg =~ /^set[\s]+master$/i) {
            if($master ne "") {
                if($nick_e eq $master) {
                    if($tnick ne "") {
                        $master = $tnick;
                        foreach my $chan_o (@CHAN_TO) {
                            &send_msg($self,$chan_o, "${master}さんをMasterに設定しました");
                        }
                    } else {
                        $master = "";
                        foreach my $chan_o (@CHAN_TO) {
                            &send_msg($self,$chan_o, "Master設定を解除しました");
                        }
                    }
                } else {
                    &send_msg($self,$nick_e, "Masterは${master}さんになっています");
                }
            } else {
                if($tnick ne "") {
                    $master = $tnick;
                } else {
                    $master = $nick_e;
                }
                foreach my $chan_o (@CHAN_TO) {
                    &send_msg($self,$chan_o, "${master}さんをMasterに設定しました");
                }
            }
        }
        # ゲーム設定
        elsif($arg =~ /^set[\s]+game$/i) {
            my $set_msg = &game_set($tnick);
            foreach my $chan_o (@CHAN_TO) {
                &send_msg($self,$chan_o, $set_msg);
            }
        }
        # 表示モード設定
        elsif($arg =~ /^set[\s]+v(iew[\s]*)?mode$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $modeflg = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "ViewMode${modeflg}に変更しました");
                    }
                }
            }
        }
        # 上方無限ロール閾値設定 0=Clear
        elsif($arg =~ /^set[\s]+upper$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $upperinf = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        if($upperinf > 0) {
                            &send_msg($self,$chan_o, "上方無限ロールを${upperinf}以上に設定しました");
                        } else {
                            &send_msg($self,$chan_o, "上方無限ロールの閾値設定を解除しました");
                        }
                    }
                }
            }
        }
        # 個数振り足しロール回数制限設定 0=無限
        elsif($arg =~ /^set[\s]+reroll$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $reroll_cnt = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        if($reroll_cnt > 0) {
                            &send_msg($self,$chan_o, "個数振り足しロール回数を${reroll_n}以下に設定しました");
                        } else {
                            &send_msg($self,$chan_o, "個数振り足しロールの回数を無限に設定しました");
                        }
                    }
                }
            }
        }
        # デ－タ送信モード設定
        elsif($arg =~ /^set[\s]+s(end[\s]*)?mode$/i) {
             my $mode_str;
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $NOTICE_SW = int($1);
                    if ($NOTICE_SW) {
                        $mode_str = "notice-mode"
                    } else {
                        $mode_str = "msg-mode"
                    }
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "SendModeを${mode_str}に変更しました");
                    }
                }
            }
        }
        # レーティング表設定
        elsif($arg =~ /^set[\s]+r(ating[\s]*)?t(able)?$/i) {
             my $mode_str;
             my $pre_mode = $rating_table;
             if(($nick_e eq $master) || ($master eq "")) {
                if($tnick =~ /(\d+)/) {
                    $rating_table = int($1);
                    if ($rating_table > 1) {
                        $mode_str = "2.0-mode";
                        $rating_table = 2;
                    } elsif ($rating_table > 0) {
                        $mode_str = "new-mode";
                        $rating_table = 1;
                    } else {
                        $mode_str = "old-mode";
                        $rating_table = 0;
                    }
                } else {
                    if($tnick =~ /old/i) {
                        $rating_table = 0;
                        $mode_str = "old-mode";
                    } elsif($tnick =~ /new/i) {
                        $rating_table = 1;
                        $mode_str = "new-mode";
                    } elsif($tnick =~ /2\.0/i) {
                        $rating_table = 2;
                        $mode_str = "2.0-mode";
                    }
                }
            }
            if($rating_table != $pre_mode) {
                foreach my $chan_o (@CHAN_TO) {
                    &send_msg($self,$chan_o, "RatingTableを${mode_str}に変更しました");
                }
            }
        }
        # ソートモード設定
        elsif($arg =~ /^set[\s]+sort$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $sort_flg = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "ソート無しに変更しました") if(!$sort_flg);
                        &send_msg($self,$chan_o, "ソート有りに変更しました") if($sort_flg);
                    }
                }
            }
        }
        # カードモード設定
        elsif($arg =~ /^set[\s]+(cardplace|CP)$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $card_place = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "カード置き場無しに変更しました") if(!$card_place);
                        &send_msg($self,$chan_o, "カード置き場ありに変更しました") if($card_place);
                    }
                }
            }
        }
        # 呪文モード設定
        elsif($arg =~ /^set[\s]+(shortspell|SS)$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $short_spell = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "通常呪文モードに変更しました") if(!$short_spell);
                        &send_msg($self,$chan_o, "短い呪文モードに変更しました") if($short_spell);
                    }
                }
            }
        }
        # タップモード設定
        elsif($arg =~ /^set[\s]+tap$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                if ($tnick =~ /(\d+)/) {
                    $can_tap = int($1);
                    foreach my $chan_o (@CHAN_TO) {
                        &send_msg($self,$chan_o, "タップ不可モードに変更しました") if(!$can_tap);
                        &send_msg($self,$chan_o, "タップ可能モードに変更しました") if($can_tap);
                    }
                }
            }
        }
        # カード読み込み
        elsif($arg =~ /^set[\s]+(cardset|CS)$/i) {
             if(($nick_e eq $master) || ($master eq "")) {
                my $card_msgs = &card_setup("$tnick");
                if($card_msgs ne '_OK_') {
                    &send_msg($self,$nick_e, "$card_msgs");
                } else {
                    &send_msg($self,$nick_e, "カードセットの読み込み成功しました");
                }
            }
        }
    }

# ポイントカウンター関係
    if($arg =~ /^#/) {
        my $out_chan = &get_plot_channel("$nick_e");
        if($out_chan ne "1") {
            $arg .= "->${tnick}" if($tnick);
            ($output_msg, my $mode) = &point_counter_command($arg, $nick_e, $out_chan, 1);
            if($output_msg ne "1") {
                if($mode) { # Talkで返事
                    &send_msg($self, $nick_e, $output_msg);
                } else {    # publicで返事
                    &send_msg($self, $out_chan, $output_msg);
                }
            }
        } else {
            &send_msg($self, $nick_e, "表示チャンネルが登録されていません");
        }
    }

# プロット入力処理
    if($arg =~ /${ADD_PLOT}[:：](.+)/i) {
        my $plot = $1;
        my $out_chan = &get_plot_channel("$nick_e");
        if($out_chan ne "1") {
            &add_secret_roll($plot, $nick_e, $out_chan, 1);
            &send_msg($self,$out_chan, "${nick_e} さんがプロットしました");
        } else {
            &send_msg($self,$nick_e, "プロット出力先が登録されていません");
        }
    }


# ボット終了命令
    elsif($arg =~ /^${END_MSG}$/) {
         if(($nick_e eq $master) || ($master eq "")) {
            $self->quit(encode($IRC_CODE,"$QUIT_MSG"));
            sleep 3;
            exit 0;
        }
    }
# モード確認
    elsif($arg =~ /^mode$/i) {
         if(($nick_e eq $master) || ($master eq "")) {
            $output_msg = "GameType = ".$game_type.", ViewMode = ".$modeflg.", Sort = ".$sort_flg;
            &send_msg($self,$nick_e, $output_msg);
        }
    }

# 簡易オンラインヘルプ
    elsif($arg =~ /^help$/i) {
        &send_msg($self,$nick_e, "・加算ロール　　　　　　　　(xDn) (n面体ダイスをx個)");
        &send_msg($self,$nick_e, "・バラバラロール　　　　　　(xBn)");
        &send_msg($self,$nick_e, "・個数振り足しロール　　　　(xRn[振り足し値])");
        &send_msg($self,$nick_e, "・上方無限ロール　　　　　　(xUn[境界値])");
        &send_msg($self,$nick_e, "・シークレットロール　　　　(Sダイスコマンド)");
        &send_msg($self,$nick_e, "・シークレットをオープンする(${OPEN_DICE})");
        &send_msg($self,$nick_e, "・四則計算(端数切捨て)　　　(C(式))");
        sleep 2;
        if($game_type =~ /SwordWorld/) {
            &send_msg($self,$nick_e, "・SW　レーティング表　　　　　(Kx[クリティカル値]) (キーxで2d6ロール)");
        } elsif($game_type eq "Chill") {
            &send_msg($self,$nick_e, "・CHILL　ストライクランク　 　(SRx)");
        } elsif($game_type eq "Demon Parasite") {
            &send_msg($self,$nick_e, "・デモンパラサイト　衝動表　　 (URGEx) (xは衝動段階)");
            &send_msg($self,$nick_e, "・　　〃　　　　　新衝動表　　(NURGEx)");
            &send_msg($self,$nick_e, "・　　〃　　　　　誤作動表　　(AURGEx)");
            &send_msg($self,$nick_e, "・　　〃ミュータント衝動表　　(MURGEx)");
        } elsif($game_type eq "Warhammer") {
            &send_msg($self,$nick_e, "・ウォーハンマークリティカル表(WHpx) (pは部位(HABL)でxはクリティカル値)");
            &send_msg($self,$nick_e, "・ウォーハンマー命中判定　  　(WHx\@p) (xは技能値, pは対象(\@のみで全種))");
        } elsif($game_type eq "Cthulhu") {
            &send_msg($self,$nick_e, "・クトゥルフ　抵抗ロール　  　(RES(x1-x2)) (x1は自分の能力値, x2は相手の能力値)");
        } elsif($game_type eq "DoubleCross") {
            &send_msg($self,$nick_e, "・ダブルクロス　判定ロール  　(xDX\@c) (cはクリティカル値)");
            &send_msg($self,$nick_e, "・ダブルクロス　感情表　　　　(ET)");
        } elsif($game_type eq "ShinobiGami") {
            &send_msg($self,$nick_e, "・シノビガミ　シーン表　　　　(ST)");
            &send_msg($self,$nick_e, "・シノビガミ　都市シーン表　　(CST)");
            &send_msg($self,$nick_e, "・シノビガミ　館シーン表　　　(MST)");
            &send_msg($self,$nick_e, "・シノビガミ　出島シーン表　　(DST)");
            &send_msg($self,$nick_e, "・シノビガミ　ファンブル表　　(FT)");
            &send_msg($self,$nick_e, "・シノビガミ　感情表　　　　　(ET)");
            &send_msg($self,$nick_e, "・シノビガミ　変調表　　　　　(WT)");
            &send_msg($self,$nick_e, "・シノビガミ　戦場表　　　　　(BT)");
        } elsif($game_type eq "Satasupe") {
            &send_msg($self,$nick_e, '・サタスペ　判定ロール  　(nR>=x[y,z]) (n:最大ロール数, x:目標値, y:目標成功数, z:ファンブル値)');
            &send_msg($self,$nick_e, '・タグ決定表　　　　　　　(TAGT)');
            &send_msg($self,$nick_e, '・情報イベント表　　　　　(～IET)');
            &send_msg($self,$nick_e, '　　犯罪表(CrimeIET)、生活表(LifeIET)、恋愛表(LoveIET)、教養表(CultureIET)、戦闘表(CombatIET)');
            &send_msg($self,$nick_e, '・情報ハプニング表　　　　(～IHT)');
            &send_msg($self,$nick_e, '　　犯罪表(CrimeIHT)、生活表(LifeIHT)、恋愛表(LoveIHT)、教養表(CultureIHT)、戦闘表(CombatIHT)');
        sleep 1;
            &send_msg($self,$nick_e, '・命中判定ファンブル表　　(FumbleT)');
            &send_msg($self,$nick_e, '・致命傷表　　　　　　　　(FatalT)');
            &send_msg($self,$nick_e, '・アクシデント表　　　　　(AccidentT)');
            &send_msg($self,$nick_e, '・汎用アクシデント表　　　(GeneralAT)');
            &send_msg($self,$nick_e, '・その後表　　　　　　　　(AfterT)');
        sleep 1;
            &send_msg($self,$nick_e, '・ロマンスファンブル表　　(RomanceFT)');
            &send_msg($self,$nick_e, '・NPCの年齢と好みを一括出力　(NPCT)');
        } elsif($game_type eq "ArsMagica") {
            &send_msg($self,$nick_e, '・ArsMagica ストレスダイス(ArSx) (x:ボッチダイス)');
        } elsif($game_type eq "Tunnels & Trolls") {
            &send_msg($self,$nick_e, '・T&T バーサーク　　　　　(nBS+x)  (n:ダイス数, x:修正)');
            &send_msg($self,$nick_e, '・T&T ハイパーバーサーク　(nHBS+x) (n:ダイス数, x:修正)');
        }
        &send_msg($self,$nick_e, "  ---");
        sleep 1;
        &send_msg($self,$nick_e, "・プロット表示　　　　　　　　(${OPEN_PLOT})");
        &send_msg($self,$nick_e, "・プロット記録　　　　　　　　(Talkで ${ADD_PLOT}:プロット)");
        &send_msg($self,$nick_e, "  ---");
        sleep 2;
        &send_msg($self,$nick_e, "・ポイントカウンタ値登録　　　(#[名前:]タグn[/m]) (識別名、最大値省略可,Talk可)");
        &send_msg($self,$nick_e, "・カウンタ値操作　　　　　　　(#[名前:]タグ+n) (もちろん-nもOK,Talk可)");
        &send_msg($self,$nick_e, "・識別名変更　　　　　　　　　(#RENAME!名前1->名前2) (Talk可)");
        sleep 1;
        &send_msg($self,$nick_e, "・同一タグのカウンタ値一覧　　(#OPEN!タグ)");
        &send_msg($self,$nick_e, "・自キャラのカウンタ値一覧　　(Talkで#OPEN![タグ]) (全カウンタ表示時、タグ省略)");
        &send_msg($self,$nick_e, "・自キャラのカウンタ削除　　　(#[名前:]DIED!) (デフォルト時、識別名省略)");
        &send_msg($self,$nick_e, "・全自キャラのカウンタ削除　　(#ALL!:DIED!)");
        &send_msg($self,$nick_e, "・カウンタ表示チャンネル登録　(${READY_CMD})");
        &send_msg($self,$nick_e, "  ---");
        sleep 2;
        &send_msg($self,$nick_e, "・カード機能ヘルプ　　　　　　(c-help)");
        &send_msg($self,$nick_e, "  -- END ---");
    }
    elsif($arg =~ /^c-help$/i) {
        &send_msg($self,$nick_e, "・カードを引く　　　　　　　(c-draw[n]) (nは枚数)");
        &send_msg($self,$nick_e, "・オープンでカードを引く　　(c-odraw[n])");
        &send_msg($self,$nick_e, "・カードを選んで引く　　　　(c-pick[c[,c]]) (cはカード。カンマで複数指定可)");
        &send_msg($self,$nick_e, "・捨てたカードを手札に戻す　(c-back[c[,c]])");
        &send_msg($self,$nick_e, "・置いたカードを手札に戻す　(c-back1[c[,c]])");
        sleep 1;
        &send_msg($self,$nick_e, "・手札と場札を見る　　　　　(c-hand) (Talk可)");
        &send_msg($self,$nick_e, "・カードを出す　　　　　　　(c-play[c[,c]]");
        &send_msg($self,$nick_e, "・カードを場に出す　　　　　(c-play1[c[,c]]");
        &send_msg($self,$nick_e, "・カードを捨てる　　　　　　(c-discard[c[,c]]) (Talk可)");
        &send_msg($self,$nick_e, "・場のカードを選んで捨てる　(c-discard1[c[,c]])");
        &send_msg($self,$nick_e, "・山札からめくって捨てる　  (c-milstone[n])");
        sleep 1;
        &send_msg($self,$nick_e, "・カードを相手に一枚渡す　　(c-pass[c]相手) (カード指定が無いときはランダム)");
        &send_msg($self,$nick_e, "・場のカードを相手に渡す　　(c-pass1[c]相手) (カード指定が無いときはランダム)");
        &send_msg($self,$nick_e, "・カードを相手の場に出す　　(c-place[c[,c]]相手)");
        &send_msg($self,$nick_e, "・場のカードを相手の場に出す(c-place1[c[,c]]相手)");
        sleep 1;
        &send_msg($self,$nick_e, "・場のカードをタップする　　(c-tap1[c[,c]]相手)");
        &send_msg($self,$nick_e, "・場のカードをアンタップする(c-untap1[c[,c]]相手)");
        &send_msg($self,$nick_e, "  ---");
        sleep 2;
        &send_msg($self,$nick_e, "・カードを配る　　　　　　　(c-deal[n]相手)");
        &send_msg($self,$nick_e, "・カードを見てから配る　　　(c-vdeal[n]相手)");
        &send_msg($self,$nick_e, "・カードのシャッフル　　　　(c-shuffle)");
        &send_msg($self,$nick_e, "・捨てカードを山に戻す　　　(c-rshuffle)");
        &send_msg($self,$nick_e, "・全員の場のカードを捨てる　(c-clean)");
        sleep 1;
        &send_msg($self,$nick_e, "・相手の手札と場札を見る　　(c-vhand) (Talk不可)");
        &send_msg($self,$nick_e, "・枚数配置を見る　　　　　　(c-check)");
        &send_msg($self,$nick_e, "・復活の呪文　　　　　　　　(c-spell[呪文]) (c-spellで呪文の表示)");
        &send_msg($self,$nick_e, "  -- END ---");
    }

}
sub on_public {
    my ($self, $event) = @_;
    my $channel = decode($IRC_CODE,($event->to)[0]);
    my ($nick_e, $mynick) = ($event->nick, $self->nick);
    my $arg = decode($IRC_CODE,($event->args)[0]);
    my $output_msg;
    my $secret_flg;

    &debug_out("${channel} [${nick_e}] ${arg}\n");
    $arg = parren_killer($arg);

# プロットの表示
    if($arg =~ /(^|\s+)${OPEN_PLOT}(\s+|$)/i) {
        my @output_msgs = &open_secret_roll($nick_e, $channel, 1);
        foreach my $msgs (@output_msgs){
            &send_msg($self, $channel, $msgs) if($msgs);
            sleep 1;
        }
        &add_plot_channel($nick_e, $channel);   # プロット表示チャンネルをセット
    }
# シークレットロールの表示
    if($arg =~ /(^|\s+)${OPEN_DICE}(\s+|$)/i) {
        my @output_msgs = &open_secret_roll($nick_e, $channel, 0);
        foreach my $msgs (@output_msgs){
            &send_msg($self, $channel, $msgs) if($msgs);
            sleep 1;
        }
    }
# ポイントカウンター関係
    if($arg =~ /^${READY_CMD}(\s+|$)/i) {
        &add_plot_channel($nick_e, $channel);   # チャンネルをセット
        &send_msg($self, $nick_e, "表示チャンネルを設定しました");
    } elsif($arg =~ /^#/) {
        ($output_msg, $secret_flg) = &point_counter_command($arg, $nick_e, $channel, 0);
        if($secret_flg) {
            &send_msg($self, $nick_e, $output_msg) if($output_msg ne "1");
        } else {
            &send_msg($self, $channel, $output_msg) if($output_msg ne "1");
        }
    }

# ダイスロールの処理
    ($output_msg, $secret_flg) = &dice_command($arg, $nick_e);
    if($secret_flg) {   # 隠しロール
        if($output_msg ne "1") {
            &broadmsg($self, $output_msg, $nick_e);
            &add_secret_roll($output_msg, $nick_e, $channel, 0);
        }
    } else {
        &send_msg($self,$channel, $output_msg) if($output_msg ne "1");
    }
# サタスペのチャート処理
    if($game_type eq "Satasupe") {
        if($arg =~ /(^|\s)(S)?(\w+)($|\s)/i) {
            my @output_msgs = &satasupe_table($3);
            my $i = 1;
            foreach my $msgs (@output_msgs) {
                if($2) {
                    &broadmsg($self, "$nick_e: ".$msgs, $nick_e) if($msgs);
                } else {
                    &send_msg($self, $channel, "$nick_e: ".$msgs) if($msgs);
                }
                sleep 1 if(!($i % 5));
                $i++;
            }
        }
    }

# カード処理
    if($arg =~ /(c-)/) {
        my $card_ok;
        my $count;
        if($arg =~ /(c-shuffle|c-sh)($|\s)/) {
            $output_msg = &c_shuffle("$arg", "$nick_e");
            &send_msg($self,$channel, $output_msg);
        }
        if($arg =~ /c-draw(\[[\d]+\])?($|\s)/) {
            ($count, $output_msg) = &c_draw("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$nick_e, &c_look($output_msg));
                &send_msg($self,$channel, "$nick_e: $count".'枚引きました');
            }else{
                &send_msg($self,$channel, "カードが残っていません");
            }
            $card_channel{"$nick_e"} = $channel if(!(exists $card_channel{"$nick_e"}));
        }
        if($arg =~ /(c-odraw|c-opend)(\[[\d]+\])?($|\s)/) {
            my $cmd = "c-draw";
            $cmd .= "$2" if($2);
            ($count, $output_msg) = &c_draw($cmd, "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: ".&c_look($output_msg).'を引きました');
            }else{
                &send_msg($self,$channel, "カードが残っていません");
            }
            $card_channel{"$nick_e"} = $channel if(!(exists $card_channel{"$nick_e"}));
        }
        if($arg =~ /c-hand($|\s])/) {
            &send_msg($self, $nick_e, &c_hand("$arg", "$nick_e"));
        }
        if($arg =~ /c-vhand\s*(${IRC_NICK_REG})($|\s)/) {
            &send_msg($self, $nick_e, "$1 の手札は".&c_hand("c-hand", "$1")."です");
        }
        if($arg =~ /c-play(\d*)\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg, $card_ok) = &c_play("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚出しました');
                &send_msg($self,$channel, "[".&c_look($card_ok)."]") if(%card_ttl);
            }
            if($output_msg ne "") {
                &send_msg($self,$channel, "[".&c_look($output_msg)."]は持っていません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /(c-rshuffle|c-rsh)($|\s)/) {
            $output_msg = &c_rshuffle("$arg", "$nick_e");
            &send_msg($self,$channel, $output_msg);
        }
        if($arg =~ /c-clean($|\s)/) {
            $output_msg = &c_clean("$arg", "$nick_e");
            &send_msg($self, $channel, $output_msg);
        }
        if($arg =~ /c-review($|\s)/) {
            $output_msg = &c_review("$arg", "$nick_e");
            &send_msg($self,$nick_e, $output_msg);
        }
        if($arg =~ /c-check($|\s)/) {
            my($out_msg,  @place_msg) = &c_check("$arg", "$nick_e");
            &send_msg($self, $channel, $out_msg);
            if(@place_msg) {
                foreach my $place_m (@place_msg) {
                    &send_msg($self, $channel, $place_m);
                }
            }
        }
        if($arg =~ /c-pass(\d)*(\[${card_reg}(,${card_reg})*\])?\s*(${IRC_NICK_REG})($|\s)/) {
            ($count, $output_msg) = &c_pass("$arg", "$nick_e");
            if($count < 0) {
                &send_msg($self, $channel, "$nick_e: ".'相手が登録されていません');
            } else {
                if($output_msg ne "") {
                    &send_msg($self, $channel, "[".&c_look($output_msg)."]".'がありません');
                }
                if($count > 0) {
                    &send_msg($self, $channel, "$nick_e: $count".'枚渡しました');
                    &send_msg($self, $4, &c_hand("Auto", "$4"));
                }
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-pick\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg) = &c_pick("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚選んで引きました');
            }
            if($output_msg ne "") {
                &send_msg($self,$channel, "[".&c_look($output_msg)."]がありません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-back(\d)*\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg) = &c_back("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚戻しました');
            }
            if($output_msg ne "") {
                &send_msg($self,$channel, "[".&c_look($output_msg)."]がありません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-deal(\[[\d]+\]|\s)\s*(${IRC_NICK_REG})($|\s)/) {
            ($count, $output_msg) = &c_draw("c-draw$1", "$2");
            if($count > 0) {
                &send_msg($self, $2, $output_msg);
                &send_msg($self, $channel, "$nick_e: $2".'に'.$count.'枚配りました');
            }else{
                &send_msg($self, $channel, "カードが残っていません");
            }
            $card_channel{"$2"} = $channel if(!(exists $card_channel{"$2"}));
        }
        if($arg =~ /c-vdeal(\[[\d]+\]|\s)\s*(${IRC_NICK_REG})($|\s)/) {
            ($count, $output_msg) = &c_draw("c-draw$1", "$2");
            if($count > 0) {
                &send_msg($self, $2, $output_msg);
                &send_msg($self, $nick_e, "$2 に $output_msg を配りました");
                &send_msg($self, $channel, "$nick_e: $2".'に'.$count.'枚配りました');
            }else{
                &send_msg($self, $channel, "カードが残っていません");
            }
            $card_channel{"$2"} = $channel if(!(exists $card_channel{"$2"}));
        }
        if($arg =~ /c-(dis|discard)(\d)*\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg,$card_ok) = &c_discard("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚捨てました');
                &send_msg($self,$channel, "[".&c_look($card_ok)."]") if(%card_ttl);
            }
            if($output_msg ne "") {
                &send_msg($self,$nick_e, "[".&c_look($output_msg)."]がありません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-place(\d)*(\[${card_reg}(,${card_reg})*\])?\s*(${IRC_NICK_REG})($|\s)/) {
            ($count, $output_msg, $card_ok) = &c_place("$arg", "$nick_e");
            if($count < 0) {
                &send_msg($self, $channel, "$nick_e: ".'相手が登録されていません');
            } else {
                if($output_msg ne "") {
                    &send_msg($self, $channel, "[".&c_look($output_msg)."]".'がありません');
                }
                if($count > 0) {
                    &send_msg($self, $channel, "$nick_e: $count".'枚場に置きました');
                    &send_msg($self, $channel, "[".&c_look($card_ok)."]") if(%card_ttl);
                    &send_msg($self, $4, &c_hand("Auto", "$4"));
                }
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-tap(\d+)\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg, $card_ok) = &c_tap("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚タップしました');
                &send_msg($self,$channel, "[".&c_look($card_ok)."]") if(%card_ttl);
            }
            if($output_msg ne "") {
                &send_msg($self,$channel, "[".&c_look($output_msg)."]は場にありません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-untap(\d+)\[${card_reg}(,${card_reg})*\]($|\s)/) {
            ($count, $output_msg, $card_ok) = &c_tap("$arg", "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: $count".'枚アンタップしました');
                &send_msg($self,$channel, "[".&c_look($card_ok)."]") if(%card_ttl);
            }
            if($output_msg ne "") {
                &send_msg($self,$channel, "[".&c_look($output_msg)."]は場にありません");
            }
            &send_msg($self, $nick_e, &c_hand("Auto", "$nick_e"));
        }
        if($arg =~ /c-spell(\[([\s,]*(${IRC_NICK_REG}:)?[A-Za-z0-9\+\-\/\*]+)+\])?($|\s)/) {
            $output_msg = &c_spell("$arg", "$nick_e");
            if($output_msg ne "0") {
                &send_msg($self, $channel, $output_msg);
            } else {
                &send_msg($self, $channel, "$nick_e: ".'カード配置を復活しました');
            }
        }
        if($arg =~ /(c-mil(stone)?(\[[\d]+\])?)($|\s)/) {
            ($count, $output_msg) = &c_milstone($1, "$nick_e");
            if($count > 0) {
                &send_msg($self,$channel, "$nick_e: ".&c_look($output_msg).'が出ました');
            }else{
                &send_msg($self,$channel, "カードが残っていません");
            }
        }
    }

# 四則計算代行
    if($arg =~ /(^|\s)C([-\d]+)\s*$/i) {
        $output_msg = $2;
        if($output_msg ne "") {
            &send_msg($self,$channel, "$nick_e: 計算結果 ＞ $output_msg");
        }
    }

    if(!$output_msg || $output_msg eq '1') {    # ダイスロール以外の発言では捨てダイス処理を
        rand 100 if($VOID_DICE);
    }

}
sub on_names {
    my ($self, $event) = @_;
    my (@list, $channel) = ($event->args);  # eat yer heart out, mjd!
    my $chan;

    ($chan, @list) = splice @list, 2;
    $chan = decode($IRC_CODE,$chan);
    &debug_out("Users on $chan: @list\n");
}
sub on_ping {
    my ($self, $event) = @_;
    my $nick = $event->nick;

    $self->ctcp_reply($nick, join (' ', ($event->args)));
    &debug_out("*** CTCP PING request from $nick received\n");
}
sub on_ping_reply {
    my ($self, $event) = @_;
    my ($args) = ($event->args)[1];
    my ($nick) = $event->nick;

    $args = time - $args;
    &debug_out("*** CTCP PING reply from $nick: $args sec.\n");
}
sub on_nick_taken {
    my ($self) = shift;

    $self->nick(substr($self->nick, -1) . substr($self->nick, 0, 8));
}
sub on_action {
    my ($self, $event) = @_;
    my ($nick, @args) = ($event->nick, $event->args);

    foreach my $arg_o (@args) {
        $arg_o = decode($IRC_CODE,$arg_o);
    }
    &debug_out("* $nick @args\n");
}
sub on_disconnect {
    my ($self, $event) = @_;

    &debug_out("Disconnected from ", $event->from(), " (",
          ($event->args())[0], "). Attempting to reconnect...\n");
    $self->connect();
}
sub on_topic {
    my ($self, $event) = @_;
    my (@args) = $event->args();
    my $chan = decode($IRC_CODE,($event->to())[0]);

    foreach  my $arg_o (@args) {
        $arg_o = decode($IRC_CODE,$arg_o);
    }
    if ($event->type() eq 'notopic') {
        &debug_out("No topic set for $args[1].\n");
    } elsif ($event->type() eq 'topic' and $event->to()) {
        &debug_out("Topic change for ", $chan, ": $args[0]\n");
    } else {
        &debug_out("The topic for $args[1] is \"$args[2]\".\n");
    }
}
sub chan_add {
    my ($list, $add_ch) = @_;

    $list .= "," if($list ne "");
    $list .= $add_ch;
    return $list;
}
sub chan_del {
    my ($list, $del_ch) = @_;
    my (@CHAN_TO, @CHAN_TO2);

    @CHAN_TO = split(/,/, $list);
    foreach my $chan_o (@CHAN_TO) {
        if($chan_o eq $del_ch) {
        } else {
            push(@CHAN_TO2, $chan_o);
        }
    }
    $list = join(",", @CHAN_TO2);
    return $list;
}

###########################################################################
#**                         各種コマンド処理
###########################################################################

#=========================================================================
#**                           コマンド分岐
#=========================================================================
sub dice_command {  # ダイスコマンドの分岐処理
    my $arg = "\U$_[0]";
    my $nick_e = $_[1];
    my $output_msg = '1';
    my $secret_flg = 0;

    if($arg =~ /[KDBRU][\d]/) {
    # ソードワールドのレーティング表ロール検出
        if($arg =~ /K[\d+-]+(\[[\d]+\])?[\d+-]*(@\d+)?($|\s)/) {
            $output_msg = &rating("$arg", "$nick_e");
            if($arg =~ /SK[\d+-]+/) {  # 隠しロール
                $secret_flg = 1;
            }
        }
    # 加算ロール検出
        elsif($arg =~ /[-\d]+D[\d\+\*\-D]+([<>=]+[?\-\d]+)?($|\s)/) {
            $output_msg = &dice("$arg", "$nick_e");
            if($arg =~ /S[-\d]+D[\d+-]+/) {    # 隠しロール
                $secret_flg = 1;
            }
        }
    # バラバラロール検出
        elsif($arg =~ /[\d]+B[\d]+([<>=]+[\d]+)?($|\s)/) {
            $output_msg = &bdice("$arg", "$nick_e");
            if($arg =~ /S[\d]+B[\d]+/i) {   # 隠しロール
                $secret_flg = 1;
            }
        }
    # 個数振り足しロール検出
        elsif($arg =~ /[\d]+R[\d]+/) {
            if($game_type eq "DoubleCross") {
                $output_msg = &dxdice("$arg", "$nick_e");
            } elsif($game_type eq "ArsMagica") {
                $output_msg = &arsmagica_stress("$arg", "$nick_e");
            } elsif($game_type eq "Tunnels & Trolls") {
                $output_msg = &tandt_berserk("$arg", "$nick_e");
            } else {
                $output_msg = &rdice("$arg", "$nick_e");
            }
            if($arg =~ /S[\d]+R[\d]+/i) {   # 隠しロール
                $secret_flg = 1;
            }
        }
    # 上方無限ロール検出
        elsif($arg =~ /[\d]+U[\d]+/) {
            $output_msg = &udice("$arg", "$nick_e");
            if($arg =~ /S[\d]+U[\d]+/) {   # 隠しロール
                $secret_flg = 1;
            }
        }
    }
    # サタスペ関係
    if($game_type eq "Satasupe") {
        if($arg =~ /((^|\s)(\d+)(S)?R[>=]+(\d+)(\[(\d+)?(,\d+)?\])?($|\s))/i) { # 判定ロール
            $output_msg = &satasupe_check("\U$1", "$nick_e");
            if($1 =~ /SR/i) {   # 隠しロール
                $secret_flg = 1;
            }
        } else {
        }
    }
    if($game_type eq "Chill") {
        # ストライクランク計算
        if($arg =~ /SR(\d+)($|\s)/i) {
            $output_msg = &strike_rank("$arg", "$nick_e");
            if($arg =~ /SSR(\d+)/i) {   # 隠しロール
                $secret_flg = 1;
            }
        }
    }
    # ウォーハンマー攻撃コマンド
    if($arg =~ /(WH\d+(@[\dWH]*)?)($|\s)/) {
        $output_msg = &wh_att("$1", "$nick_e");
        if($arg =~ /S(WH\d+(@[\dWH]+)?)/) {    # 隠しロール
            $secret_flg = 1;
        }
    }
    # 表関係
    if($arg =~ /((\w)?URGE(\s*)(\d+))($|\s)/i) {    # デモンパ衝動表
        $output_msg = &dp_urge("\U$1", "$nick_e");
        if($arg =~ /S(\w)?URGE(\s*)(\d+)/i) {   # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /(WH[HABTLW]\d+)($|\s)/i) {  # ウォーハンマークリティカル表
        $output_msg = &wh_crit("\U$1", "$nick_e");
        if($arg =~ /S(WH[HABTLW]\d+)/i) {   # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /(RES[\-\d]+)($|\s)/i) { # CoC抵抗表コマンド
        $output_msg = &coc_res("\U$1", "$nick_e");
        if($arg =~ /S(RES[\-\d]+)/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /((^|\s)(\w)*ST($|\s))/i) {  # シーン表
        $output_msg = &sinobigami_scene_table("\U$1", "$nick_e");
        if($1 =~ /S[CMD]?ST/i) {    # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /((^|\s)(S)?FT($|\s))/i) {   # ファンブル表
        $output_msg = &sinobigami_fumble_table("$nick_e");
        if($1 =~ /SFT/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /((^|\s)(S)?ET($|\s))/i) {   # 感情表
        if($game_type eq "ShinobiGami") {
            $output_msg = &sinobigami_emotion_table("$nick_e");
        } elsif($game_type eq "DoubleCross") {
            $output_msg = &dx_emotion_table("$nick_e");
        }
        if($1 =~ /SET/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /((^|\s)(S)?WT($|\s))/i) {   # 変調表
        $output_msg = &sinobigami_wrong_table("$nick_e");
        if($1 =~ /SWT/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }
    if($arg =~ /((^|\s)(S)?BT($|\s))/i) {   # 戦場表
        $output_msg = &sinobigami_battlefield_table("$nick_e");
        if($1 =~ /SBT/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }

    if($arg =~ /((^|\s)(S)?choise\[[\w,]+\]($|\s))/i) {   # 選択コマンド
        $output_msg = &choise_random($1, "$nick_e");
        if($1 =~ /Schoise/i) {  # 隠しロール
            $secret_flg = 1;
        }
    }

    return ($output_msg, $secret_flg);
}
sub point_counter_command {
    my $arg = $_[0];
    my $p_nick = $_[1];
    my $p_chan = $_[2];
    my $mode = $_[3];
    my $output = "1";

    if($arg =~ /^#/){
        if($arg =~ /^#OPEN!/i) {
            $output = &get_point_list($arg, $p_nick, $p_chan, $mode);
        } elsif($arg =~ /^#(.*)DIED!/i) {
            $output = &delete_point_list($arg, $p_nick);
            if($output) {
                $output = "${p_nick}: $output のカウンタが削除されました";
                $mode = 1;  # 出力は常にTalk側
            }
        } elsif($arg =~ /^#RENAME!/i) {
            $output = &rename_point_counter($arg, $p_nick);
            if($output ne "1") {
                $output = "${p_nick}: $output";
                $mode = 0;  # 出力は常にPublic側
            }
        } else {
            $output = &set_point_counter($arg, $p_nick, $p_chan, $mode);
            if($output ne "1") {
                $output = "${p_nick}: $output";
            }
        }
    }

    return ($output, $mode);
}

#=========================================================================
#**                           ランダマイザ
#=========================================================================
sub roll {  # ダイスロール
    my($dice_cnt, $dice_max, $dice_sort, $dice_add, $dice_ul, $dice_diff, $dice_re) = @_;
    my $total = 0;
    my $dice_str = "";
    my $cnt1 = 0;
    my $cnt_max = 0;
    my $n_max = 0;
    my $cnt_suc = 0;
    my $d9_on = 0;
    my $cnt_re = 0;
    my @dice_res;

    $dice_add = 0 if(!$dice_add);
    if(($d66_on) && ($dice_max == 66)) {
        $dice_sort = 0;
        $dice_cnt = 2;
        $dice_max = 6;
    }
    if(($game_type eq "Gundog") && ($dice_max == 9)) {
        $d9_on = 1; # ガンドッグのnD9処理
        $dice_max++;
    }
    if(($dice_cnt <= $DICE_MAXCNT) && ($dice_max <= $DICE_MAXNUM)) {
        for(my $i=1; $i <= $dice_cnt ; $i++) {
            my $dice_now = 0;
            my $dice_n = 0;
            my $dice_st_n = "";
            my $round = 0;
            do{
                if($game_type eq "DoubleCross" && $round >= 1) {    # ダブルクロス用出目読み替え
                    $dice_now += 10 - $dice_n;
                }
                $dice_n = int(rand $dice_max) + 1;
                $dice_n-- if($d9_on);
                $dice_now += $dice_n;
                if($modeflg >=2) {
                    $dice_st_n .= "," if($dice_st_n);
                    $dice_st_n .= "${dice_n}";
                }
                $round++;
            } while(($dice_add > 1) && ($dice_n >= $dice_add));
            $total +=  $dice_now;
            if($dice_ul) {
                my $suc = &check_hit($dice_now, $dice_ul, $dice_diff);
                $cnt_suc += $suc;
            }
            if($dice_re) {
                $cnt_re++ if($dice_now >= $dice_re);
            }
            if($modeflg >=2 && $round >= 2) {
                push @dice_res, "${dice_now}[${dice_st_n}]";
            } else {
                push @dice_res, "${dice_now}";
            }
            $cnt1++ if($dice_now == 1);
            $cnt_max++ if($dice_now == $dice_max);
            $n_max = $dice_now if($dice_now > $n_max);
        }
    }
    if($dice_sort) {
        $dice_str = join ",", sort { &dice_num($a) <=> &dice_num($b) } @dice_res;
    } else {
        $dice_str = join ",", @dice_res;
    }
    return ($total, $dice_str, $cnt1, $cnt_max, $n_max, $cnt_suc, $cnt_re);
}
sub dice_num {
    my $dice_str = $_[0];
    $dice_str =~ s/\[[\d,]+\]//;
    return $dice_str;
}

#==========================================================================
#**                            ダイスコマンド処理
#==========================================================================
####################             加算ダイス        ########################
sub dice {  # 加算ダイスロール
    my $dice_cnt = 0;
    my $dice_max = 0;
    my $total_n = 0;
    my $dice_n = 0;
    my $output = "";
    my $ulflg = "";
    my $diff = 0;
    my $n1 = 0;
    my $n_max = 0;
    my $check_on = 0;
    my $string = $_[0];

    if($string =~ /(^|\s)S?(([\d\+\*\-]*[\d]+D[\d]*[\d\+\*\-D]*)(([<>=]+)([?\-\d]+))?)($|\s)/) {
        $string = $2;
        if($4) {
            $ulflg = &cp_f($5);
            $diff = $6;
            $string = $3;
            $check_on = 1;
        }
        my @DICE_A = split(/\+/, $string);
        foreach my $dice_o (@DICE_A) {
            my @DICE_S = split(/-/, $dice_o);
            my $sub_flg = 1;
            foreach my $dice_h (@DICE_S) {
                if($dice_h) {
                    my($dice_now, $dice_n_wk, $dice_str, $n1_wk, $n_max_wk, $cnt_wk, $max_wk) = &dice_mul($dice_h, $check_on);
                    if($dice_now <= 0) {
                        return "1";
                    }
                    $total_n += ($dice_now) * $sub_flg;
                    $dice_n += $dice_n_wk * $sub_flg;
                    $n1 += $n1_wk;
                    $n_max += $n_max_wk;
                    $dice_cnt += $cnt_wk;
                    $dice_max = $max_wk if($max_wk > $dice_max);
                    if($modeflg > 0) {
                        if($sub_flg > 0) {
                            $output .= "+" if($output ne "");
                        } else {
                            $output .= "-";
                        }
                        $output .= "$dice_str";
                    }
                }
                $sub_flg = -1 if($sub_flg > 0);
            }
        }
        if($ulflg ne "") {
            $string .= "$ulflg$diff";
        }
        if($modeflg > 0) {
            if($output =~ /[^\d\[\]]+/) {
                $output = "$_[1]: ($string) ＞ $output ＞ $total_n";
            } else {
                $output = "$_[1]: ($string) ＞ $total_n";
            }
        } else {
            $output = "$_[1]: ($string) ＞ $total_n";
        }
        if($game_type eq "NightmareHunterDeep") {   # D6の6の数分の補正処理
            if($n_max > 0 && $dice_max == 6) {
                $total_n += $n_max * 4;
                $output .= "+".$n_max."*4 ＞ $total_n";
            }
        }
        if($ulflg ne "") {  # 成功度判定処理
            $output .= &check_suc($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max);
        }
        if($game_type eq "NightmareHunterDeep") {   # 宿命表示
            $output .= " ＞ 宿命獲得" if($n1 && $dice_max == 6);
        } elsif($game_type eq "Tunnels & Trolls"){
            $output .= " ＞ 悪意".$n_max if(($n_max > 0) && ($dice_max == 6));
        }elsif($game_type eq "TokumeiTenkousei") { #エキストラパワーポイント獲得
            $output .= " ＞ ".($n1 * 5)."EPP獲得" if($n1 && $dice_max == 6);
        }
        if(($dice_cnt == 0) || ($dice_max == 0)) { $output = '1'; }
        return $output;
    } else {
    return "1";
    }
}
sub dice_mul {  # 加算ダイスロール(個別処理)
    my $dice_max = 0;
    my $string = $_[0];
    my $check_on = $_[1];
    my $dice_total = 1;
    my $dice_n = 0;
    my $output ="";
    my $n1 = 0;
    my $n_max = 0;
    my $dice_cnt_total = 0;
    my $double_check = 0;

    if($double_up){ # 振り足しありのゲームでダイスが二個以上
        if($double_type <= 0){  # 判定のみ振り足し
            $double_check = 1 if($check_on);
        } elsif($double_type <= 1){ # ダメージのみ振り足し
            $double_check = 1 if(! $check_on);
        } else {    # 両方振り足し
            $double_check = 1;
        }
    }
    while($string=~ /(^([\d]+\*[\d]+)\*(.+)|(.+)\*([\d]+\*[\d]+)$|(.+)\*([\d]+\*[\d]+)\*(.+))/) {
        if($2) {
            $string = parren_killer('('.$2.')').'*'.$3;
        }elsif($5) {
            $string = $4.'*'.parren_killer('('.$5.')');
        }elsif($7) {
            $string = $6.'*'.parren_killer('('.$7.')').'*'.$8;
        }
    }
    my @MUL_CMD = split(/\*/, $string);
    foreach my $mul_line (@MUL_CMD) {
        if($mul_line =~ /([\d]+)D([\d]+)/) {
            my $dice_cnt = $1;
            $dice_max = $2;
            if($dice_max > $DICE_MAXNUM) {
                return(0, 0, "", 0, 0, 0, 0);
            }
            my($dice_now, $dice_str, $n1_wk, $n_max_wk);
            $dice_now = $n1_wk = $n_max_wk = 0;
            $dice_str = "";
            my @dice_arr;
            push(@dice_arr,$dice_cnt);
            do {
                my $dice_wk = shift @dice_arr;
                $dice_cnt_total += $dice_wk;
                my @DICE_DAT = &roll($dice_wk, $dice_max, ($sort_flg & 1));
                $dice_now += $DICE_DAT[0];
                $dice_str .= "][" if($dice_str ne "");
                $dice_str .= $DICE_DAT[1];
                $n1_wk += $DICE_DAT[2];
                $n_max_wk += $DICE_DAT[3];
                if($double_check && $dice_wk >= 2) {    # 振り足しありでダイスが二個以上
                    my @dice_num = split(/,/, $DICE_DAT[1]);
                    my @dice_face;
                    for(my $i = 0; $i < $dice_max; $i++){
                        push(@dice_face, 0);
                    }
                    foreach my $dice_o (@dice_num){
                        $dice_face[$dice_o - 1] += 1;
                    }
                    foreach my $dice_o (@dice_face){
                        if($double_up == 1){ # 全部同じ目じゃないと振り足しなし
                            push(@dice_arr, $dice_o) if( $dice_o == $dice_wk );
                        } else {
                            push(@dice_arr, $dice_o) if( $dice_o >= $double_up );
                        }
                    }
                }
            } while(@dice_arr);
            if($game_type eq "CthulhuTech" && $check_on && $dice_max == 10) { # クトゥルフ・テックの判定用ダイス計算
                $dice_now = cthulhutech_check($dice_str);
            }
            $dice_total *= $dice_now;
            $dice_n += $dice_now;
            $n1 += $n1_wk;
            $n_max += $n_max_wk;
            if($output ne "") {
                $output .= "*";
            }
            if($modeflg > 1) {
                    $output .= $dice_now."[$dice_str]";
            } elsif($modeflg > 0) {
                    $output .= "$dice_now";
            }
        } else {
            $dice_total *= ($mul_line);
            if($output ne "") {
                $output .= "*";
            }
            if(($mul_line) < 0) {
                $output .= "($mul_line)";
            } else {
                $output .= "$mul_line";
            }
        }
    }
    return($dice_total, $dice_n, $output, $n1, $n_max, $dice_cnt_total, $dice_max);
}

####################         バラバラダイス       ########################
sub bdice { # 個数判定型ダイスロール
    my $total_n = 0;
    my $suc = 0;
    my $ulflg = "";
    my $diff = 0;
    my $output = "";
    my $string = $_[0];

    $string =~ s/-[\d]+B[\d]+//g;   # バラバラダイスを引き算しようとしているのを除去
    if($string =~ /(^|\s)S?(([\d]+B[\d]+(\+[\d]+B[\d]+)*)(([<>=]+)([\d]+))?)($|\s)/) {
        $string = $2;
        if($5) {
            $ulflg = &cp_f($6);
            $diff = $7;
            $string = $3;
        } elsif($suc_def) {
            if($suc_def =~/([<>=]+)(\d+)/) {
                $ulflg = &cp_f($1);
                $diff = $2;
            }
        }
        my @DICE_A = split(/\+/, $string);
        my $dice_cnt_total = 0;
        my $n1_total = 0;
        foreach my $dice_o (@DICE_A) {
            my ($dice_cnt, $dice_max) = split(/[bB]/, $dice_o);
            my @DICE_DAT = &roll($dice_cnt, $dice_max, ($sort_flg & 2), 0, $ulflg, $diff);
            $suc += $DICE_DAT[5];
            $output .= "," if($output ne "");
            $output .= $DICE_DAT[1];
            $n1_total += $DICE_DAT[2];
            $dice_cnt_total += $dice_cnt;
        }
        if($ulflg ne "") {
            $string .= "$ulflg$diff";
            $output = "$output ＞ 成功数$suc";
            if($game_type eq "ShadowRun4") {    # SR4用グリッチ処理
                if($n1_total >= ($dice_cnt_total / 2)) {    # グリッチ！
                    if($suc) {
                        $output .= ' ＞ グリッチ';
                    } else {
                        $output .= ' ＞ クリティカルグリッチ';
                    }
                }
            }
        }
        $output = "$_[1]: ($string) ＞ $output";
    } else {
        $output = '1';
    }
    return $output;
}

####################        個数振り足しダイス     ########################
sub rdice { # 個数振り足し型ダイスロール
    my($dice_cnt, $dice_max, $round);
    my $total_n = 0;
    my $suc = 0;
    my $ulflg = "";
    my $diff = 0;
    my $output = "";
    my $output2 = "";
    my $string = $_[0];
    my $roll_re = 0;
    my $next_roll = 0;

    $string =~ s/-[\d]+R[\d]+//g;   # 振り足しロールの引き算している部分をカット
    if($string =~ /(^|\s)S?([\d]+R[\d\+R]+)(\[(\d+)\])?(([<>=]+)([\d]+))?(\@(\d+))?($|\s)/) {
        $string = $2;
        if($3) {
            $roll_re = $4;
        } elsif($8) {
            $roll_re = $9;
        } elsif($5) {
            $roll_re = $7;
        } elsif($reroll_n) {
            $roll_re = $reroll_n;
        } else {
            return '条件が間違っています'
        }
        if($5) {
            $ulflg = &cp_f($6);
            $diff = $7;
        } elsif($suc_def) {
            if($suc_def =~/([<>=]+)(\d+)/) {
                $ulflg = &cp_f($1);
                $diff = $2;
            }
        }
        my @DICE_A = split(/\+/, $string);
        my $n1_total = 0;
        my $dice_cnt_total =0;
        foreach my $dice_o (@DICE_A) {
            ($dice_cnt, $dice_max) = split(/[rR]/, $dice_o);
            if(&check_r($dice_max, $ulflg, $diff)) {
                my @DICE_DAT = &roll($dice_cnt, $dice_max, ($sort_flg & 2), 0, $ulflg, $diff, $roll_re);
                $suc += $DICE_DAT[5];
                $output .= "," if($output ne "");
                $output .= $DICE_DAT[1];
                $next_roll += $DICE_DAT[6];
                $n1_total += $DICE_DAT[2];
                $dice_cnt_total += $dice_cnt;
            } else {
                $suc = 0;
                $next_roll = 0;
                $output = '条件が間違っています';
                last;
            }
        }
        $round = 0;
        if($next_roll > 0) {
            $dice_cnt = $next_roll;
            do {
                $output2 .= "$output + ";
                $output = "";
                my @DICE_DAT = &roll($dice_cnt, $dice_max, ($sort_flg & 2), 0, $ulflg, $diff, $roll_re);
                $suc += $DICE_DAT[5];
                $output .= $DICE_DAT[1];
                $round++;
                $dice_cnt_total += $dice_cnt;
                $dice_cnt = $DICE_DAT[6];
            } while (($dice_cnt > 0) && (($round < $reroll_cnt)||(!$reroll_cnt)));
        }

        $output = "$output2$output ＞ 成功数$suc";
        $string .= "[${roll_re}]${ulflg}${diff}";
        if($game_type eq "ShadowRun4") {    # SR4用グリッチ処理
            if($n1_total >= ($dice_cnt_total / 2)) {    # グリッチ！
                if($suc) {
                    $output .= ' ＞ グリッチ';
                } else {
                    $output .= ' ＞ クリティカルグリッチ';
                }
            }
        }
        $output = "$_[1]: ($string) ＞ $output";

        if(length($output) > $SEND_STR_MAX) {   # 長すぎたときの救済
            $output = "$_[1]: ($string) ＞ ... ＞ 回転数${round} ＞ 成功数$suc";
        }
    } else {
        $output = '1';
    }
    return $output;
}
sub check_r {   # 振り足しロールの条件確認
    my $dice_max = $_[0];
    my $ulflg    = $_[1];
    my $diff     = $_[2];
    my $flg = 1;

    if($ulflg eq '<=') {
        $flg = 0 if($diff >= $dice_max);
    } elsif($ulflg eq '>=') {
        $flg = 0 if($diff <= 1);
    } elsif($ulflg eq '<>') {
        $flg = 0 if(($diff > $dice_max)||($diff < 1));
    } elsif($ulflg  eq '<') {
        $flg = 0 if($diff > $dice_max);
    } elsif($ulflg eq '>') {
        $flg = 0 if($diff < 1);
    }
    return $flg;
}

####################          上方無限ダイス      ########################
sub udice { # 上方無限型ダイスロール
    my($dice_cnt, $dice_max, $dice_now, $i, $suc2);
    my($upper, $dice_n, $max, $cnt1, $dice_cnt_a, $dice_add2);
    my $total_n = 0;
    my $suc = 0;
    my $ulflg = "";
    my $diff = 0;
    my $output = "";
    my $max_o = 0;
    my $cnt_o = 0;
    my $dice_add = 0;
    my $string = $_[0];

    $string =~ s/-[sS]?[\d]+[uU][\d]+//g;   # 上方無限の引き算しようとしてる部分をカット
    if($string =~ /(^|\s)[sS]?(\d+[uU][\d\+\-uU]+)(\[(\d+)\])?(([<>=]+)(\d+))?(\@(\d+))?($|\s)/) {
        $string = $2;
        if($5) {
            $ulflg = &cp_f($6);
            $diff = $7;
        }
        if($3) {
            $upper = $4;
        } elsif($8) {
            $upper = $9;
        } else {
            if($upperinf eq "Max") {
                $upper = 2;
            } else {
                $upper = $upperinf;
            }
        }
        if($upper <= 1) {
            $output = "$_[1]: ($string\[$upper\]) ＞ 無限ロールの条件がまちがっています"
        } else {
            my @DICE_A = split(/\+/, $string);
            my (@dice_cmd, @dice_bns);
            foreach my $dice_o (@DICE_A) {
                 if($dice_o =~/[Uu]/) {
                    push @dice_cmd, $dice_o;
                } else {
                    push @dice_bns, $dice_o;
                }
            }
            my $bonus_str = join "+", @dice_bns;
            my $bonus_ttl = 0;
            $bonus_ttl = parren_killer("(".$bonus_str.")") if($bonus_str);
            foreach my $dice_o (@dice_cmd) {
                ($dice_cnt, $dice_max) = split(/[uU]/, $dice_o);
                if($upperinf eq "Max") {
                    $upper = $dice_max;
                }
                my @DICE_DAT = &roll($dice_cnt, $dice_max, ($sort_flg & 2), $upper, $ulflg, $diff - $bonus_ttl);
                $suc += $DICE_DAT[5];
                $output .= "," if($output ne "");
                $output .= $DICE_DAT[1];
                $max_o = $DICE_DAT[4] if($DICE_DAT[4] > $max_o);
                $cnt_o += $DICE_DAT[2];
                $dice_cnt_a += $dice_cnt;
                $dice_add += $DICE_DAT[0];
            }
            if($bonus_ttl) {
                if($bonus_ttl > 0) {
                    $output .= "+${bonus_ttl}";
                } else {
                    $output .= "${bonus_ttl}";
                }
                $max_o += $bonus_ttl;
                $dice_add += $bonus_ttl;
            }
            $string .= "[$upper]";
            if(($max_dice != 0) && ($dice_cnt_a > 1)) {
                $output = "$output ＞ ${max_o}";
            }
            if($ulflg ne "") {
                $output = "$output ＞ 成功数$suc";
                $string .= "$ulflg$diff";
            } else {
                if($game_type eq "DoubleCross") {   # ダブルクロス用
                    if($cnt_o >= $dice_cnt_a) {
                        $output =~ s/[\s]＞[\s][\d]+$//;
                        $output = "$output ＞ ファンブル";
                    }
                } else {
                    $output .= " / ${dice_add}(最大/合計)" if($dice_cnt_a > 1);
                }
            }
            $output = "$_[1]: ($string) ＞ $output";

            if (length($output) > $SEND_STR_MAX) {
                $output ="$_[1]: ($string) ＞ ... ＞ ${max_o}";
                if($ulflg eq "") {
                    $output .= " / ${dice_add}(最大/合計)" if($dice_cnt_a > 1);
                }
            }
        }
    } else {
        $output = '1';
    }
    return $output;
}

####################             DXダイス         ########################
sub dxdice {    # ダブルクロス型個数振り足しダイスロール
    my($dice_cnt, $dice_max, $round);
    my $total_n = 0;
    my $ulflg = "";
    my $diff = 0;
    my $output = "";
    my $output2 = "";
    my $string = $_[0];
    my $roll_re = 0;
    my $next_roll = 0;

    $string =~ s/-[\d]+[rR][\d]+//g;    # 振り足しロールの引き算している部分をカット
    if($string =~ /(^|\s)[sS]?([\d]+[rR][\d\+\-rR]+)(\[(\d+)\])?(([<>=]+)(\d+))?($|\s)/) {
        $string = $2;
        if($3) {
            $roll_re = $4;
        } elsif($reroll_n) {
            $roll_re = $reroll_n;
        } else {
            return '条件が間違っています'
        }
        if($5) {
            $ulflg = &cp_f($6);
            $diff = $7;
        } elsif($suc_def) {
            if($suc_def =~/([<>=]+)(\d+)/) {
                $ulflg = &cp_f($1);
                $diff = $2;
            }
        }
        my @DICE_A = split(/\+/, $string);
        my (@dice_cmd, @dice_bns);
        foreach my $dice_o (@DICE_A) {
             if($dice_o =~/[Rr]/) {
                if($dice_o =~ /-/) {
                    my @dice_wk = split /-/, $dice_o;
                    push @dice_cmd, shift @dice_wk;
                    push @dice_bns, "0-".join "-", @dice_wk;
                } else {
                    push @dice_cmd, $dice_o;
                }
            } else {
                push @dice_bns, $dice_o;
            }
        }
        my $bonus_str = join "+", @dice_bns;
        my $bonus_ttl = 0;
        $bonus_ttl = parren_killer("(".$bonus_str.")") if($bonus_str);
        my $n1_total = 0;
        my $dice_cnt_total =0;
        foreach my $dice_o (@dice_cmd) {
            my $subtotal = 0;
            ($dice_cnt, $dice_max) = split(/[rR]/, $dice_o);
            my @dice_dat = &roll($dice_cnt, $dice_max, ($sort_flg & 2), 0, "", 0, $roll_re);
            $output .= "," if($output ne "");
            $next_roll += $dice_dat[6];
            $n1_total += $dice_dat[2];
            $dice_cnt_total += $dice_cnt;
            if($dice_dat[6] > 0) {  # リロール時の特殊処理
                if($game_type eq "DoubleCross" && $dice_max == 10) {
                    $subtotal = 10;
                } else {            # 特殊処理無し(最大値)
                    $subtotal = $dice_dat[4];
                }
            } else {
                $subtotal = $dice_dat[4];
            }
            $output .= "${subtotal}[${dice_dat[1]}]";
            $total_n += $subtotal;
        }
        $round = 0;
        if($next_roll > 0) {
            $dice_cnt = $next_roll;
            do {
                my $subtotal = 0;
                $output2 .= "$output+";
                $output = "";
                my @dice_dat = &roll($dice_cnt, $dice_max, ($sort_flg & 2), 0, "", 0, $roll_re);
                $round++;
#               $n1_total += $dice_dat[2];
                $dice_cnt_total += $dice_cnt;
                $dice_cnt = $dice_dat[6];
                if($dice_dat[6] > 0) {  # リロール時の特殊処理
                    if($game_type eq "DoubleCross" && $dice_max == 10) {
                        $subtotal = 10;
                    } else {            # 特殊処理無し(最大値)
                        $subtotal = $dice_dat[4];
                    }
                } else {
                    $subtotal = $dice_dat[4];
                }
                $output .= "${subtotal}[${dice_dat[1]}]";
                $total_n += $subtotal;
            } while (($dice_cnt > 0) && (($round < $reroll_cnt)||(!$reroll_cnt)));
        }
        $total_n += $bonus_ttl;
        if($bonus_ttl > 0) {
            $output = "${output2}${output}+${bonus_ttl} ＞ ${total_n}";
        } elsif($bonus_ttl < 0) {
            $output = "${output2}${output}${bonus_ttl} ＞ ${total_n}";
        } else {
            $output = "${output2}${output} ＞ ${total_n}";
        }
        $string .= "[${roll_re}]";
        $string .= "${ulflg}${diff}" if($ulflg ne "");
        $output = "$_[1]: ($string) ＞ $output";
        if(length($output) > $SEND_STR_MAX) {   # 長すぎたときの救済
            $output = "$_[1]: ($string) ＞ ... ＞ 回転数${round} ＞ ${total_n}";
        }
        if($ulflg ne "") {  # 成功度判定処理
            $output .= &check_suc($total_n, 0, $ulflg, $diff, $dice_cnt_total, $dice_max, $n1_total, 0);
        } else {    # 目標値無し判定
            if($round <= 0) {
                if($game_type eq "DoubleCross" && $dice_max == 10) {
                    if($n1_total >= $dice_cnt_total) {
                        $output .= " ＞ ファンブル";
                    }
                }
            }
        }
    } else {
        $output = '1';
    }
    return $output;
}

####################            サタスペ           ########################
sub satasupe_check {
    my $string = $_[0];
    my $output = "";

    if($game_type eq "Satasupe") {
        if($string =~ /(^|\s)((\d+)(S)?R([>=]+)(\d+)(\[(\d+)?(,\d+)?\])?)($|\s)/i) {
            $string = $2;
            my $roll_times = $3;
            my $ulflg = &cp_f($5);
            my $target = $6;
            my $param = $7;
            my $min_suc = 0;
            my $fumble = 1;
            if($param) {
                $param =~ s/(\[|\])//g;
                my @dmy = split /,/, $param;
                if($dmy[0] && ($dmy[0] > 0)) {
                    $min_suc = $dmy[0];
                }
                if($dmy[1] && ($dmy[1] > 1)) {
                    $fumble = $dmy[1];
                }
            }
            my $total_suc = 0;
            my $fumble_flg = 0;
            my $i = 0;
            my $dice_str = "";
            while(($i < $roll_times) && (!$fumble_flg) && (($total_suc < $min_suc) || !$min_suc)) {
                my $d1 = int(rand 6) + 1;
                my $d2 = int(rand 6) + 1;
                if(($d1 == $d2) and ($d1 <= $fumble)) { # ファンブルの確認
                    $fumble_flg = 1;
                }
                my $dice_suc = 0;
                $dice_suc = 1 if($target <= ($d1 + $d2));
                $dice_str .= "+" if($dice_str);
                $dice_str .= "${dice_suc}[${d1},${d2}]";
                $total_suc += $dice_suc;
                $i++;
            }
            $output = "$_[1]: ($string) ＞ $dice_str ＞ 成功度$total_suc";
            if($fumble_flg) {
                $output .= " ＞ ファンブル";
            }
        }
    }

    return $output;
}

####################           Ars Magica          ########################
sub arsmagica_stress {
    my $string = $_[0];
    my $output = "1";

    if($game_type eq "ArsMagica") {
        if($string =~ /(^|\s)(1[rR]10([\+\-\d]*)(\[(\d+)\])?(([>=]+)(\d+))?)(\s|$)/) {
            my $diff = 0;
            my $botch = 1;
            my $bonus = 0;
            my $crit_mul = 1;
            my $total = 0;
            my $ulflg = "";
            $botch = $5 if($4);
            if($6) {
                $ulflg = &cp_f($7);
                $diff = $8;
            }
            $bonus = parren_killer("(0".$3.")") if($3);

            my $die = int(rand 10);
            $output = "($2) ＞ ";
            if($die == 0) { # botch?
                my $count0 = 0;
                my @dice_n;
                for(my $i = 0; $i < $botch; $i++) {
                    my $botch_die = int(rand 10);
                    $count0++ unless($botch_die);
                    push @dice_n, $botch_die;
                }
                @dice_n = sort {$a<=>$b} @dice_n if($sort_flg);
                $output .= "0[$die,".(join ",", @dice_n)."]";
                if($count0) {
                    $bonus = 0;
                    if($count0 > 1) {
                        $output .= " ＞ ${count0}Botch!";
                    } else {
                        $output .= " ＞ Botch!";
                    }
                    $ulflg = "";
                } else {
                    if($bonus > 0) {
                        $output .= "+$bonus ＞ ".$bonus;
                    } elsif($bonus < 0) {
                        $output .= "$bonus ＞ ".$bonus;
                    } else {
                        $output .= " ＞ 0";
                    }
                    $total = $bonus;
                }
            } elsif($die == 1) {    # Crit
                my $crit_dice = "";
                while ($die == 1) {
                    $crit_mul *= 2;
                    $die = int(rand 10) + 1;
                    $crit_dice .= "$die,";
                }
                $total = $die * $crit_mul;
                $crit_dice =~ s/,$//;
                $output .= "$total";
                if($modeflg) {
                    $output .= "[1,$crit_dice]";
                }
                $total = $total + $bonus;
                if($bonus > 0) {
                    $output .= "+$bonus ＞ $total";
                } elsif($bonus < 0) {
                    $output .= "$bonus ＞ $total";
                }
            } else {
                $total = $die + $bonus;
                if($bonus > 0) {
                    $output .= "$die+$bonus ＞ $total";
                } elsif($bonus < 0) {
                    $output .= "$die$bonus ＞ $total";
                } else {
                    $output .= "$total";
                }
            }
            if($ulflg ne "") {  # 成功度判定処理
                $output .= &check_suc($total, 0, $ulflg, $diff, 1, 10, 0, 0);
            }
        }
    }
    return $output;
}

####################   Tunnels and Trolls Berserk  ########################
sub tandt_berserk{
    my $string = $_[0];
    my $output = "1";

    if($game_type eq "Tunnels & Trolls") {
        if($string =~ /(^|\s)((\d+)[rR]6([\+\-\d]*)(\[(\w+)\])?)(\s|$)/) {
            $string = $2;
            my $dice_c = $3;
            my $bonus = 0;
            $bonus = parren_killer("(0".$4.")") if($4);
            my $hyper_flg = 0;
            $hyper_flg = 1 if($5 and ($6 =~ /[Hh]/));
            my @dice_arr;
            my $dice_now = 0;
            my $dice_str = "";
            my $first_r = 1;
            my $n_max = 0;
            my $total_n = 0;
            my $bonus2 = 0;

            # ２回目以降
            push(@dice_arr, $dice_c);
            do {
                my $dice_wk = shift @dice_arr;
                my @DICE_DAT = &roll($dice_wk, 6, ($sort_flg & 1));
                if($dice_wk >= 2) { # ダイスが二個以上
                    my @dice_num = split(/,/, $DICE_DAT[1]);
                    my @dice_face;
                    for(my $i = 0; $i < 6; $i++){
                        push(@dice_face, 0);
                    }
                    foreach my $dice_o (@dice_num){
                        $dice_face[$dice_o - 1] += 1;
                    }
                    foreach my $dice_o (@dice_face){
                        if( $dice_o >= 2 ) {
                            $dice_o++ if($hyper_flg);
                            push(@dice_arr, $dice_o);
                        }
                    }
                    if($first_r and (scalar @dice_arr < 1)) {
                        my $min1 = 0;
                        my $min2 = 0;
                        for(my $i = 5; $i > -1; $i--) {
                            if( $dice_face[$i] > 0 ) {
                                $min2 = $min1;
                                $min1 = $i;
                            }
                        }
                        $bonus2 = -($min2 - $min1);
                        $DICE_DAT[3]-- if($min2 == 5);
                        if($hyper_flg) {
                            push(@dice_arr, 3);
                        } else {
                            push(@dice_arr, 2);
                        }
                    }
                }
                $dice_now += $DICE_DAT[0];
                $dice_str .= "][" if($dice_str ne "");
                $dice_str .= $DICE_DAT[1];
                $n_max += $DICE_DAT[3];
                $first_r = 0;
            } while(@dice_arr);
            $total_n = $dice_now + $bonus + $bonus2;
            $dice_str = "[".$dice_str."]";
            $output = "${dice_now}${dice_str}";
            if($bonus2 < 0) {
                $output .= "${bonus2}";
            }
            if($bonus > 0) {
                $output .= "+${bonus}";
            } elsif($bonus < 0) {
                $output .= "${bonus}";
            }
            if($modeflg > 0) {
                if($output =~ /[^\d\[\]]+/) {
                    $output = "$_[1]: ($string) ＞ $output ＞ $total_n";
                } else {
                    $output = "$_[1]: ($string) ＞ $total_n";
                }
            } else {
                $output = "$_[1]: ($string) ＞ $total_n";
            }
            $output .= " ＞ 悪意".$n_max if(($n_max > 0));
        }
    }
    return $output;
}

####################        その他ダイス関係      ########################
sub open_secret_roll {
    my $s_nick = "\U$_[0]";
    my $s_chan = "\U$_[1]";
    my $mode = $_[2];
    my @msg_arr;

    $s_nick =~ /[_\d]*(.+)[_\d]*/;
    $s_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    $s_chan = "${mode},${s_chan}";
    if(exists $hold_member_list{"${s_chan}"}) {
        my @mem_arr = split /,/, $hold_member_list{"${s_chan}"};
        foreach my $mem (@mem_arr) {
            my $msg1 = $hold_dice{"${s_chan},${mem}"};
            if($msg1) {
                push @msg_arr, $msg1;
                delete $hold_dice{"${s_chan},${mem}"};  # 記録しておいたデータを削除
            }
        }
        delete $hold_member_list{"${s_chan}"} if($mode <= 0);  # 記録しておいたデータを削除
    }
    return @msg_arr;
}

sub add_secret_roll {
    my $s_dice = $_[0];
    my $s_nick = "\U$_[1]";
    my $s_chan = "\U$_[2]";
    my $mode = $_[3];

# まずはチャンネルごとの管理リストに追加
    $s_nick =~ /[_\d]*(.+)[_\d]*/;
    $s_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    $s_chan = "${mode},${s_chan}";
    my $mem_list = $hold_member_list{"${s_chan}"};
    my @new_mem;
    if($mem_list) {
        my @mem_arr = split /,/, $mem_list;
        foreach my $mem (@mem_arr) {
            push @new_mem, $mem if($mem ne $s_nick);
        }
    }
    push @new_mem, $s_nick;
    $hold_member_list{"${s_chan}"} = join ",", @new_mem;

# 次にダイスの出力結果を保存
    $s_dice = "$_[1]: ${s_dice}" if($mode);         # プロットにNickを追加
    $hold_dice{"${s_chan},${s_nick}"} = $s_dice;    # 複数チャンネルも一応想定
}

sub add_plot_channel {
    my $s_nick = "\U$_[0]";
    my $s_chan = "\U$_[1]";

    $s_nick =~ /[_\d]*(.+)[_\d]*/;
    $s_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    $plot_channel{"$s_nick"} = "$s_chan";
}
sub get_plot_channel {
    my $s_nick = "\U$_[0]";
    my $output = "1";

    $s_nick =~ /[_\d]*(.+)[_\d]*/;
    $s_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    if(exists $plot_channel{"${s_nick}"}) {
        $output = $plot_channel{"${s_nick}"};
    }
    return $output;
}

#=========================================================================
#**                     ゲーム固有コマンド処理
#=========================================================================
####################        SWレーティング表       ########################
sub rating {    # レーティング表
    return '1' if(! $game_type =~ /^SwordWorld/i);  # 他ゲーム中の暴発防止
    my($key, $dice, $output, $dice_str, $crit, $key_max);
    my($dicestr_wk, $dice_wk, $dice_add, $rate_wk, $rate_str);
    my(@A, @RATE3, @RATE4, @RATE5, @RATE6, @RATE7, @RATE8, @RATE9, @RATE10, @RATE11, @RATE12, @RATE);

    my $add_p = "";
    my $dec_p = "";
    my $total_n = 0;
    my $round = 0;
    my $string = $_[0];
    if($string =~ /(^|\s)S?((K[\d+-]+)(\[([\d]+)\])?([\d+-]*)(@(\d+))?)($|\s)/) {
        $string = $2;
        if($4) {
            $string = $3.$6;
            $crit = ($5);
            $crit = 3 if($crit < 3);        # エラートラップ(クリティカル値が3未満なら3とする)
        }
        elsif($7) {
            $string = $3.$6;
            $crit = ($8);
            $crit = 3 if($crit < 3);        # エラートラップ(クリティカル値が3未満なら3とする)
        } else { $crit = 10; }              # クリティカル値の未設定はクリティカル値10とする
        if($string =~ /K(\d+)([\d+-]*)/) {  # ボーナスの抽出
            $key = $1;
            $add_p = (parren_killer("(".$2.")")) if($2); 
        }
        else{ $key = $string; }
        $key =~ /([\d]+)/;
        $key = $1;
        if($key eq "") { return '1'; }
        # 2.0対応
        my @RATE_20;
        $RATE_20[0]= '*,0,0,0,1,2,2,3,3,4,4';
        $RATE_20[1]= '*,0,0,0,1,2,3,3,3,4,4';
        $RATE_20[2]= '*,0,0,0,1,2,3,4,4,4,4';
        $RATE_20[3]= '*,0,0,1,1,2,3,4,4,4,5';
        $RATE_20[4]= '*,0,0,1,2,2,3,4,4,5,5';
        $RATE_20[5]= '*,0,1,1,2,2,3,4,5,5,5';
        $RATE_20[6]= '*,0,1,1,2,3,3,4,5,5,5';
        $RATE_20[7]= '*,0,1,1,2,3,4,4,5,5,6';
        $RATE_20[8]= '*,0,1,2,2,3,4,4,5,6,6';
        $RATE_20[9]= '*,0,1,2,3,3,4,4,5,6,7';
        $RATE_20[10]='*,1,1,2,3,3,4,5,5,6,7';

        $RATE_20[11]='*,1,2,2,3,3,4,5,6,6,7';
        $RATE_20[12]='*,1,2,2,3,4,4,5,6,6,7';
        $RATE_20[13]='*,1,2,3,3,4,4,5,6,7,7';
        $RATE_20[14]='*,1,2,3,4,4,4,5,6,7,8';
        $RATE_20[15]='*,1,2,3,4,4,5,5,6,7,8';
        $RATE_20[16]='*,1,2,3,4,4,5,6,7,7,8';
        $RATE_20[17]='*,1,2,3,4,5,5,6,7,7,8';
        $RATE_20[18]='*,1,2,3,4,5,6,6,7,7,8';
        $RATE_20[19]='*,1,2,3,4,5,6,7,7,8,9';
        $RATE_20[20]='*,1,2,3,4,5,6,7,8,9,10';

        $RATE_20[21]='*,1,2,3,4,6,6,7,8,9,10';
        $RATE_20[22]='*,1,2,3,5,6,6,7,8,9,10';
        $RATE_20[23]='*,2,2,3,5,6,7,7,8,9,10';
        $RATE_20[24]='*,2,3,4,5,6,7,7,8,9,10';
        $RATE_20[25]='*,2,3,4,5,6,7,8,8,9,10';
        $RATE_20[26]='*,2,3,4,5,6,8,8,9,9,10';
        $RATE_20[27]='*,2,3,4,6,6,8,8,9,9,10';
        $RATE_20[28]='*,2,3,4,6,6,8,9,9,10,10';
        $RATE_20[29]='*,2,3,4,6,7,8,9,9,10,10';
        $RATE_20[30]='*,2,4,4,6,7,8,9,10,10,10';

        $RATE_20[31]='*,2,4,5,6,7,8,9,10,10,11';
        $RATE_20[32]='*,3,4,5,6,7,8,10,10,10,11';
        $RATE_20[33]='*,3,4,5,6,8,8,10,10,10,11';
        $RATE_20[34]='*,3,4,5,6,8,9,10,10,11,11';
        $RATE_20[35]='*,3,4,5,7,8,9,10,10,11,12';
        $RATE_20[36]='*,3,5,5,7,8,9,10,11,11,12';
        $RATE_20[37]='*,3,5,6,7,8,9,10,11,12,12';
        $RATE_20[38]='*,3,5,6,7,8,10,10,11,12,13';
        $RATE_20[39]='*,4,5,6,7,8,10,11,11,12,13';
        $RATE_20[40]='*,4,5,6,7,9,10,11,11,12,13';

        $RATE_20[41]='*,4,6,6,7,9,10,11,12,12,13';
        $RATE_20[42]='*,4,6,7,7,9,10,11,12,13,13';
        $RATE_20[43]='*,4,6,7,8,9,10,11,12,13,14';
        $RATE_20[44]='*,4,6,7,8,10,10,11,12,13,14';
        $RATE_20[45]='*,4,6,7,9,10,10,11,12,13,14';
        $RATE_20[46]='*,4,6,7,9,10,10,12,13,13,14';
        $RATE_20[47]='*,4,6,7,9,10,11,12,13,13,15';
        $RATE_20[48]='*,4,6,7,9,10,12,12,13,13,15';
        $RATE_20[49]='*,4,6,7,10,10,12,12,13,14,15';
        $RATE_20[50]='*,4,6,8,10,10,12,12,13,15,15';

        $RATE_20[51]='*,5,7,8,10,10,12,12,13,15,15';
        $RATE_20[52]='*,5,7,8,10,11,12,12,13,15,15';
        $RATE_20[53]='*,5,7,9,10,11,12,12,14,15,15';
        $RATE_20[54]='*,5,7,9,10,11,12,13,14,15,16';
        $RATE_20[55]='*,5,7,10,10,11,12,13,14,16,16';
        $RATE_20[56]='*,5,8,10,10,11,12,13,15,16,16';
        $RATE_20[57]='*,5,8,10,11,11,12,13,15,16,17';
        $RATE_20[58]='*,5,8,10,11,12,12,13,15,16,17';
        $RATE_20[59]='*,5,9,10,11,12,12,14,15,16,17';
        $RATE_20[60]='*,5,9,10,11,12,13,14,15,16,18';

        $RATE_20[61]='*,5,9,10,11,12,13,14,16,17,18';
        $RATE_20[62]='*,5,9,10,11,13,13,14,16,17,18';
        $RATE_20[63]='*,5,9,10,11,13,13,15,17,17,18';
        $RATE_20[64]='*,5,9,10,11,13,14,15,17,17,18';
        $RATE_20[65]='*,5,9,10,12,13,14,15,17,18,18';
        $RATE_20[66]='*,5,9,10,12,13,15,15,17,18,19';
        $RATE_20[67]='*,5,9,10,12,13,15,16,17,19,19';
        $RATE_20[68]='*,5,9,10,12,14,15,16,17,19,19';
        $RATE_20[69]='*,5,9,10,12,14,16,16,17,19,19';
        $RATE_20[70]='*,5,9,10,12,14,16,17,18,19,19';

        $RATE_20[71]='*,5,9,10,13,14,16,17,18,19,20';
        $RATE_20[72]='*,5,9,10,13,15,16,17,18,19,20';
        $RATE_20[73]='*,5,9,10,13,15,16,17,19,20,21';
        $RATE_20[74]='*,6,9,10,13,15,16,18,19,20,21';
        $RATE_20[75]='*,6,9,10,13,16,16,18,19,20,21';
        $RATE_20[76]='*,6,9,10,13,16,17,18,19,20,21';
        $RATE_20[77]='*,6,9,10,13,16,17,18,20,21,22';
        $RATE_20[78]='*,6,9,10,13,16,17,19,20,22,23';
        $RATE_20[79]='*,6,9,10,13,16,18,19,20,22,23';
        $RATE_20[80]='*,6,9,10,13,16,18,20,21,22,23';

        $RATE_20[81]='*,6,9,10,13,17,18,20,21,22,23';
        $RATE_20[82]='*,6,9,10,14,17,18,20,21,22,24';
        $RATE_20[83]='*,6,9,11,14,17,18,20,21,23,24';
        $RATE_20[84]='*,6,9,11,14,17,19,20,21,23,24';
        $RATE_20[85]='*,6,9,11,14,17,19,21,22,23,24';
        $RATE_20[86]='*,7,10,11,14,17,19,21,22,23,25';
        $RATE_20[87]='*,7,10,12,14,17,19,21,22,24,25';
        $RATE_20[88]='*,7,10,12,14,18,19,21,22,24,25';
        $RATE_20[89]='*,7,10,12,15,18,19,21,22,24,26';
        $RATE_20[90]='*,7,10,12,15,18,19,21,23,25,26';

        $RATE_20[91] ='*,7,11,13,15,18,19,21,23,25,26';
        $RATE_20[92] ='*,7,11,13,15,18,20,21,23,25,27';
        $RATE_20[93] ='*,8,11,13,15,18,20,22,23,25,27';
        $RATE_20[94] ='*,8,11,13,16,18,20,22,23,25,28';
        $RATE_20[95] ='*,8,11,14,16,18,20,22,23,26,28';
        $RATE_20[96] ='*,8,11,14,16,19,20,22,23,26,28';
        $RATE_20[97] ='*,8,12,14,16,19,20,22,24,26,28';
        $RATE_20[98] ='*,8,12,15,16,19,20,22,24,27,28';
        $RATE_20[99] ='*,8,12,15,17,19,20,22,24,27,29';
        $RATE_20[100]='*,8,12,15,18,19,20,22,24,27,30';

        $key_max = (scalar @RATE_20)-1;
        foreach my $rate_wk (@RATE_20) {
            my @rate_arr = split /,/, $rate_wk;
            push @A, 0;
            push @RATE3, int($rate_arr[1]);
            push @RATE4, int($rate_arr[2]);
            push @RATE5, int($rate_arr[3]);
            push @RATE6, int($rate_arr[4]);
            push @RATE7, int($rate_arr[5]);
            push @RATE8, int($rate_arr[6]);
            push @RATE9, int($rate_arr[7]);
            push @RATE10, int($rate_arr[8]);
            push @RATE11, int($rate_arr[9]);
            push @RATE12, int($rate_arr[10]);
        }
        if($rating_table < 2) {
            $key_max = 50;
            if($rating_table == 1) {
                # 完全版準拠に差し替え
                $RATE12[31] = $RATE12[32] = $RATE12[33] = 10;
            }
        }
        @RATE = (\@A, \@A, \@A, \@RATE3, \@RATE4, \@RATE5, \@RATE6, \@RATE7, \@RATE8, \@RATE9, \@RATE10, \@RATE11, \@RATE12);
        if($key > $key_max) { return "キーナンバーは${key_max}までです"; }
        $output = "$_[1]: KeyNo."."$key";
        $output .= "[$crit]" if($crit < 13);
        if($add_p) {
            $output .= "+${add_p}" if($add_p > 0);
            $output .=  "${add_p}" if($add_p < 0);
        }
        $output .= " ＞ ";

        $dice_wk = "";
        do {
            ($dice, $dice_str) = &roll(2, 6);
            $rate_wk = $RATE[$dice][$key];
            $total_n += $rate_wk;
            $dice_add += $dice;
            if($dice_wk ne "") {
                $dice_wk .= ",$dice";
                $dicestr_wk .= " $dice_str";
                if($dice > 2) {
                    $rate_str .= ",$rate_wk";
                } else {
                    $rate_str .= ",**";
                }
            } else {
                $dice_wk = "$dice";
                $dicestr_wk = "$dice_str";
                if($dice > 2) {
                    $rate_str .= "$rate_wk";
                } else {
                    $rate_str .= "**";
                }
            }
            $round++;
        } while($dice >= $crit);
        if($modeflg > 1) {          # 表示モード２以上
            $output .= "2D:[$dicestr_wk]=$dice_wk ＞ $rate_str";
        } elsif($modeflg > 0) { # 表示モード１以上
            $output .= "2D:$dice_wk ＞ $total_n";
        } else {                    # 表示モード０
            $output .= "$total_n";
        }
        if($dice_add <= 2) {
            return "$output ＞ 自動的失敗";
        }

        if($add_p) {
            $output .= "+${add_p}" if($add_p > 0);
            $output .=  "${add_p}" if($add_p < 0);
            $total_n += $add_p;
            $output .= " ＞ $total_n";
        }
        if ($round > 1) {
            $round--;   # ここでは「回転数=クリティカルの出た数」とする
            $output .= " ＞ ${round}回転";
        }

        if (length($output) > $SEND_STR_MAX) {  # 回りすぎて文字列オーバーフロウしたときの救済
            if($crit < 13) {
                $output = "$_[1]: KeyNo."."$key"."[$crit] ＞ ... ＞ $total_n ＞ ${round}回転";
            } else {
                $output = "$_[1]: KeyNo."."$key"." ＞ ... ＞ $total_n ＞ ${round}回転";
            }
        }
        return $output;
     } else {
        return '1';
     }
}

####################    CHILLストライクランク表    ########################
sub strike_rank {   # Chillのストライクランク
    return '1' if($game_type ne "Chill");   # 他ゲーム中の暴発防止
    my $output = '';
    my $string = $_[0];
    my ($wounds, $sta_loss, $dice, $dice_add, $dice_str);

    if($string =~ /(^|\s)[sS]?(SR|sr)(\d+)($|\s)/) {
        my ($dice_w, $dice_ws, $dice_wa);
        if($3 < 14) {
            ($sta_loss, $dice, $dice_add, $dice_str) = &chill_sr($3);
            ($wounds, $dice_w, $dice_wa, $dice_ws) = &chill_sr($3 - 3);
            $dice = $dice.', '.$dice_w;
            $dice_add .= ', '.$dice_wa;
            $dice_str = $dice_str.', '.$dice_ws;
        } else {
            my $wounds_wk;
            ($sta_loss, $dice, $dice_add, $dice_str) = &chill_sr(13);
            ($wounds, $dice_ws) = &roll(4, 10);
            $dice = '5d10*3, 4d10+'.(($3 - 13) * 2).'d10';
            $dice_add .= ', '.$wounds;
            $dice_str = $dice_str.', '.$dice_ws;
            ($wounds_wk, $dice_ws) = &roll(($3 - 13) * 2, 10);
            $dice_str .= '+'.$dice_ws;
            $dice_add .= '+'.$wounds_wk;
            $wounds += $wounds_wk;
        }
        if($modeflg > 1) {
            $output = $dice_str.' ＞ '.$dice_add.' ＞ スタミナ損失'.$sta_loss.', 負傷'.$wounds;
        }
        elsif($modeflg > 0) {
            $output = $dice_add.' ＞ スタミナ損失'.$sta_loss.', 負傷'.$wounds;
        }
        else {
            $output = 'スタミナ損失'.$sta_loss.', 負傷'.$wounds;
        }
        $string .= ':'.$dice
    }
    if($output) {
        $output = "$_[1]: ($string) ＞ $output";
        return $output;
    } else {
        return "1";
    }
}
sub chill_sr {
    my ($dice, $dice_add, $dice_str, $damage);
    my $sr = $_[0];

    $sr = int($sr);
    if($sr < 1) {
        $damage = 0;
        $dice_str = '-';
        $dice_add = '-';
        $dice = '-';
    }
    elsif($sr < 2) {
        $dice = '0or1';
        ($damage, $dice_str) = &roll(1, 2);
        $damage -= 1;
        $dice_add = $damage;
    }
    elsif($sr < 3) {
        $dice = '1or2';
        ($damage, $dice_str) = &roll(1, 2);
        $dice_add = $damage;
    }
    elsif($sr < 4) {
        $dice = '1d5';
        ($damage, $dice_str) = &roll(1, 5);
        $dice_add = $damage;
    }
    elsif($sr < 10) {
        $dice = ($sr - 3).'d10';
        ($damage, $dice_str) = &roll($sr - 3, 10);
        $dice_add = $damage;
    }
    elsif($sr < 13) {
        $dice = ($sr - 6).'d10*2';
        ($damage, $dice_str) = &roll($sr - 6, 10);
        $dice_add = $damage.'*2';
        $damage = $damage * 2;
        $dice_str = '('.$dice_str.')*2';
    } else {
        $dice = '5d10*3';
        ($damage, $dice_str) = &roll(5, 10);
        $dice_add = $damage.'*3';
        $damage = $damage * 3;
        $dice_str = '('.$dice_str.')*3';
    }
    return($damage,$dice,$dice_add,$dice_str);
}

####################         デモンパ衝動表        ########################
sub dp_urge {   # デモンパラサイトの衝動表
    return '1' if($game_type ne "Demon Parasite");  # 他ゲーム中の暴発防止
    my @URGE;

    my $string = $_[0];
    if($string =~/(\w)?URGE\s*(\d+)/i) {
        my $urge_type;
        my $urgelv = ($2);
        if(!$1) {
            $urge_type = 1;
        } elsif($1 =~ /n/i) {   # 新衝動表
            $urge_type = 2;
        } elsif($1 =~ /a/i) {   # 誤作動表
            $urge_type = 3;
        } elsif($1 =~ /m/i) {   # ミュータント衝動表
            $urge_type = 4;
        } else {    # あり得ない文字
            $urge_type = 1;
        }
        if(($urgelv < 1) || ($urgelv > 5)) {
            return '衝動段階は1から5です';
        } elsif($urge_type) {
            @URGE = &dp_urge_get($urge_type);
            my ($dice_now, $dice_str) = &roll(2, 6);
            my $output = $urgelv.'-'.$dice_now.':'.$URGE[$urgelv - 1][$dice_now - 2];
            if($urge_type <= 1) {
                $output = $_[1].': 衝動表'.$output;
            } elsif($urge_type <= 2) {
                $output = $_[1].': 新衝動表'.$output;
            } elsif($urge_type <= 3) {
                $output = $_[1].': 誤作動表'.$output;
            } else {
                $output = $_[1].': ミュータント衝動表'.$output;
            }
            return $output;
        }
    } else {
        return '1';
    }
}
sub dp_urge_get {
    my(@URGE1, @URGE2, @URGE3, @URGE4, @URGE5, @URGE);
    my $urge_type = $_[0];

    if($urge_type <= 1) {
        @URGE1 = (
            '『怒り』突然強い怒りに駆られる。近くの対象に(非暴力の)怒りを全力でぶつける。このターンの終了まで「行動不能」となる。[経験値20点]',
            '『絶叫』寄生生物が体内で蠢く。その恐怖に絶叫。このターンの終了まで「行動不能」となる。[経験値10点]',
            '『悲哀』急に悲しいことを思い出して動きが止まる。このターンの終了まで「行動不能」となる。[経験値10点]',
            '『微笑』可笑しくてしょうがない。くすくす笑いが止まらず、このターンの終了まで「行動不能」となる。[経験値10点]',
            '『鈍感』衝動に気が付かなかった。何も起こらない。[経験値0点]',
            '『抑制』衝動を抑え込んだ。何も起こらない。[経験値0点]',
            '『我慢』衝動を我慢した。何も起こらない。[経験値0点]',
            '『前兆』悪魔的特徴が一瞬目立つ。１ターン(10秒)持続。変身中なら影響なし。[経験値10点]',
            '『発現』悪魔的特徴が急に目立つ。60ターン(10分)持続。変身中なら影響なし。[経験値10点]',
            '『変化』利き腕/前脚が２ターン(20秒)かけて悪魔化する。18ターン(3分)持続。変身中なら影響なし。[経験値20点]',
            '『顕現』利き腕/前脚が瞬時に悪魔化。60ターン(10分)持続。変身中なら影響なし。[経験値20点]',
            );
        @URGE2 = (
            '『茫然』思考が止まり、このターンの終了まで「攻撃」行動を行えない。回避行動に影響はない。[経験値20点]',
            '『激怒』側にいるもの(生物、物体問わず)が憎く、殴る。変身後ならば次のターンの終了まで、すべての命中判定+5、回避判定-5。[経験値20点]',
            '『残忍』殺意、破壊衝動が一瞬増す。戦闘中ならば次のターンに行われる「攻撃」行動の達成値に+5。[経験値20点]',
            '『落涙』過去の悲しい想い出が去来し、涙が溢れる。１ターン(10秒)「通常」行動を行えない。回避行動に影響はない。[経験値10点]',
            '『抑制』衝動を抑え込んだ。何も起こらない。[経験値0点]',
            '『我慢』衝動を我慢した。何も起こらない。[経験値0点]',
            '『忍耐』肉体を傷つけて衝動に耐えた。５ダメージ。[経験値10点]',
            '『辛抱』ほんの一瞬、全身が変身しかかる。無理に抑えたので、５ダメージ。変身中なら影響なし。[経験値10点]',
            '『異貌』３ターン(30秒)かけて顔が変身する。18ターン(3分)持続。変身中なら影響なし。[経験値20点]',
            '『苦痛』寄生生物が体内で暴れ、痛みにのけぞる。10ダメージ。[経験値20点]',
            '『変貌』変身後の(特異な)外見的特徴が３ターン(30秒)かけて現れる。18ターン(3分)持続。変身中なら影響なし。[経験値20点]',
            );
        @URGE3 = (
            '『憤怒』怒りに全身が満たされる。次のターンの終了まで、すべてのダメージのサイコロを+1個する。[経験値20点]',
            '『加速』ほとばしる衝動により。次のターンは【行動値】が２倍になる。[経験値20点]',
            '『発露』力が溢れ出る。次のターンの終了まで、すべてのダメージに+5、防御点-5(最低0)される。[経験値20点]',
            '『乾き』攻撃衝動を抑えられない。次のターンの終了まで全ての命中判定+5、回避判定-5。[経験値10点]',
            '『絶叫』あらん限りの声で叫ぶ。このターンの終了まで、全ての回避判定に-10。[経験値10点]',
            '『我慢』衝動を我慢した。何も起こらない。[経験値0点]',
            '『限界』衝動を無理矢理抑え込む。あちこちの血管が破裂し、10ダメージ。[経験値10点]',
            '『解放』衝動に耐えられず変身が始まる。３ターン(30秒)かけて変身。変身中なら影響なし。[経験値10点]',
            '『本能』衝動に駆られ、瞬時に変身。次のターン、目の前の動くものを敵味方区別無く攻撃する。[経験値20点]',
            '『保身』次のターンの終了まで、敵を攻撃できない。全ての防御力に+5。[経験値20点]',
            '『救済』悪魔寄生体が危機を察知し、【エナジー】を20点回復する。[経験値20点]',
            );
        @URGE4 = (
            '『癒し』衝動を１点使った回復を行う。[経験値20点]',
            '『離脱』その場から逃げ出す。逃げられない場合は、うずくまって動けなくなる。１ターン(10秒)経過すれば我に返る。[経験値20点]',
            '『脱力』急に力が抜ける。次のターンの終了まで、全ての判定に-5される。[経験値20点]',
            '『全力』激しい躁状態。次のターンの終了まで、命中判定に+10、回避判定に-10[経験値20点]',
            '『混沌』意味のある言葉を話せなくなる。１時間持続する。[経験値10点]',
            '『限界』衝動を無理矢理抑え込む。あちこちの血管が破裂し、10ダメージ。[経験値10点]',
            '『本能』衝動に駆られ、瞬時に変身。次のターン、目の前の動くものを敵味方区別無く攻撃する。[経験値20点]',
            '『焦燥』焦りから「転倒」する。[経験値20点]',
            '『猜疑』味方が急に敵に思える。即座に近くの味方に一回攻撃し、自動命中となる。いなければ影響なし。[経験値20点]',
            '『自虐』自分が許せない。自分へ攻撃(自動命中。ダメ－ジは通常)。[経験値20点]',
            '『自浄』少し我に返る。衝動が２点回復する。[経験値20点]',
            );
        @URGE5 = (
            '『絶望』自殺を試みる。変身中ならば最強の攻撃(特殊能力等を使用しての攻撃)を自分へ与える。[経験値30点]',
            '『賛美』敵(複数いる場合はリーダー格)を主と思いこむ。主が倒されるか、このターンの終了まで主の命令を聞く。[経験値30点]',
            '『拒絶』変身が解除される。変身していなければ影響なし。[経験値20点]',
            '『飢餓』近くの無防備な対象を喰らおうとする。邪魔する物は敵として攻撃する。次ターンの終了時に我に返る。[経験値20点]',
            '『暗闇』視神経に影響が出る。以後１日「暗闇」になる。[経験値20点]',
            '『混乱』意味のある言葉を話せなくなる。１時間持続する。[経験値20点]',
            '『嫉妬』仲間に猛烈な嫉妬を覚える。即座に一番近くの味方を攻撃。判定は自動的に効果的成功となる。いなければ影響なし。[経験値20点]',
            '『暴君』自分が最強に思えてしかたがない。60ターン(10分)攻撃判定の達成値に+10、回避判定の達成値は-10。[経験値20点]',
            '『無双』全力だが無防備。60ターン(10分)、全てのダメージに+10、防御点0、【行動値】0。[経験値20点]',
            '『定着』変身していなければ、即座に変身。肉体が変身に馴染んでしまう。24時間、変身が解除されなくなる。[経験値30点]',
            '『眠り』猛烈な睡魔に襲われる。60ターン(10分)、もしくは戦闘終了まで起こしても起きない。[経験値30点]',
            );
    } elsif($urge_type <= 2) {  # 新衝動表
        @URGE1 = (
            '『開眼』潜在能力が発揮される。10分間、あらゆる戦闘以外の判定に+5。',
            '『集中』感覚が研ぎ澄まされる。次のターンの終了まで、射撃の命中判定に+5。',
            '『迅速』運動神経が上昇する。20分間、戦闘以外の【機敏】判定に+5。',
            '『怪力』怪力を発揮する。20分間、戦闘以外の【肉体】判定に+5。',
            '『鈍感』衝動に気が付かない。何も起こらない。',
            '『抑制』衝動を抑え込む。何も起こらない。',
            '『我慢』衝動を我慢する。何も起こらない。',
            '『無心』冷静になる。20分間、戦闘以外の【精神】判定に+5。',
            '『解放』感覚が解放される。20分間、戦闘以外の【感覚】判定に+5。',
            '『攻撃』攻撃の姿勢を取る。次のターンの終了まで、すべてのダメージが+5。',
            '『防御』防御の姿勢を取る。このターンの終了まで、すべての防御力が+5。',
            );
        @URGE2 = (
            '『敵視』激しい攻撃本能に駆られる。次のターンの終了まで、肉弾ダメージ+10。',
            '『忘我』怒りに痛みを忘れる。エナジー5点回復。',
            '『閃き』頭が冴える。20分間、戦闘以外の【知力】判定に+5。',
            '『全力』筋肉のリミッターが一時的にはずれる。次のターンの終了まで、肉弾ダメージに+5。',
            '『抑制』衝動を抑え込む。何も起こらない。',
            '『我慢』衝動を我慢する。何も起こらない。',
            '『反射』反射神経が研ぎ澄まされる。次のターンの終了まで、射撃の回避判定に+5。',
            '『機転』わずかなチャンスを見逃さなくなる。20分間、戦闘以外の【幸運】判定に+5。',
            '『耐性』精神力が上昇する。次のターンの終了まで、特殊防御力+5。',
            '『怒り』敵に対する怒りにとらわれる。次のターンの終了まで、肉弾の命中判定に+10。',
            '『活発』明るく活発になる。戦闘終了まで【行動値】+5。',
            );
        @URGE3 = (
            '『漲り』体の奥底から力がみなぎってくる。エナジー10点回復。',
            '『分析』相手の動きを冷静に分析できるようになる。5ターンの間、射撃ダメージに+10。',
            '『慈愛』万人に対して慈愛を感じるようになる。5ターンの間、回復に振るダイスが+1d。',
            '『慎重』敵の攻撃に慎重になる。次のターンの終了まで、すべての回避判定に+5。',
            '『本能』攻撃本能がむき出しになる。5ターンの間、特殊の命中判定に+5。',
            '『性急』気が早くなる。次のターンの終了まで、【行動値】に+3',
            '『凶暴』イライラが止まらなくなる。5ターンの間、肉弾の命中判定に+5。',
            '『楽観』気分がリラックスする。エナジー5点回復。',
            '『自閉』自分の殻に閉じこもろうとする。5ターンの間、特殊防御力に+5。',
            '『反射』敵の攻撃に即座に反応できる。5ターンの間、肉弾の回避判定に+10。',
            '『快感』快感を覚える。衝動が1点回復する。',
            );
        @URGE4 = (
            '『情熱』激しい情熱が噴き出してくる。エナジー10点と衝動1点回復。',
            '『気合』体中に気合いが入る。10ターンの間、すべてのダメージに+10。',
            '『加速』体中の神経が加速する。10ターンの間、すべての命中判定に+10。',
            '『利己』考え方が利己的になる。10ターンの間、特殊の命中判定に+10。',
            '『頑強』肉体が鋼のように強くなる。10ターンの間、肉弾防御力に+5。',
            '『察知』相手の動きを察知できる。10ターンの間、射撃防御力に+5。',
            '『殺意』激しい殺意にとらわれる。10ターンの間、特殊ダメージに+10。',
            '『静観』心が落ち着き冷静になる。10ターンの間、射撃の回避判定に+5。',
            '『是空』頭が冴えて敵の行動が読める。10ターンの間、すべての回避判定に+5。',
            '『心眼』心の目で相手の行動を読める。5ターンの間、射撃の回避判定に+10。',
            '『自愛』何をおいても自分が愛しく思える。5ターンの間、特殊の回避判定に+10。',
            );
        @URGE5 = (
            '『神速』人知を超えたスピードに目覚める。戦闘終了まで「通常」行動を２回行えるようになる。',
            '『流水』超感覚に目覚める。10ターンの間、すべての回避判定に+10。',
            '『覚醒』肉体の回復力が限界突破。エナジー20点回復。',
            '『忍耐』あらゆる苦痛に耐える鋼の精神が宿る。10ターンの間、すべての防御力に+5。',
            '『予知』第六感が研ぎ澄まされる。10ターンの間、射撃の命中とダメージに+10。',
            '『豪傑』身体能力が限界を超えて上昇する。10ターンの間、肉弾の命中とダメージに+10。',
            '『殺気』猛烈な殺意がみなぎる。10ターンの間、特殊の命中判定とダメージに+10。',
            '『発動』反射神経が飛躍的に加速される。10ターンの間、【行動値】+10。',
            '『激情』激しい感情があふれ出す。10ターンの間、すべてのダメージに+10。',
            '『超人』運動神経が飛躍的に加速される。10ターンの間、すべての命中判定に+15。',
            '『悟り』心が解放され無我の境地に達する。衝動が３点回復する',
            );
    } elsif($urge_type <= 3) {  # 誤作動表
        @URGE1 = (
            '『緊急停止』機能に異常発生。次のターンの終了まで、「行動不能」になる。[30点]',
            '『動力不調』動力装置に異常発生。このターンの終了時まで、「行動不能」になる。[30点]',
            '『腕部停止』腕部機構に異常発生。このターンの終了時まで、「タイミング：攻撃」が行えない。[20点]',
            '『脚部停止』脚部機構に異常発生。このターンの終了時まで、あらゆる「移動」を行えない。[20点]',
            '『機能制動』機能が一瞬停止するが、影響なし。[10点]',
            '『不良調整』機能に違和感。影響なし。[10点]',
            '『機能安定』機能が安定した。影響なし。[10点]',
            '『機能暴発』直前に使用した《兵装》がこのターンの終了時まで使用不能。未使用なら影響なし。[20点]',
            '『離脱機能』機能の異常発生。行動を消費することなく、即座に敵から「移動(全力)」で離れる。[20点]',
            '『排熱暴走』排熱機能に異常発生。次のターン終了時まで「着火」状態となる。[30点]',
            '『作動予測』次に起きる誤作動を予測できる。「第2限界点」に達したとき、「作動予測」以外の任意の誤作動を選択できる。[30点]',
            );
        @URGE2 = (
            '『安全機能』安全機能が作動。このターンの終了時まで、あらゆる判定に-5。[40点]',
            '『筋肉萎縮』人工筋肉に異常発生。次のターン終了時まで、【肉体】判定に-2。[30点]',
            '『出力低下』駆動部に異常発生。次のターンの終了時まで、【機敏】判定に-2。[30点]',
            '『感覚異常』視界機能に異常発生。次のターンの終了時まで、【感覚】判定に-2。[20点]',
            '『視界不良』視界機能に異常発生。次のターンの終了時まで、【幸運】判定に-2。[20点]',
            '『機能制動』機能が一瞬停止するが、影響なし。[10点]',
            '『不良調整』機能に違和感。影響なし。[10点]',
            '『援護不通』援護ソフトが誤作動。次のターンの終了時まで、【知力】判定-2。[20点]',
            '『発声変調』発声機能に異常発生。次のターンの終了時まで、【精神】判定-2。[30点]',
            '『装甲軟化』防御機構に異常発生。あらゆる防御力に-5。[30点]',
            '『作動予測』次に起きる誤作動を予測できる。「第3限界点」に達したとき、「作動予測」以外の任意の誤作動を選択できる。[40点]',
            );
        @URGE3 = (
            '『動力漏電』動力から漏電。『負荷』が2点上昇。[40点]',
            '『駆動異常』脚部に異常発生。次のターンの終了時まで、「移動」距離半減。[40点]',
            '『足下転倒』バランサーに異常発生。「転倒」状態となる。[30点]',
            '『出力向上』《兵装》機能が向上。次のターンの終了時まで、特殊ダメージに+1d点。[30点]',
            '『機能制動』機能が一瞬停止するが、影響なし。[20点]',
            '『機能暴走』攻撃機能が暴走し、戦闘能力が上昇。「着火」状態になるが、あらゆるダメージに+10。[20点]',
            '『身体向上』格闘機能が向上。次のターンの終了時まで、肉弾ダメージに+1d点。[30点]',
            '『反射向上』反応速度が向上。次のターンの終了時まで、【行動値】が+5。[30点]',
            '『精度向上』標準機能が向上。次のターンの終了時まで、射撃ダメージに+1d点。[30点]',
            '『電子賦活』電磁障壁が突如回復。【電力】が10点回復する。[30点]',
            '『作動予測』次に起きる誤作動を予測できる。「第4限界点」に達したとき、「作動予測」以外の任意の誤作動を選択できる。[40点]',
            );
        @URGE4 = (
            '『照準誤認』照準機能に異常発生。即座に最も近い味方を全力攻撃。[50点]',
            '『攻撃特化』攻撃機能が上昇。次のターン終了時まで、あらゆるダメージに+2dされるが「タイミング：防御」を行えない。[40点]',
            '『機内窒息』呼吸補助機能に異常発生。次のターン終了時まで、「窒息」状態。[40点]',
            '『機能増強』全機能が飛躍的に向上。次のターン終了時まで、《兵装》のコストを払わなくて良い。[30点]',
            '『音声遮断』聴覚機能に異常発生。次のターン終了時まで、一切の物音が聞こえず、あらゆる回避判定に-5。[30点]',
            '『電流加速』電磁障壁が効率的に流れる。『負荷』が1点回復。[20点]',
            '『精密射撃』照準の精度が向上。あらゆるダメージに+5点。[30点]',
            '『電力浪費』電磁障壁が過剰に使用される。【電力】が10点減少。[30点]',
            '『荷電暴走』【電力】を5点消費するが、次のターン終了時まで、あらゆるダメージに+10点。[40点]',
            '『状況分析』視界機能が向上。あらゆる命中判定に+5。[40点]',
            '『作動予測』次に起きる誤作動を予測できる。「第5限界点」に達したとき、「作動予測」以外の任意の誤作動を選択できる。[50点]',
            );
        @URGE5 = (
            '『出力過剰』全出力が過剰。次のターン終了時まで、あらゆるダメージの総計が2倍になるが《兵装》のコストも2倍になる。[50点]',
            '『機関暴走』放熱機能が暴走。自分を中心に半径5m以内すべての対象を「着火」状態にする。[50点]',
            '『機体清冽』機能異常から復帰。「気絶」「死亡」を除く、あらゆる状態変化がすべて消滅。[40点]',
            '『鉄壁装甲』防御機能が向上。次のターン終了時まで、あらゆる防御力に+5。[30点]',
            '『緊急駆動』回避機能が向上。次のターン終了時まで、あらゆる回避判定に+5。[30点]',
            '『出力増大』装備補助機能が向上。次のターン終了時まで、「所持品」あるいは《兵装》を使用したダメージ総計が2倍になる。[30点]',
            '『機体加速』運動機能が暴走。次のターン終了時まで、【行動値】が2倍となる。[30点]',
            '『自動追尾』自動追尾機能が発動。次のターン終了時まで、あらゆる命中値に+5。[40点]',
            '『限定解除』全機能の限界を解除。次のターン終了時まで、あらゆるダメージに+10。[50点]',
            '『負荷軽減』急激に機体の負荷が低下。『負荷』が2点回復する。[50点]',
            '『複合反応』この表を2回振る。ただし、同じ結果が出た場合は適用するのは一度だけ。獲得経験値は累積する。[0点]',
            );
    } else {    # ミュータント衝動表
        @URGE1 = (
            '『怒り』突然強い怒りに駆られる。近くの対象にあたりちらす。このターンの終了まで「行動不能」となる。[20点]',
            '『絶叫』悪魔寄生体が蠢きだす。その恐怖に絶叫。このターンの終了まで「行動不能」となる。[10点]',
            '『悲哀』急に悲しいことを思い出す。このターンの終了まで「行動不能」となる。[10点]',
            '『微笑』可笑しくてしょうがない。くすくす笑いが止まらず、このターンの終了まで「行動不能」となる。[10点]',
            '『鈍感』衝動に気が付かなかった。何も起こらない。[0点]',
            '『抑制』衝動を抑え込んだ。何も起こらない。[0点]',
            '『我慢』衝動を我慢した。何も起こらない。[0点]',
            '『前兆』悪魔的特徴が一瞬目立つ。１ターン(10秒)持続。《擬態変化》を解いているなら影響なし。[10点]',
            '『発現』悪魔的特徴が急に目立つ。60ターン(10分)持続。《擬態変化》を解いているなら影響なし。[10点]',
            '『解除』利き腕/前脚の《擬態変化》が２ターン(20秒)かけて解除される。18ターン(3分)持続。《擬態変化》を解いているなら影響なし。[20点]',
            '『顕現』利き腕/前脚の《擬態変化》が瞬時に解除。60ターン(10分)持続。《擬態変化》を解いているなら影響なし。[20点]',
            );
        @URGE2 = (
            '『茫然』思考が止まり、このターンの終了まで「攻撃」行動を行えない。その他の行動は影響なし。[20点]',
            '『激怒』側にいるもの(生物、物体問わず)が憎くなり、殴る。《擬態変化》を解いているならば次のターンの終了まで、すべての命中判定+5、回避判定-5。[20点]',
            '『残忍』殺意、破壊衝動が一瞬増す。戦闘中ならば次のターンに行われる「攻撃」行動の達成値に+5。[20点]',
            '『落涙』過去の悲しい想い出が去来し、涙が溢れる。１ターン(10秒)「通常」行動を行えない。その他の行動に影響はない。[10点]',
            '『抑制』衝動を抑え込んだ。何も起こらない。[0点]',
            '『我慢』衝動を我慢した。何も起こらない。[0点]',
            '『忍耐』肉体を傷つけて衝動に耐えた。5点ダメージ。[10点]',
            '『辛抱』ほんの一瞬、《擬態変化》が解けかかる。無理に抑えたので5点ダメージ。《擬態変化》を解いているなら影響なし。[10点]',
            '『異貌』３ターン(30秒)かけて《擬態変化》が解除される。18ターン(3分)持続。《擬態変化》を解いているなら影響なし。[20点]',
            '『苦痛』寄生生物が体内で暴れ狂う。10点ダメージ。[20点]',
            '『変貌』特異な外見的特徴が３ターン(30秒)かけて現れる。18ターン(3分)持続。《擬態変化》を解いているなら影響なし。[20点]',
            );
        @URGE3 = (
            '『憤怒』怒りに全身が満たされる。次のターンの終了まで、すべてのダメージを+1d点する。[20点]',
            '『加速』ほとばしる衝動により。次のターンは【行動値】が２倍になる。[20点]',
            '『発露』力が溢れ出る。次のターンの終了まで、すべてのダメージに+5、防御点-5(最低0)される。[20点]',
            '『乾き』攻撃衝動を抑えられない。次のターンの終了まで全ての命中判定+5、回避判定-5。[10点]',
            '『絶叫』あらん限りの声で叫ぶ。このターンの終了まで、あらゆる回避判定に-10。[10点]',
            '『我慢』衝動を我慢した。何も起こらない。[0点]',
            '『限界』衝動を無理矢理抑え込む。10点ダメージ。[10点]',
            '『解放』衝動に耐えられず擬態が解ける。３ターン(30秒)かけて解除。《擬態変化》を解いているなら影響なし。[10点]',
            '『本能』衝動に駆られ、《擬態変化》が瞬時に解除。次のターンは、目の前の動くものを敵味方区別無く攻撃する。[20点]',
            '『保身』次のターンの終了まで、敵を攻撃できない。全ての防御力に+5。[20点]',
            '『救済』悪魔寄生体が危機を察知し、【エナジー】を20点回復する。[20点]',
            );
        @URGE4 = (
            '『癒し』【エナジー】が即座に3d点回復。[20点]',
            '『離脱』その場から逃げ出す。逃げられない場合は、うずくまって動けなくなる。１ターン(10秒)経過すれば我に返る。[20点]',
            '『脱力』急に力が抜ける。次のターンの終了まで、全ての判定に-5される。[20点]',
            '『全力』激しい躁状態。次のターンの終了まで、命中判定に+10、回避判定に-10。[20点]',
            '『混沌』1時間の間、意味のある言葉を話せなくなる。[10点]',
            '『争乱』体内で共生生物同士が争い、暴れ回る。衝動が1点増える。[10点]',
            '『本能』衝動に駆られ、《擬態変化》が瞬時に解除。次のターン、目の前の動くものを敵味方区別無く攻撃する。[20点]',
            '『焦燥』焦りから「転倒」する。[20点]',
            '『猜疑』味方が急に敵に思える。即座に近くの味方に1回攻撃(自動命中。ダメージは通常)。いなければ影響なし。[20点]',
            '『自虐』自分が許せない。自分へ素手攻撃(自動命中。ダメ－ジは通常)。[20点]',
            '『自浄』少し我に返る。衝動が2点回復する。[20点]',
            );
        @URGE5 = (
            '『絶望』無力感にさいなまれる。次のターンの終了時まで「行動不能」となる。[30点]',
            '『眠り』猛烈な睡魔に襲われる。60ターン(10分)、もしくは戦闘終了まで起こしても起きない。[30点]',
            '『誤動』突然《擬態変化》が使用され、人間の姿になる(衝動も通常通り使用する)。既に使用していた場合は変化無し。[20点]',
            '『暗闇』視神経に影響が出る。以後1日「暗闇」になる。[20点]',
            '『再生』共生生物が危機を察知し、【エナジー】を10点回復する。[20点]',
            '『混乱』1時間の間、意味のある言葉を話せなくなる。[20点]',
            '『硬化』急に体が硬直する。このターンの終了時まで、あらゆる命中判定に-10、防御力に+10。[20点]',
            '『暴君』自分が最強に思えてしかたがない。60ターン(10分)攻撃判定に+10、回避判定に-10。[20点]',
            '『無双』全力だが無防備。60ターン(10分)、全てのダメージに+10、防御点と【行動値】は0。[20点]',
            '『喪失』《擬態変化》が使用中なら、即座に解除。さらに24時間、《擬態変化》が使えなくなる。[30点]',
            '『進化』共生生物たちが上手く混じって身体能力が向上する。次の判定の達成値+10。[30点]',
            );
    }
    @URGE = (\@URGE1, \@URGE2, \@URGE3, \@URGE4, \@URGE5);
    return @URGE;
}

####################            WHFRP関連          ########################
sub wh_crit {
    return '1' if($game_type ne "Warhammer"); 
    # クリティカル効果データ
    my @WHH = (
        '01:打撃で状況が把握出来なくなる。次ターンは1回の半アクションしか行なえない。',
        '02:耳を強打された為、耳鳴りが酷く目眩がする。1Rに渡って一切のアクションを行なえない。',
        '03:打撃が頭皮を酷く傷つけた。【武器技術度】に-10%。治療を受けるまで継続。',
        '04:鎧が損傷し当該部位のAP-1。修理するには(職能:鎧鍛冶)テスト。鎧を着けていないなら1Rの間アクションを行なえない。',
        '05:転んで倒れ、頭がくらくらする。1Rに渡ってあらゆるテストに-30で、立ち上がるには起立アクションが必要。',
        '06:1d10R気絶。',
        '07:1d10分気絶。以後CTはサドンデス。',
        '08:顔がずたずたになって倒れ、以後無防備状態。治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。【頑強】テストに失敗すると片方の視力を失う。',
        '09:凄まじい打撃により頭蓋骨が粉砕される。死は瞬時に訪れる。',
        '10:死亡する。いかに盛大に出血し、どのような死に様を見せたのかを説明してもよい。',
        );
    my @WHA = (
        '01:手に握っていたものを落とす。盾はくくりつけられている為、影響なし。',
        '02:打撃で腕が痺れ、1Rの間使えなくなる。',
        '03:手の機能が失われ、治療を受けるまで回復できない。手で握っていたもの(盾を除く)は落ちる。',
        '04:鎧が損傷する。当該部位のAP-1。修理するには(職能:鎧鍛冶)テスト。鎧を着けていないなら腕が痺れ、1Rの間使えなくなる。',
        '05:腕の機能が失われ、治療を受けるまで回復できない。手で握っていたもの(盾を除く)は落ちる。',
        '06:腕が砕かれる。手で握っていたもの(盾を除く)は落ちる。出血がひどく、治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。',
        '07:手首から先が血まみれの残骸と化す。手で握っていたもの(盾を除く)は落ちる。出血がひどく、治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。【頑健】テストに失敗すると手の機能を失う。',
        '08:腕は血まみれの肉塊がぶら下がっている状態になる。手で握っていたもの(盾を除く)は落ちる。治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。【頑健】テストに失敗すると肘から先の機能を失う。',
        '09:大動脈に傷が及んだ。コンマ数秒の内に損傷した肩から血を噴出して倒れる。ショックと失血により、ほぼ即死する。',
        '10:死亡する。いかに盛大に出血し、どのような死に様を見せたのかを説明してもよい。',
        );
    my @WHB = (
        '01:打撃で息が詰まる。1Rの間、キャラクターの全てのテストや攻撃に-20%。',
        '02:股間への一撃。苦痛のあまり、1Rに渡って一切のアクションを行なえない。',
        '03:打撃で肋骨がぐちゃぐちゃになる。以後治療を受けるまでの間、【武器技術度】に-10%。',
        '04:鎧が損傷する。当該部位のAP-1。修理するには(職能:鎧鍛冶)テスト。鎧を着けていないなら股間への一撃、1Rに渡って一切のアクションを行なえない。',
        '05:転んで倒れ、息が詰まって悶絶する。1Rに渡ってあらゆるテストに-30の修正、立ち上がるには起立アクションが必要。',
        '06:1d10R気絶。',
        '07:ひどい内出血が起こり、無防備状態。出血がひどく、治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。',
        '08:脊髄が粉砕されて倒れ、以後治療を受けるまで無防備状態。以後CTはサドンデスを適用。【頑強】テストに失敗すると腰から下が不随になる。',
        '09:凄まじい打撃により複数の臓器が破裂し、死は数秒のうちに訪れる。',
        '10:死亡する。いかに盛大に出血し、どのような死に様を見せたのかを説明してもよい。',
        );
    my @WHL = (
        '01:よろめく。次のターン、1回の半アクションしか行なえない。',
        '02:脚が痺れる。1Rに渡って【移動】は半減し、脚に関連する【敏捷】テストに-20%。回避が出来なくなる。',
        '03:脚の機能が失われ、治療を受けるまで回復しない。【移動】は半減し、脚に関連する【敏捷】テストに-20%。回避が出来なくなる。',
        '04:鎧が損傷する。当該部位のAP-1。修理するには(職能:鎧鍛冶)テスト。鎧を着けていないなら脚が痺れる、1Rに渡って【移動】は半減し、脚に関連する【敏捷】テストに-20%、回避不可になる。',
        '05:転んで倒れ、頭がくらくらする。1Rに渡ってあらゆるテストに-30の修正、立ち上がるには起立アクションが必要。',
        '06:脚が砕かれ、無防備状態。出血がひどく、治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。',
        '07:脚は血まみれの残骸と化し、無防備状態になる。治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。【頑強】テストに失敗すると足首から先を失う。',
        '08:脚は血まみれの肉塊がぶらさがっている状態。以後無防備状態。治療を受けるまで毎Rの被害者のターン開始時に20%で死亡。以後CTはサドンデスを適用。【頑強】テストに失敗すると膝から下を失う。',
        '09:大動脈に傷が及ぶ。コンマ数秒の内に脚の残骸から血を噴出して倒れ、ショックと出血で死は瞬時に訪れる。',
        '10:死亡する。いかに盛大に出血し、どのような死に様を見せたのかを説明してもよい。',
        );
    my @WHW = (
        '01:軽打。1ラウンドに渡って、あらゆるテストに-10％。',
        '02:かすり傷。+10％の【敏捷】テストを行い、失敗なら直ちに高度を1段階失う。地上にいるクリーチャーは、次のターンには飛び立てない。',
        '03:損傷する。【飛行移動力】が2点低下する。-10％の【敏捷】テストを行い、失敗なら直ちに高度を1段階失う。地上にいるクリーチャーは、次のターンには飛び立てない。',
        '04:酷く損傷する。【飛行移動力】が4点低下する。-30％の【敏捷】テストを行い、失敗なら直ちに高度を1段階失う。地上にいるクリーチャーは、1d10ターンが経過するまで飛び立てない。',
        '05:翼が使えなくなる。【飛行移動力】が0に低下する。飛行中のものは落下し、高度に応じたダメージを受ける。地上にいるクリーチャーは、怪我が癒えるまで飛び立てない。',
        '06:翼の付け根に傷が開く。【飛行移動力】が0に低下する。飛行中のものは落下し、高度に応じたダメージを受ける。地上にいるクリーチャーは、怪我が癒えるまで飛び立てない。治療を受けるまで毎R被害者のターン開始時に20％の確率で死亡。以後CTはサドンデスを適用。',
        '07:翼は血まみれの残骸と化し、無防備状態になる。【飛行移動力】が0に低下する。飛行中のものは落下し、高度に応じたダメージを受ける。地上にいるクリーチャーは、怪我が癒えるまで飛び立てない。治療を受けるまで毎R被害者のターン開始時に20％の確率で死亡。以後CTはサドンデスを適用。【頑強】テストに失敗すると飛行能力を失う。',
        '08:翼が千切れてバラバラになり、無防備状態になる。【飛行移動力】が0に低下する。飛行中のものは落下し、高度に応じたダメージを受ける。地上にいるクリーチャーは、怪我が癒えるまで飛び立てない。治療を受けるまで毎R被害者のターン開始時に20％の確率で死亡。以後CTはサドンデスを適用。飛行能力を失う。',
        '09:大動脈が切断された。コンマ数秒の内に血を噴き上げてくずおれる、ショックと出血で死は瞬時に訪れる。',
        '10:死亡する。いかに盛大に出血し、どのような死に様を見せたのかを説明してもよい。',
        );
    my @WHCT = (
         5, 7, 9,10,10,10,10,10,10,10,  #01-10
         5, 6, 8, 9,10,10,10,10,10,10,  #11-20
         4, 6, 8, 9, 9,10,10,10,10,10,  #21-30
         4, 5, 7, 8, 9, 9,10,10,10,10,  #31-40
         3, 5, 7, 8, 8, 9, 9,10,10,10,  #41-50
         3, 4, 6, 7, 8, 8, 9, 9,10,10,  #51-60
         2, 4, 6, 7, 7, 8, 8, 9, 9,10,  #61-70
         2, 3, 5, 6, 7, 7, 8, 8, 9, 9,  #71-80
         1, 3, 5, 6, 6, 7, 7, 8, 8, 9,  #81-90
         1, 2, 4, 5, 6, 6, 7, 7, 8, 8,  #91-00
    );
    # クリティカル表作成終了
    my $string = $_[0];
    my $dst = $_[1];
    my $output = "1";
    if($string =~ /WH([HABTLW])(\d+)/) {
        my $whp = ($1);     #部位
        my $whlv = ($2);    #クリティカル値
        $whlv = 10 if($whlv > 10);
        $whlv = 1 if($whlv < 1);
        my($whpp, @whppp);
        if($whp =~ /H/i) {
            $whpp = '頭部';
            @whppp = @WHH;
        } elsif($whp =~ /A/i) {
            $whpp = '腕部';
            @whppp = @WHA;
        } elsif($whp =~ /[TB]/i) {
            $whpp = '胴体';
            @whppp = @WHB;
        } elsif($whp =~ /L/i) {
            $whpp = '脚部';
            @whppp = @WHL;
        } elsif($whp =~ /W/i) {
            $whpp = '翼部';
            @whppp = @WHW;
        }
        my ($dice_now, $dice_str) = &roll(1, 100);
        my $crit_no = int(($dice_now - 1) / 10) * 10;
        my $crit_num = $WHCT[$crit_no + $whlv - 1];
        $output = $whppp[$crit_num - 1];
        if($crit_num >= 5) {
            $output .= 'サドンデス×'
        } else {
            $output .= 'サドンデス○'
        }
        $output = $dst.":".$whpp.'CT表'."(${dice_now}+${whlv}) ＞ ".$output;
    }
    return "$output";
}
sub wh_atpos {  #WHFRP2命中部位表
    my $pos_num = $_[0];
    my $pos_type = $_[1];
    my @pos_2l = (
        '二足',
        '15','頭部',
        '35','右腕',
        '55','左腕',
        '80','胴体',
        '90','右脚',
        '100','左脚',
    );
    my @pos_2lw = (
        '有翼二足',
        '15','頭部',
        '25','右腕',
        '35','左腕',
        '45','右翼',
        '55','左翼',
        '80','胴体',
        '90','右脚',
        '100','左脚',
    );
    my @pos_4l = (
        '四足',
        '15','頭部',
        '60','胴体',
        '70','右前脚',
        '80','左前脚',
        '90','右後脚',
        '100','左後脚',
    );
    my @pos_4la = (
        '半人四足',
        '10','頭部',
        '20','右腕',
        '30','左腕',
        '60','胴体',
        '70','右前脚',
        '80','左前脚',
        '90','右後脚',
        '100','左後脚',
    );
    my @pos_4lw = (
        '有翼四足',
        '10','頭部',
        '20','右翼',
        '30','左翼',
        '60','胴体',
        '70','右前脚',
        '80','左前脚',
        '90','右後脚',
        '100','左後脚',
    );
    my @pos_b = (
        '鳥',
        '15','頭部',
        '35','右翼',
        '55','左翼',
        '80','胴体',
        '90','右脚',
        '100','左脚',
    );
    my @wh_pos = (\@pos_2l, \@pos_2lw, \@pos_4l, \@pos_4la, \@pos_4lw, \@pos_b);
    my $output = "";
    my $pos_t = 0;
    if($pos_type ne "") {
        if($pos_type =~/\@(2W|W2)/i) {
            $pos_t = 1;
        } elsif($pos_type =~ /\@(4W|W4)/i) {
            $pos_t = 4;
        } elsif($pos_type =~ /\@(4H|H4)/i) {
            $pos_t = 3;
        } elsif($pos_type =~ /\@4/i) {
            $pos_t = 2;
        } elsif($pos_type =~ /\@W/i) {
            $pos_t = 5;
        } elsif(!($pos_type =~ /\@(2H|H2|2)/i)) {
            $pos_t = -1;
        }
    }
    if($pos_t < 0) {
        foreach my $pos_i (@wh_pos) {
            $output .= ' '.${$pos_i}[0].":";
            for(my $i = 1; $i <= scalar @{$pos_i}; $i += 2) {
                if($pos_num <= ${$pos_i}[$i]) {
                    $output .= ${$pos_i}[$i+1];
                    last;
                }
            }
        }
    } else {
        my $pos_i = $wh_pos[$pos_t];
        $output .= ' '.${$pos_i}[0].":";
        for(my $i = 1; $i <= scalar @{$pos_i}; $i += 2) {
            if($pos_num <= ${$pos_i}[$i]) {
                $output .= ${$pos_i}[$i+1];
                last;
            }
        }
    }
    return $output;
}
sub wh_att {
    return '1' if($game_type ne "Warhammer"); 
    my $string = $_[0];
    my $type = "";
    my $output = '1';

    if($string =~/(.+)(@.*)/) {
        $string = $1;
        $type = $2;
    }
    if($string =~ /WH(\d+)/i) {
        my $diff = $1;
        my ($total_n, $dice_dmy) = &roll(1, 100);
        $output = "$_[1]: ($string) ＞ $total_n";
        $output .= &check_suc($total_n, 0, "<=", $diff, 1, 100, 0, $total_n);
        my $pos_num = ($total_n % 10)*10+int($total_n / 10);
        $pos_num = 100 if($total_n >= 100);
        $output .= &wh_atpos($pos_num, $type) if($total_n <= $diff);
    }
    return $output;
}

####################           CthulhuTech         ########################
sub cthulhutech_check { # CthulhuTechの判定用ダイス計算
    my $dice_str = $_[0];
    my @DICE_ARR = split(/,/, $dice_str);
    my @dice_num = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0,);
    my $max_num = 0;

    foreach my $dice_n (@DICE_ARR) {
        $dice_num[($dice_n -1)] += 1;
        $max_num = $dice_n if($dice_n > $max_num);  # 1.個別のダイスの最大値
    }
    if(scalar @DICE_ARR > 1) {  # ダイスが2個以上ロールされている
        for(my $i=0; $i < 10; $i++) {
            if($dice_num[$i] > 1) { # 2.同じ出目の合計値
                my $dice_now = $dice_num[$i] * ($i + 1);
                $max_num = $dice_now if($dice_now > $max_num);
            }
        }
        if(scalar @DICE_ARR > 2) {  # ダイスが3個以上ロールされている
            for(my $i=0; $i < 10; $i++) {
                if($dice_num[$i] > 0) {
                    if($dice_num[$i + 1] > 0 && $dice_num[$i + 2] > 0) {    # 3.連続する出目の合計
                        my $dice_now = $i * 3 + 6;  # ($i+1) + ($i+2) + ($i+3) = $i*3 + 6
                        for(my $i2 = $i + 3; $i2 < 10; $i2++) {
                            if($dice_num[$i2] > 0) {
                                $dice_now += $i2 + 1;
                            } else {
                                last;
                            }
                        }
                        $max_num = $dice_now if($dice_now > $max_num);
                    }
                }
            }
        }
    }
    return $max_num;
}

####################         Call Of Cthulhu        ########################
sub coc_res{    # CoCの抵抗ロール
    my $string = $_[0];
    my $output = "1";

    if($game_type eq "Cthulhu") {
        if($string =~ /res([-\d]+)/i) {
            my $target =  $1 * 5 + 50;
            if($target < 5){    # 自動失敗
                $output = "$_[1]: (1d100<=${target}) ＞ 自動失敗";
            } elsif($target > 95){  # 自動成功
                $output = "$_[1]: (1d100<=${target}) ＞ 自動成功";
            } else {    # 通常判定
                my ($total_n, $dice_dmy) = &roll(1, 100);
                if($total_n <= $target){
                    $output = "$_[1]: (1d100<=${target}) ＞ ${total_n} ＞ 成功";
                } else {
                    $output = "$_[1]: (1d100<=${target}) ＞ ${total_n} ＞ 失敗";
                }
            }
        }
    }
    return $output;
}

####################        ダブルクロス 3rd       ########################
#** 感情表
sub dx_emotion_table {
    my $output = '1';
    if($game_type eq "DoubleCross") {
        my ($pos_dice, $pos_table) = &dx_feel_positive_table;
        my ($neg_dice, $neg_table) = &dx_feel_negative_table;
        my ($dice_now, $dice_dmy) = &roll(1, 2);
        if($pos_table ne '1' and $neg_table ne '1') {
            if($dice_now < 2){
                $pos_table = "○".$pos_table;
            } else {
                $neg_table = "○".$neg_table;
            }
            $output = "$_[0]: 感情表(${pos_dice}-${neg_dice}) ＞ ${pos_table} - ${neg_table}";
        }
    }
    return $output;
}

#** 感情表（ポジティブ）
sub dx_feel_positive_table {
    my @table = (
        [0, '傾倒(けいとう)'],
        [5, '好奇心(こうきしん)'],
        [10, '憧憬(どうけい)'],
        [15, '尊敬(そんけい)'],
        [20, '連帯感(れんたいかん)'],
        [25, '慈愛(じあい)'],
        [30, '感服(かんぷく)'],
        [35, '純愛(じゅんあい)'],
        [40, '友情(ゆうじょう)'],
        [45, '慕情(ぼじょう)'],
        [50, '同情(どうじょう)'],
        [55, '遺志(いし)'],
        [60, '庇護(ひご)'],
        [65, '幸福感(こうふくかん)'],
        [70, '信頼(しんらい)'],
        [75, '執着(しゅうちゃく)'],
        [80, '親近感(しんきんかん)'],
        [85, '誠意(せいい)'],
        [90, '好意(こうい)'],
        [95, '有為(ゆうい)'],
        [100, '尽力(じんりょく)'],
        [101, '懐旧(かいきゅう)'],
        [102, '任意(にんい)'],
        );
    
    return &dx_feel_table( @table );
}

#** 感情表（ネガティブ）
sub dx_feel_negative_table {
    my @table = (
        [0, '侮蔑(ぶべつ)'],
        [5, '食傷(しょくしょう)'],
        [10, '脅威(きょうい)'],
        [15, '嫉妬(しっと)'],
        [20, '悔悟(かいご)'],
        [25, '恐怖(きょうふ)'],
        [30, '不安(ふあん)'],
        [35, '劣等感(れっとうかん)'],
        [40, '疎外感(そがいかん)'],
        [45, '恥辱(ちじょく)'],
        [50, '憐憫(れんびん)'],
        [55, '偏愛(へんあい)'],
        [60, '憎悪(ぞうお)'],
        [65, '隔意(かくい)'],
        [70, '嫌悪(けんお)'],
        [75, '猜疑心(さいぎしん)'],
        [80, '厭気(いやけ)'],
        [85, '不信感(ふしんかん)'],
        [90, '不快感(ふかいかん)'],
        [95, '憤懣(ふんまん)'],
        [100, '敵愾心(てきがいしん)'],
        [101, '無関心(むかんしん)'],
        [102, '任意(にんい)'],
        );
    
    return &dx_feel_table( @table );
}

sub dx_feel_table {
    my @table = @_;
    my $output = '1';

    my ($dice_now, $dice_dmy) = &roll(1, 100);
    foreach my $item_ref (@table) {
        my @item = @$item_ref;
        my $number = $item[0];
        
        if( $number >= $dice_now ) {
            $output = $item[1];
            last;
        }
    }
    
    return ($dice_now, $output);
}

####################           シノビガミ          ########################
#** シーン表
sub sinobigami_scene_table {
    my $string = "\U$_[0]";
    my $nick = $_[1];
    my $output = '1';
    my $type = "";
    my @table = ('1','1','1','1','1','1','1','1','1','1','1',);

    if($game_type eq "ShinobiGami") {
        if($string =~ /CST/i) {
            $type = '都市';
        } elsif($string =~ /MST/i) {
            $type = '館';
        } elsif($string =~ /DST/i) {
            $type = '出島';
        }
        if($type eq '都市') {
            @table = (
                'シャワーを浴び、浴槽に疲れた身体を沈める。時には、癒しも必要だ。',
                '閑静な住宅街。忍びの世とは関係のない日常が広がっているようにも見えるが……それも錯覚なのかもしれない',
                '橋の上にたたずむ。川の対岸を結ぶ境界点。さて、どちらに行くべきか……？',
                '人気のない公園。野良猫が一匹、遠くからあなたを見つめているような気がする。',
                '至福の一杯。この一杯のために生きている……って、いつも言ってるような気がするなぁ。',
                '無機質な感じのするオフィスビル。それは、まるで都市の墓標のようだ。',
                '古びた劇場。照明は落ち、あなたたちのほかに観客の姿は見えないが……。',
                '商店街を歩く。人ごみに混じって、不穏な気配もちらほら感じるが……。',
                'ビルの谷間を飛び移る。この街のどこかに、「アレ」は存在するはずなのだが……。',
                '見知らぬ天井。いつの間にか眠っていたのだろうか？それにしてもここはどこだ？',
                '廃屋。床には乱雑に壊れた調度品や器具が転がっている。',
            );
        } elsif($type eq '館') {
            @table = (
                'どことも知れぬ暗闇の中。忍びの者たちが潜むには、おあつらえ向きの場所である。',
                '洋館の屋根の上。ここからなら、館の周りを一望できるが……。',
                '美しい庭園。丹精こめて育てられたであろう色とりどりの花。そして、綺麗に刈り込まれた生垣が広がっている。',
                'あなたは階段でふと足を止めた。何者かの足音が近づいているようだ。',
                'あなたに割り当てられた寝室。ベッドは柔らかく、調度品も高級なものばかりだが……。',
                'エントランスホール。古い柱時計の時報が響く中、館の主の肖像画が、あなたを見下ろしている。',
                '食堂。染み一つないテーブルクロスに覆われた長い食卓。その上は年代物の燭台や花で飾られている。',
                '長い廊下の途中。この屋敷は広すぎて、迷子になってしまいそうだ。',
                '戯れに遊戯室へ入ってみた。そこには撞球台やダーツの的、何組かのトランプが散らばっているポーカーテーブルがあった。',
                'かび臭い図書室。歴代の館の主たちの記録や、古今東西の名著が、ぎっしりと棚に並べられている。',
                '一族の納骨堂がある。冷気と瘴気に満ちたその場所に、奇妙な叫びが届く。遠くの鳥のさえずりか？それとも死者の恨みの声か……？',
            );
        } elsif($type eq '出島') {
            @table = (
                '迷宮街。いつから囚われてしまったのだろう？何重にも交差し、曲がりくねった道を歩き続ける。このシーンの登場人物は《記憶術》で判定を行わなければならない。成功すると、迷宮の果てで好きな忍具を一つ獲得する。失敗すると、行方不明の変調を受ける。',
                '幻影城。訪れた者の過去や未来の風景を見せる場所。このシーンの登場人物は、《意気》の判定を行うことができる。成功すると、自分の持っている【感情】を好きな何かに変更することができる。',
                '死者たちの行進。無念の死を遂げた者たちが、仲間を求めて彷徨らっている。このシーンの登場人物は《死霊術》で判定を行わなければならない。失敗すると、ランダムに変調を一つを受ける。',
                'スラム。かろうじて生き延びている人たちが肩を寄せ合い生きているようだ。ここなら辛うじて安心できるかも……。',
                '落書きだらけのホテル。その周囲には肌を露出させた女や男たちが、媚態を浮かべながら立ち並んでいる。',
                '立ち並ぶ廃墟。その影から、人とも怪物ともつかぬ者の影が、あなたの様子をじっとうかがっている。',
                '薄汚い路地裏。巨大な黒犬が何かを貪っている。あなたの気配を感じて黒犬は去るが、そこに遺されていたのは……。',
                '昏い酒場。バーテンが無言でグラスを磨き続けている。あなたの他に客の気配はないが……。',
                '地面を覆う無数の瓦礫。その隙間から暗黒の瘴気が立ち昇る。このシーンの登場人物は《生存術》で判定を行わなければならない。失敗すると、好きな【生命力】を１点失う。',
                '熱気溢れる市場。武器や薬物などを売っているようだ。商人たちの中には、渡来人の姿もある。このシーンの登場人物は、《経済力》で判定を行うことができる。成功すると、好きな忍具を一つ獲得できる。',
                '目の前に渡来人が現れる。渡来人はあなたに興味を持ち、襲い掛かってくる。このシーンの登場人物は《刀術》で判定を行わなければならない。成功すると、渡来人を倒し、好きな忍具を一つ獲得する。失敗すると、３点の接近戦ダメージを受ける。',
            );
        } else {
            @table = (
                '血の臭いがあたりに充満している。何者かの戦いがあった気配。　いや？まだ戦いは続いているのだろうか？',
                'これは……夢か？　もう終わったはずの過去。しかし、それを忘れることはできない。',
                '眼下に広がる街並みを眺める。ここからなら街を一望できるが……。',
                '世界の終わりのような暗黒。暗闇の中、お前達は密やかに囁く。',
                '優しい時間が過ぎていく。影の世界のことを忘れてしまいそうだ。',
                '清廉な気配が漂う森の中。鳥の囀りや、そよ風が樹々を通り過ぎる音が聞こえる。',
                '凄まじい人混み。喧噪。影の世界のことを知らない無邪気な人々の手柄話や無駄話が騒がしい。',
                '強い雨が降り出す。人々は、軒を求めて、大慌てて駆けだしていく。',
                '大きな風が吹き荒ぶ。髪の毛や衣服が大きく揺れる。何かが起こりそうな予感……',
                '酔っぱらいの怒号。客引きたちの呼び声。女たちの嬌声。いつもの繁華街の一幕だが。',
                '太陽の微笑みがあなたを包み込む。影の世界の住人には、あまりにまぶしすぎる。',
            );
        }
    }
    my ($total_n, $dice_dmy) = &roll(2, 6);
    my $tn = $total_n - 2;
    $output = "${nick}: ${type}シーン表(${total_n}) ＞ $table[$tn]" if($table[$tn] ne '1');
    return $output;
}
#** ファンブル表
sub sinobigami_fumble_table {
    my $output = '1';
    my @table = ('1','1','1','1','1','1','1','1','1','1','1',);

    if($game_type eq "ShinobiGami") {
    @table = (
        '何か調子がおかしい。そのサイクルの間、すべての行為判定にマイナス１の修正がつく。',
        'しまった！　好きな忍具を１つ失ってしまう。',
        '情報が漏れる！　このゲームであなたが獲得した【秘密】は、他のキャラクター全員の知るところとなる。',
        '油断した！　術の制御に失敗し、好きな【生命力】を１点失う。',
        '敵の陰謀か？　罠にかかり、ランダムに選んだ変調１つを受ける。変調は、変調表で決定すること。',
        'ふう。危ないところだった。特に何も起こらない。',
        );
    }
    my ($total_n, $dice_dmy) = &roll(1, 6);
    my $tn = $total_n - 1;
    $output = "$_[0]: ファンブル表(${total_n}) ＞ $table[$tn]" if($table[$tn] ne '1');
    return $output;
}
#** 感情表
sub sinobigami_emotion_table {
    my $output = '1';
    my @table = ('1','1','1','1','1','1','1','1','1','1','1',);

    if($game_type eq "ShinobiGami") {
    @table = (
        '共感（プラス）／不信（マイナス）',
        '友情（プラス）／怒り（マイナス）',
        '愛情（プラス）／妬み（マイナス）',
        '忠誠（プラス）／侮蔑（マイナス）',
        '憧憬（プラス）／劣等感（マイナス）',
        '狂信（プラス）／殺意（マイナス）',
        );
    }
    my ($total_n, $dice_dmy) = &roll(1, 6);
    my $tn = $total_n - 1;
    $output = "$_[0]: 感情表(${total_n}) ＞ $table[$tn]" if($table[$tn] ne '1');
    return $output;
}
#** 変調表
sub sinobigami_wrong_table {
    my $output = '1';
    my @table = ('1','1','1','1','1','1','1','1','1','1','1',);

    if($game_type eq "ShinobiGami") {
    @table = (
        '故障:すべての忍具が使用不能。１サイクルの終了時に、《絡繰術》で判定を行い、成功するとこの効果は無効化される。',
        'マヒ:修得済み特技がランダムに１つ使用不能になる。１サイクルの終了時に、《身体操術》で成功するとこの効果は無効化される。',
        '重傷:次の自分の手番に行動すると、ランダムな特技分野１つの【生命力】に１点ダメージ。１サイクルの終了時に、《生存術》で成功すると無効化される。',
        '行方不明:その戦闘終了後、メインフェイズ中に行動不可。１サイクルの終了時に、《経済力》で成功すると無効化される。',
        '忘却:修得済み感情がランダムに１つ使用不能。１サイクルの終了時に、《記憶術》で成功すると無効化される。',
        '呪い:修得済み忍法がランダムに１つ使用不能。１サイクルの終了時に、《呪術》で成功すると無効化される。',
        );
    }
    my ($total_n, $dice_dmy) = &roll(1, 6);
    my $tn = $total_n - 1;
    $output = "$_[0]: 変調表(${total_n}) ＞ $table[$tn]" if($table[$tn] ne '1');
    return $output;
}
#** 戦場表
sub sinobigami_battlefield_table {
    my $output = '1';
    my @table = ('1','1','1','1','1','1','1','1','1','1','1',);

    if($game_type eq "ShinobiGami") {
    @table = (
        '平地:特になし。',
        '水中:海や川や、プール、血の池地獄など。この戦場では、回避判定に-2の修正がつく。',
        '高所:ビルの谷間や樹上、断崖絶壁など。この戦場でファンブルすると1点のダメージを受ける。',
        '悪天候:嵐や吹雪、ミサイルの雨など。この戦場では、すべての攻撃忍法の間合が１上昇する。',
        '雑踏:人混みや教室、渋滞中の車道など。この戦場では、行為判定のとき、2D6の目がプロット値+1以下だとファンブルする。',
        '極地:宇宙や深海、溶岩、魔界など。ラウンドの終わりにＧＭが1D6を振り、経過ラウンド以下なら全員1点ダメージ。ここから脱落したものは変調表を適用する。',
        );
    }
    my ($total_n, $dice_dmy) = &roll(1, 6);
    my $tn = $total_n - 1;
    $output = "$_[0]: 戦場表(${total_n}) ＞ $table[$tn]" if($table[$tn] ne '1');
    return $output;
}

####################            サタスペ           ########################
#** シーン表
sub satasupe_table {
    my $string = "\U$_[0]";
    my @output;
    my $counts = 1;
    my $type = "";
    my $name = "";
    if($string =~ /(\D+)(\d*)/) {
        $type = $1;
        $counts = $2 if($2);
    }

    if($game_type eq "Satasupe") {
        #1d6*1d6
        #タグ決定表
        if($type eq "TAGT") {
            my @table = (
                '情報イベント',
                'アブノーマル(サ)',
                'カワイイ(サ)',
                'トンデモ(サ)',
                'マニア(サ)',
                'ヲタク(サ)',
                '音楽(ア)',
                '好きなタグ',
                'トレンド(ア)',
                '読書(ア)',
                'パフォーマンス(ア)',
                '美術(ア)',
                'アラサガシ(マ)',
                'おせっかい(マ)',
                '好きなタグ',
                '家事(マ)',
                'ガリ勉(マ)',
                '健康(マ)',
                'アウトドア(休)',
                '工作(休)',
                'スポーツ(休)',
                '同一タグ',
                'ハイソ(休)',
                '旅行(休)',
                '育成(イ)',
                'サビシガリヤ(イ)',
                'ヒマツブシ(イ)',
                '宗教(イ)',
                '同一タグ',
                'ワビサビ(イ)',
                'アダルト(風)',
                '飲食(風)',
                'ギャンブル(風)',
                'ゴシップ(風)',
                'ファッション(風)',
                '情報ハプニング',
            );
            $name = "タグ決定表:";
            for(my $i = 0; $i < $counts; $i++) {
                my $num1 = int(rand 6);
                my $num2 = int(rand 6);
                push @output, $name.($num1 + 1).($num2 + 1).":".$table[$num1 * 6 + $num2];
            }
        }
        #2d6
        if(! $name) {
            my @table;
            if($type =~ /CrimeIET/i) {
                #情報イベント表／〔犯罪〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '昔やった仕事の依頼人が登場。てがかりをくれる。好きなタグの上位リンク（SL+2）を１つ得る。',
                    '謎のメモを発見……このターゲットについて調べている間、このトピックのタグをチーム全員が所有しているものとして扱う',
                    '謎の動物が亜侠を路地裏に誘う。好きなタグの上位リンクを２つ得る',
                    '偶然、他の亜侠の仕事現場に出くわす。口止め料の代わりに好きなタグの上位リンクを１つ得る',
                    'あまりに適切な諜報活動。コストを消費せず、上位リンクを３つ得る',
                    'その道の権威を紹介される。現在と同じタグの上位リンクを２つ得る',
                    '捜査は足だね。〔肉体点〕を好きなだけ消費する。その値と同じ数の好きなタグの上位リンクを得る',
                    '近所のコンビニで立ち読み。思わぬ情報が手に入る。上位リンクを３つ得る',
                    'そのエリアの支配盟約からメッセンジャーが1D6人。自分のチームがその盟約に敵対していなければ、好きなタグの上位リンクを２つ得る。敵対していれば、メッセンジャーは「盟約戦闘員（p.127）」となる。血戦を行え',
                    '「三下（p.125）」が1D6人現れる。血戦を行え。倒した数だけ、好きなタグの上位リンクを手に入れる',
                );
                $name = "情報イベント表／〔犯罪〕:";
            } elsif($type =~ /LifeIET/i) {
                #情報イベント表／〔生活〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '隣の奥さんと世間話。上位リンクを４つ得る',
                    'ミナミで接待。次の１ターン何もできない代わりに、好きなタグの上位リンク（SL+2）を１つ得る',
                    '息抜きにテレビを見ていたら、たまたまその情報が。好きなタグの上位リンクを１つ得る',
                    '器用に手に入れた情報を転売する。《札巻》を１個手に入れ、上位リンクを３つ得る',
                    '情報を得るついでに軽い営業。〔サイフ〕を１回復させ、上位リンクを３つ得る',
                    '街の有力者からの突然の電話。そのエリアの盟約の幹部NPCの誰かと【コネ】を結ぶことができる',
                    '金をばらまく。〔サイフ〕を好きなだけ消費する。その値と同じ数の任意の上位リンクを得る',
                    '〔表の顔〕の同僚が思いがけないアドバイスをくれる。上位リンクを1D6つ得る',
                    '謎の情報屋チュンさんが、情報とアイテムのトレードを申し出る。DDの指定するアイテムを１つ手に入れると、どこからともなくチュンさんが現れる。そのアイテムをチュンさんに渡せば、情報ゲット！',
                    'ターゲットとは関係ないが、ドデかい情報を掘り当てる。その情報を売って〔サイフ〕が全快する',
                );
                $name = "情報イベント表／〔生活〕:";
            } elsif($type =~ /LoveIET/i) {
                #情報イベント表／〔恋愛〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '恋人との別れ。自分に恋人がいれば、１人を選んで、お互いのトリコ欄から名前を消す。その代わり情報ゲット！',
                    'とびきり美形の情報提供者と遭遇。〔性業値〕判定で律になると、好きなタグの上位リンクを１つ得る',
                    '敵対する亜侠と第一種接近遭遇。キスのあとの濡れた唇から、上位リンクを３つ得る',
                    '昔の恋人がそれに詳しかったはず。その日の深夜・早朝に行動しなければ、好きなタグの上位リンク（SL+2）を１つ得る',
                    '情報はともかくトリコをゲット。データは「女子高生（p.122）」を使用する',
                    '関係者とすてきな時間を過ごす。好きなタグの上位リンクを１つ得る。ただし、次の１ターンは行動できない',
                    '持つべきものは愛の奴隷。自分のトリコの数だけ好きなタグの上位リンクを得る',
                    '自分よりも１０歳年上のイヤなやつに身体を売る。現在と同じタグの上位リンクを１つ得る',
                    '有力者からの突然のご指名。チームの仲間を１人、ランダムに決定する。差し出すなら、そのキャラクターは次の１ターン行動できない代わり、その後にそのキャラクターの〔恋愛〕と同じ数の上位リンクを得る',
                    '愛する人の死。自分に恋人がいれば、１人選んで、そのキャラクターを死亡させる。その代わり情報ゲット！',
                );
                $name = "情報イベント表／〔恋愛〕:";
            } elsif($type =~ /CultureIET/i) {
                #情報イベント表／〔教養〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    'ネットで幻のリンクサイトを発見。すべての種類のタグに上位リンクがはられる',
                    '間違いメールから恋が始まる。ハンドルしか知らない「女子高生（p.122）」と恋人（お互いのトリコ）の関係になる',
                    '新聞社でバックナンバーを読みふける。上位リンクを６つ得る',
                    '巨大な掲示板群から必要な情報をサルベージ。好きなタグの上位リンクを１つ得る',
                    '検索エンジンにかけたらすぐヒット。コストを消費せず、上位リンクを４つ得る',
                    '警察無線を傍受。興味深い。好きなタグの上位リンクを２つ得る',
                    'クールな推理がさえ渡る。〔精神点〕を好きなだけ消費する。その値と同じ数だけ好きなタグの上位リンクを得る',
                    '図書館ロールが貫通。好きなタグの上位リンク（SL+3)を１つ得る',
                    '図書館で幻の書物を発見。上位リンクを８つ得る。キャラクターシートのメモ欄に<クトゥルフ神話知識>、SANと記入し、それぞれ後ろに＋５、－５の数値を書き加える',
                    'アジトに謎の手紙が届く。自分のアジトに戻れば、情報ゲット！',
                );
                $name = "情報イベント表／〔教養〕:";
            } elsif($type =~ /CombatIET/i) {
                #情報イベント表／〔戦闘〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '昔、お前が『更正』させた大幇のチンピラから情報を得る。〔精神点〕を２点減少し、好きなタグの上位リンク（SL+2）を１つ得る。',
                    '大阪市警の刑事から情報リーク。「敵の敵は味方」ということか……？　〔精神点〕を３点減少し、上位リンクを６つ得る。',
                    '無軌道な若者達を拳で『更正』させる。彼等は涙を流しながら情報を差し出した。……情けは人のためならず。好きなだけ〔精神点〕を減少する。減少した値と同じ数だけ、上位リンクを得る。',
                    'クスリ漬けの流氓を拳で『説得』。流氓はゲロと一緒に情報を吐き出した。２点のダメージ（セーブ不可）を受け、好きなタグの上位リンクを１つ得る。',
                    '次から次へと糞どもがやってくる。コストを消費せずに上位リンクを３つ得る。',
                    '自称『善良な一市民』からの情報リークを受ける。オマエの持っている異能の数だけ上位リンクを得る。……罠か！？',
                    'サウナ風呂でくつろぐヤクザから情報収集。ヤクザは歯の折れた口から、弱々しい呻きと共に情報を吐き出した。好きなだけダメージを受ける（セーブ不可）。好きなタグの受けたダメージと同じ値のSLへリンクを１つ得る。',
                    'ゼロ・トレランスオンスロートなラブ＆ウォー。2D6を振り、その値が現在の〔肉体点〕以上であれば、情報をゲット！',
                    'お前達を狙う刺客が冥土の土産に教えてくれる。お前自身かチームの仲間、お前の恋人のいずれかの〔肉体点〕を０点にすれば、情報をゲットできる。',
                    'お前の宿敵（データはブラックアドレス）が1D6体現れる。血戦によって相手を倒せば、情報ゲット。',
                );
                $name = "情報イベント表／〔戦闘〕:";
            } elsif($type =~ /CrimeIHT/i) {
                #情報ハプニング表／〔犯罪〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '警官からの職務質問。一晩拘留される。臭い飯表（p.70）を１回振ること',
                    'だますつもりがだまされる。〔サイフ〕を１点消費',
                    '気のゆるみによる駐車違反。持っている乗物が無くなってしまう',
                    '超えてはならない一線を越える。トラウマを１点受ける',
                    'そのトピックを取りしきる盟約に目をつけられる。このトピックと同じタグのトピックからはリンクをはれなくなる',
                    '過去の亡霊がきみを襲う。自分の修得している異能の中から好きな１つを選ぶ。このセッションでは、その異能が使用不可になる',
                    '敵対する盟約のいざこざに巻き込まれる。〔肉体点〕に1D6点のセーブ不可なダメージを受ける',
                    'スリにあう。〔通常装備〕からランダムにアイテムを１個選び、それを無くす',
                    '敵対する盟約からの妨害工作。この情報は情報収集のルールを使って手に入れることはできなくなる',
                    '頼れる協力者のもとへ行くと、彼（彼女）の無惨な姿が……自分の持っている現在のセッションに参加していないキャラクター１体を選び、〔肉体点〕を０にする。そして、致命傷表(p.61）を振ること',
                );
                $name = "情報ハプニング表／〔犯罪〕:";
            } elsif($type =~ /LifeIHT/i) {
                #情報ハプニング表／〔生活〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '経理の整理に没頭。この日の行動をすべてそれに費やさない限り、このセッションでは買物を行えなくなる',
                    '壮大なる無駄使い。〔サイフ〕を１点消費',
                    '「当たり屋(p.124）」が【追跡】を開始',
                    '留守の間に空き巣が！　〔アジト装備〕からランダムにアイテムが１個無くなる',
                    '「押し売り(p.124）」が【追跡】を開始',
                    '新たな風を感じる。自分の好きな〔趣味〕１つをランダムに変更すること',
                    '貧乏ひまなし。［1D6－自分の〔生活〕］ターンの間、行動できなくなる',
                    '留守の間にアジトが火事に！　〔アジト装備〕がすべて無くなる。明日からどうしよう？',
                    '頼りにしていた有力者が失脚する。しわ寄せがこっちにもきて、〔生活〕が１点減少する',
                    '覚えのない借金の返済を迫られる。〔サイフ〕を1D6点減らす。〔サイフ〕が足りない場合、そのセッション終了時までに不足分を支払わないと【借金大王】(p.119）の代償を得る',
                );
                $name = "情報ハプニング表／〔生活〕:";
            } elsif($type =~ /LoveIHT/i) {
                #情報ハプニング表／〔恋愛〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '一晩を楽しむが相手はちょっと特殊な趣味だった。アブノーマルの趣味を持っていない限り、トラウマを１点受ける。この日はもう行動できない',
                    '一晩を楽しむが相手はちょっと特殊な趣味だった。【両刀使い】の異能を持っていない限り、トラウマを１点受ける。この日はもう行動できない',
                    '一晩を楽しむが相手は年齢を10偽っていた。ロマンス判定のファンブル表を振ること',
                    'すてきな人を見かけ、一目惚れ。DDが選んだNPC１体のトリコになる',
                    '「痴漢・痴女(p.124）」が【追跡】を開始',
                    '手を出した相手が有力者の女（ヒモ）だった。手下どもに袋叩きに会い、1D6点のダメージを受ける（セーブ不可）',
                    '突然の別れ。トリコ欄からランダムに１体を選び、その名前を消す',
                    '乱れた性生活に疲れる。〔肉体点〕と〔精神点〕がともに２点減少する',
                    '性病が伝染る。１日以内に病院に行き、治療（価格４）を行わないと、鼻がもげる。鼻がもげると〔恋愛〕が１点減少する',
                    '生命の誕生。子供ができる',
                );
                $name = "情報ハプニング表／〔恋愛〕:";
            } elsif($type =~ /CultureIHT/i) {
                #情報ハプニング表／〔教養〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    'アヤシイ書物を読み、一時的発狂。この日はもう行動できない。トラウマを１点受ける',
                    '天才ゆえの憂鬱。自分の〔教養〕と同じ値だけ、〔精神点〕を減少させる',
                    '唐突に睡魔が。次から２ターンの間、睡眠しなくてはならない',
                    '間違いメールから恋が始まる。ハンドルしか知らない「女子高生（p.122）」に偽装した「殺人鬼（p.137）」と恋人（お互いのトリコ）の関係になる',
                    '「勧誘員(p.124）」が【追跡】を開始',
                    'OSの不調。徹夜で再インストール。この日はもう行動できない上、「無理」をしてしまう',
                    '場を荒らしてしまう。このトピックと同じタグのトピックからはリンクをはれなくなる',
                    'ボケる。〔教養〕が１点減少する',
                    'クラッキングに遭う。いままで調べていたトピックとリンクをすべて失う',
                    'ネットサーフィンにハマってしまい、ついつい時間が過ぎる。毎ターンのはじめに〔性業値〕判定を行い、律にならないとそのターンは行動できない。この効果は１日続く',
                );
                $name = "情報ハプニング表／〔教養〕:";
            } elsif($type =~ /CombatIHT/i) {
                #情報ハプニング表／〔戦闘〕
                @table = (
                    '謎の情報屋チュンさん登場。ターゲットとなる情報を渡し、いずこかへ去る。情報ゲット！',
                    '悪を憎む心に支配され、一匹の修羅と化す。キジルシの代償から１種類を選び、このセッションの間、習得すること。修得できるキジルシの代償がなければ、あなたはNPCとなる。',
                    '自宅に帰ると、無惨に破壊された君のおたからが転がっていた。「この件から手を引け」という書き置きと共に……。この情報フェイズでは、リンク判定を行ったトピックのタグの〔趣味〕を修得していた場合、それを未修得にする。また、おたからを持っていたなら、このセッション中、そのおたからは利用できなくなる。',
                    '「俺にはもっと別の人生があったんじゃないだろうか……！？」突如、空しさがこみ上げて来る……その日は各ターンの始めに〔性業値〕判定を行う。失敗すると、酒に溺れ、そのターンは行動済みになる。',
                    'クライムファイター仲間からスパイの容疑を受ける……１点のトラウマを追う。',
                    '自宅の扉にメモが……！！　「今ならまだ間に合う」奴等はどこまで知っているんだ！？　このトピックからは、これ以上リンクを伸ばせなくなる。',
                    '大幇とコンビナートの抗争に何故か巻き込まれる。……なんとか生還するが、次のターンの最後まで行動できず、1D6点のダメージを受ける（セーブ不可）',
                    '地獄組の鉄砲玉が君に襲い掛かってきた！！　〔戦闘〕で難易度９の判定に失敗すると、〔肉体点〕が０になる。',
                    '「お前はやり過ぎた」の書きおきと共に、友人の死体が発見される〔戦闘〕で難易度９の判定を行う。失敗すると、ランダムに選んだチームの仲間１人が死亡する。',
                    '宿敵によって深い疵を受ける。自分の修得している異能の中から、１つ選ぶこと。このセッションのあいだ、その異能を使用することができなくなる。',
                    '流氓の男の卑劣な罠にかかり、肥え喰らいの巣に落ちる！！　「掃き溜めの悪魔」1D6体と血戦を行う。戦いに勝たない限り、生きて帰ることはできないだろう……。もちろん血戦に勝ったところで情報は得られない。',
                );
                $name = "情報ハプニング表／〔戦闘〕:";
            } elsif($type =~ /G(eneral)?A(ccident)?T/i) {
                #汎用アクシデント表
                @table = (
                    '痛恨のミス。激しく状況が悪化する。以降のケチャップに関する行為判定の難易度に＋１の修正がつき、あなたが追う側なら逃げる側のコマを２マス進める（逃げる側なら自分を２マス戻す）',
                    '最悪の大事故。ケチャップどころではない！　〔犯罪〕で難易度９の判定を行う。失敗したら、ムーブ判定を行ったキャラクターは3D6天のダメージを受け、ケチャップから脱落する。判定に成功すればギリギリ難を逃れる。特に何もなし。',
                    'もうダメだ……。絶望感が襲いかかってくる。後３ラウンド以内にケリをつけないと、あなたが追う側なら自動的に逃げる側が勝利する（逃げる側なら追う側が勝利する）',
                    'まずい、突発事故だ！　ムーブ判定を行ったキャラクターは、1D6点のダメージを受ける。',
                    '一瞬ひやりと緊張が走る。　ムーブ判定を行ったキャラクターは、〔精神点〕を２点減少する。',
                    'スランプ！　思わず足踏みしてしまう。ムーブ判定を行った者は、ムーブ判定に使用した能力値を使って難易度７の判定を行うこと。失敗したら、ムーブ判定を行ったキャラクターは、ケチャップから脱落。成功しても、あなたが追う側なら逃げる側のコマを１マス進める（逃げる側なら自分を１マス戻す）',
                    'イマイチ集中できない。〔性業値〕判定を行うこと。「激」になると、思わず見とれてしまう。あなたが追う側なら逃げる側のコマを１マス進める（逃げる側なら自分を１マス戻す）',
                    '古傷が痛み出す。以降のケチャップに関する行為判定に修正が＋１つく',
                    'うっかり持ち物を見失う。〔通常装備〕欄からアイテムを１個選んで消す',
                    '苦しい状態に追い込まれた。ムーブ判定を行ったキャラクターは、今後のムーブ判定で成功度が－１される。',
                    '頭の中が真っ白になる。〔精神点〕を1D6減少する。',
                );
                $name = "汎用アクシデント表:";
            } elsif($type =~ /R(omance)?F(umble)?T/i) {
                #ロマンスファンブル表
                @table = (
                    'みんなあいそをつかす。自分のトリコ欄のキャラクターの名前をすべて消すこと',
                    '痴漢として通報される。〔犯罪〕の難易度９の判定に成功しない限り、1D6ターン後に検挙されてしまう',
                    'へんにつきまとわれる。対象は、トリコになるが、ファンブル表の結果やトリコと分かれる判定に成功しない限り、常備化しなくてもトリコ欄から消えることはない',
                    '修羅場！　対象とは別にトリコを所有していれば、そのキャラクターが現れ、あなたと対象に血戦をしかけてくる',
                    '恋に疲れる。自分の〔精神点〕が1D6点減少する',
                    '甘い罠。あなたが対象のトリコになってしまう',
                    '平手うち！　自分の〔肉体点〕が1D6点減少する',
                    '浮気がばれる。恋人関係にあるトリコがいれば、そのキャラクターの名前をあなたのトリコ欄から消す',
                    '無礼な失言をしてしまう。対象はあなたに対し「憎悪（p.120参照）」の反応を抱き、あなたはその対象の名前を書き込んだ【仇敵】の代償を得る',
                    'ショックな一言。トラウマを１点受ける',
                    'トリコからの監視！　このセッションの間、ロマンス判定のファンブル率が自分のトリコの所持数と同じだけ上昇する',
                );
                $name = "ロマンスファンブル表:";
            } elsif($type =~ /FumbleT/i) {
                #命中判定ファンブル表
                @table = (
                    '自分の持ち物がすっぽぬけ、偶然敵を直撃！　持っているアイテムを１つ消し、ジオラマ上にいるキャラクター１人をランダムに選ぶ。そのキャラクターの〔肉体点〕を1D6ラウンドの間０点にし、行動不能にさせる（致命傷表は使用しない）。1D6ラウンドが経過し、行動不能から回復すると、そのキャラクターの〔肉体点〕は、行動不能になる直前の値にまで回復する',
                    '敵の増援！　「三下(p.125）」が1D6体現れて、自分たちに襲いかかってくる（DDは、この処理が面倒だと思ったら、ファンブルしたキャラクターの〔肉体点〕を1D6点減少させてもよい）',
                    'お前のいるマスに「障害物」が出現！　そのマスに障害物オブジェクトを置き、そのマスにいたキャラクターは全員２ダメージを受ける（セーブ不可）',
                    '射撃武器を使っていれば、弾切れを起こす。準備行動を行わないとその武器はもう使えない',
                    '転んでしまう。準備行動を行わないと移動フェイズに行動できず、格闘、射撃、突撃攻撃が行えない',
                    '急に命が惜しくなる。性業値判定をすること。「激」なら戦闘を続行。「律」なら次のラウンドから全力移動を行い、ジオラマから逃走を試みる。「迷」なら次のラウンドは移動・攻撃フェイズに行動できない',
                    '誤って別の目標を攻撃。目標以外であなたに一番近いキャラクターに４ダメージ（セーブ不可）！',
                    '誤って自分を攻撃。３ダメージ（セーブ不可）！',
                    '今使っている武器が壊れる。アイテム欄から使用中の武器を消すこと。銃器を使っていた場合、暴発して自分に６ダメージ！　武器なしの場合、体を傷つけ３ダメージ（共にセーブ不可）！',
                    '「制服警官(p.129）」が１人現れる。その場にいるキャラクターをランダムに攻撃する',
                    '最悪の事態。〔肉体点〕を０にして、そのキャラクターは行動不能に（致命傷表は使用しない）',
                );
                $name = "命中判定ファンブル表:";
            } elsif($type =~ /FatalT/i) {
                #致命傷表（別名１４番表）
                @table = (
                    '死亡。',
                    '死亡。',
                    '昏睡して行動不能。1D6ラウンド以内に治療し、〔肉体点〕を１以上にしないと死亡。',
                    '昏睡して行動不能。1D6ターン以内に治療し、〔肉体点〕を１以上にしないと死亡。',
                    '大怪我で行動不能。体の部位のどこかを欠損してしまう。任意の〔能力値〕１つが１点減少。',
                    '大怪我で行動不能。1D6ターン以内に治療し、〔肉体点〕を１以上にしないと体の部位のどこかを欠損してしまう。任意の〔能力値〕１つが１点減少。',
                    '気絶して行動不能。〔肉体点〕の回復には治療が必要。',
                    '気絶して行動不能。１ターン後、〔肉体点〕が１になる。',
                    '気絶して行動不能。1D6ラウンド後、〔肉体点〕が１になる。',
                    '気絶して行動不能。1D6ラウンド後、〔肉体点〕が1D6回復する。',
                    '奇跡的に無傷。さきほどのダメージを無効に。',
                );
                $name = "致命傷表:";
            } elsif($type =~ /AccidentT/i) {
                #アクシデント表
                @table = (
                    'ゴミか何かが降ってきて、視界を塞ぐ。以降のケチャップに関する判定に修正が＋１つく。あなたが追う側なら逃げる側のコマを２マス進める（逃げる側なら自分を２マス戻す）',
                    '対向車線の車（もしくは他の船、飛行機）に激突しそうになる。運転手は難易度９の〔精神〕の判定を行うこと。失敗したら、乗物と乗組員全員は3D6のダメージを受けた上に、ケチャップから脱落',
                    'ヤバイ、ガソリンがもうない！　後３ラウンド以内にケリをつけないと逃げられ（追いつかれ）ちまう',
                    '露店や消火栓につっこむ。その乗物に1D6ダメージ',
                    '一瞬ひやりと緊張が走る。〔精神点〕を２点減らす',
                    '何かの障害物に衝突する。運転手は難易度７の〔精神〕の判定を行うこと。失敗したら、乗物と乗組員全員は2D6ダメージを受けた上に、ケチャップから脱落。成功しても、あなたが追う側なら逃げる側のコマを１マス進める（逃げる側なら自分を１マス戻す）',
                    '走ってる途中に〔趣味〕に関する何かが目に映る。性業値判定を行うこと。「激」になると思わず見とれてしまう。あなたが追う側なら逃げる側のコマを１マス進める（逃げる側なら自分を１マス戻す）',
                    '軽い故障が起きちまった。以降のケチャップに関する行為判定に修正が＋１つく',
                    'うっかり落し物。〔通常装備〕欄からアイテムを１個選んで消す',
                    'あやうく人にぶつかりそうになる。運転手は難易度９の〔精神〕の判定を行う。失敗したら、その一般人を殺してしまう。あなたが追う側なら逃げる側のコマを１マス進める（逃げる側なら自分を１マス戻す）',
                    '信号を無視しちまったら後ろで事故が起きた。警察のサイレンが鳴り響いてくる。DDはケチャップの最後尾に警察の乗物を加えろ。データは「制服警官（p.129）」のものを使用',
                );
                $name = "アクシデント表:";
            } elsif($type =~ /AfterT/i) {
                #その後表
                @table = (
                    'ここらが潮時かもしれない。2D6を振り、その目が自分の修得している代償未満であれば、そのキャラクターは引退し、二度と使用できない',
                    '苦労の数だけ喜びもある。2D6を振り、自分の代償の数以下の目を出した場合、経験点が追加で１点もらえる',
                    '妙な恨みを買ってしまった。【仇敵】（p.95）を修得する。誰が【仇敵】になるかは、DDが今回登場したNPCの中から１人を選ぶ',
                    '大物の覚えがめでたい。今回のセッションに登場した盟約へ入るための条件を満たしていれば、その盟約に経験点の消費なしで入ることができる',
                    '思わず意気投合。今回登場したNPC１人を選び、そのキャラクターとの【コネ】（p.95）を修得する',
                    '今回の事件で様々な教訓を得る。自分の修得しているアドバンスドカルマの中から、汎用以外のものを好きなだけ選ぶ。そのカルマの異能と代償を、別な異能と代償に変更することができる',
                    '深まるチームの絆。今回のセッションでミッションが成功していた場合、【絆】（p.95）を修得する',
                    '色々な運命を感じる。今回のセッションでトリコができていた場合、経験点の消費なしにそのトリコを常備化することができる。また、自分が誰かのトリコになっていた場合、その人物への【トリコ】(p.95）の代償を得る',
                    'やっぱり亜侠も楽じゃないかも。今回のセッションで何かツラい目にあっていた場合、【日常】（p.95）を取得する',
                    'くそっ！　ここから出せ！！　今回のセッションで逮捕されていたら、【前科】(p.95）の代償を得る',
                    '〔性業値〕が１以下、もしくは１３以上だった場合、そのキャラクターは大阪の闇に消える。そのキャラクターは引退し、二度と使用できない',
                );
                $name = "その後表:";
            }
            if($name) {
                for(my $i = 0; $i < $counts; $i++) {
                    my($dice, $dummy) = &roll(2, 6);
                    push @output, $name.$dice.":".$table[$dice - 2];
                }
            }
        }

        #1d6
        if($type eq "NPCT") {
            #好み／雰囲気表
            my @lmood = (
                'ダークな',
                'お金持ちな',
                '美形な',
                '知的な',
                'ワイルドな',
                'バランスがとれてる',
            );
            #好み／年齢表
            my @lage = (
                '年下が好き。',
                '同い年が好き。',
                '年上が好き。',
            );
            #年齢表
            my @age = (
                '幼年', #6+2D6歳
                '少年', #10+2D6歳
                '青年', #15+3D6歳
                '中年', #25+4D6歳
                '壮年', #40+5D6歳
                '老年', #60+6D6歳
            );
            my @agen = (
                '6+2D6',  #幼年
                '10+2D6', #少年
                '15+3D6', #青年
                '25+4D6', #中年
                '40+5D6', #壮年
                '60+6D6', #老年
            );
            $name = "NPC表:";
            for(my $i = 0; $i < $counts; $i++) {
                my $age_type = int(rand 6);
                my @age_num = split /\+/, $agen[$age_type];
                my ($total, $dummy) = &dice_mul($age_num[1]);
                my $ysold = $total + $age_num[0];
                push @output, $name.$age[$age_type]."(".$ysold."):".$lmood[int(rand 6)].$lage[int(rand 3)];
            }
        }
    }
    return @output;
}

#==========================================================================
#**                            その他の機能
#==========================================================================
sub choise_random {
    my $string = $_[0];
    my $output = "1";

    if($string =~ /(^|\s)((S)?choise\[([\w,]+)\])($|\s)/i) {
        $string = $2;
        if($4) {
            my @elem_arr = split /,/, $4;
            $output = "$_[1]: (${string}) ＞ ".$elem_arr[int(rand scalar @elem_arr)];
        }
    }
    return $output;
}

#==========================================================================
#**                            結果判定関連
#==========================================================================
sub cp_f {  # 不等号の整列
    my $ulflg = $_[0];

    if($ulflg =~ /(<=|=<)/) {
        $ulflg = "<=";
    } elsif($ulflg =~ /(>=|=>)/) {
        $ulflg = ">=";
    } elsif($ulflg =~ /(<>)/) {
        $ulflg = "<>";
    } elsif($ulflg =~ /[<]+/) {
        $ulflg = "<";
    } elsif($ulflg =~ /[>]+/) {
        $ulflg = ">";
    } elsif($ulflg =~ /[=]+/) {
        $ulflg = "=";
    }
    return $ulflg;
}
sub check_hit { # 成功数判定用
    my $dice_now = $_[0];
    my $ulflg    = $_[1];
    my $diff     = $_[2];
    my $suc = 0;

    if($ulflg =~ /(<=|=<)/) {
        if($dice_now <= $diff) {
            $suc++;
        }
    } elsif($ulflg =~ /(>=|=>)/) {
        if($dice_now >= $diff) {
            $suc++;
        }
    } elsif($ulflg =~ /(<>)/) {
        if($dice_now != $diff) {
            $suc++;
        }
    } elsif($ulflg =~ /[<]+/) {
        if($dice_now < $diff) {
            $suc++;
        }
    } elsif($ulflg =~ /[>]+/) {
        if($dice_now > $diff) {
            $suc++;
        }
    } elsif($ulflg =~ /[=]+/) {
        if($dice_now == $diff) {
            $suc++;
        }
    }
    return($suc);
}

####################       ゲーム別成功度判定      ########################
sub check_suc { # ゲーム別成功度判定
    my @check_param = @_ ;
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @check_param;
    my $output = "";

    if($total_n =~ /([\d]+)[)]?$/) {
        $total_n = $1;
        if($game_type ne "") {  # 成功判定処理
            if(($dice_max == 100) && ($dice_cnt == 1)) {    # 1D100判定
                $output = check_1D100(@check_param);
            } elsif(($dice_max == 20) && ($dice_cnt == 1)) {    # 1d20判定
                $output = check_1D20(@check_param);
            } elsif($dice_max == 10) {  # d10ベース判定
                $output = check_nD10(@check_param);
            } elsif($dice_max == 6) {   # d6ベース判定
                if($dice_cnt == 2) {    # 2d6判定
                    $output = check_2D6(@check_param);
                }
                if($output eq "") { # xD6判定
                    $output = check_nD6(@check_param);
                }
            }
        }

        if(($output eq "") && ($ulflg ne "")) { # どれでもないけど判定するとき
            $output = check_nDx(@check_param);
        }
    }
    return $output;
}
sub check_1D100 {   # ゲーム別成功度判定(1d100)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if(($game_type eq "Cthulhu") && ($ulflg eq "<=")) {
        if(($total_n <= $diff) && ($total_n < 100)) {
            if($total_n <= 5) {
                $output .= " ＞ 決定的成功";
                if($total_n <= ($diff / 5)) {
                    $output .= "/スペシャル";
                }
            } elsif($total_n <= ($diff / 5)) {
                $output .= " ＞ スペシャル";
            } else {
                $output .= " ＞ 成功";
            }
        } elsif(($total_n >= 96) && ($diff < 100)) {
            $output .= " ＞ 致命的失敗";
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "Hieizan") && ($ulflg eq "<=")) {
        if($total_n <= 1) { # 1は自動成功
            if($total_n <= ($diff / 5)) {
                $output .= " ＞ 大成功";    # 大成功 > 自動成功
            } else {
                $output .= " ＞ 自動成功";
            }
        } elsif(($total_n >= 100)) {
            $output .= " ＞ 大失敗";    # 00は大失敗(大失敗は自動失敗でもある)
        } elsif(($total_n >= 96)) {
            $output .= " ＞ 自動失敗";  # 96-00は自動失敗
        } else {
            if(($total_n <= $diff)) {
                if($total_n <= ($diff / 5)) {
                    $output .= " ＞ 大成功";    # 目標値の1/5以下は大成功
                } else {
                    $output .= " ＞ 成功";
                }
            } else {
                $output .= " ＞ 失敗";
            }
        }
    } elsif(($game_type eq "Elric!") && ($ulflg eq "<=")) {
        if($total_n <= 1) { # 1は常に貫通
            $output .= " ＞ 貫通";
        } elsif($total_n >= 100) {  # 100は常に致命的失敗
            $output .= " ＞ 致命的失敗";
        } elsif($total_n <= ($diff / 5 + 0.9)) {
            $output .= " ＞ 決定的成功";
        } elsif($total_n <= $diff) {
            $output .= " ＞ 成功";
        } elsif(($total_n >= 99) && ($diff < 100)) {
            $output .= " ＞ 致命的失敗";
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "RuneQuest") && ($ulflg eq "<=")) {
        if(($total_n <= 1) || ($total_n <= ($diff / 20 + 0.5))) {   # 1は常に決定的成功
            $output .= " ＞ 決定的成功";
        } elsif($total_n >= 100) {  # 100は常に致命的失敗
            $output .= " ＞ 致命的失敗";
        } elsif($total_n <= ($diff / 5 + 0.5)) {
            $output .= " ＞ 効果的成功";
        } elsif($total_n <= $diff) {
            $output .= " ＞ 成功";
        } elsif($total_n >= (95 + ($diff / 20 + 0.5))) {
            $output .= " ＞ 致命的失敗";
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "Chill") && ($ulflg eq "<=")) {
        if($total_n >= 100) {
            $output .= " ＞ ファンブル"
        } elsif($total_n <= $diff) {
            if($total_n >= ($diff * 0.9)) {
                $output .= " ＞ Ｌ成功";
            } elsif($total_n >= ($diff / 2)) {
                $output .= " ＞ Ｍ成功";
            } elsif($total_n >= ($diff / 10)) {
                $output .= " ＞ Ｈ成功";
            } else {
                $output .= " ＞ Ｃ成功";
            }
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "Gundog") && ($ulflg eq "<=")) {
        if($total_n >= 100) {
            $output .= " ＞ ファンブル"
        } elsif($total_n <= 1) {
            $output .= " ＞ 絶対成功(達成値1+SL)"
        } elsif($total_n <= $diff) {
            my $dig10 = int($total_n / 10);
            my $dig1 = ($total_n) - $dig10 * 10;
            $dig10 = 0 if($dig10 >= 10);
            $dig1 = 0 if($dig1 >= 10);  # 条件的にはあり得ない(笑
            if($dig1 <= 0) {
                $output .= " ＞ クリティカル(達成値20+SL)";
            } else {
                $output .= " ＞ 成功(達成値".($dig10 + $dig1)."+SL)";
            }
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "Warhammer") && ($ulflg eq "<=")) {
        if($total_n <= $diff) {
            $output .= ' ＞ 成功(成功度'.int(($diff - $total_n)/10).')';
        } else {
            $output .= ' ＞ 失敗(失敗度'.int(($total_n - $diff)/10).')';
        }
    }
    return $output;
}
sub check_1D20 {    # ゲーム別成功度判定(1d20)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if(($game_type eq "Pendragon") && ($ulflg eq "<=")) {
        if($total_n <= $diff) {
            if(($total_n >= (40 - $diff)) || ($total_n == $diff)) {
                $output .= " ＞ クリティカル";
            } else {
                $output .= " ＞ 成功";
            }
        } else {
            if($total_n == 20) {
                $output .= " ＞ ファンブル";
            } else {
                $output .= " ＞ 失敗";
            }
        }
    } elsif(($game_type eq "Infinite Fantasia") && ($ulflg eq "<=")) {
        if($total_n <= $diff) {
            if($total_n <= ($diff / 32)) {
                $output .= " ＞ 32レベル成功(32Lv+)";
            } elsif($total_n <= ($diff / 16)) {
                $output .= " ＞ 16レベル成功(16LV+)";
            } elsif($total_n <= ($diff / 8)) {
                $output .= " ＞ 8レベル成功";
            } elsif($total_n <= ($diff / 4)) {
                $output .= " ＞ 4レベル成功";
            } elsif($total_n <= ($diff / 2)) {
                $output .= " ＞ 2レベル成功";
            } else {
                $output .= " ＞ 1レベル成功";
            }
            if($total_n <= 1) {
                $output .= "/クリティカル";
            }
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif(($game_type eq "PhantasmAdventure") && ($ulflg eq "<=")) {
        # 技能値の修正を計算する
        my $skill_mod = 0;
        if($diff < 1) {
            $skill_mod = $diff - 1;
        } elsif($diff > 20) {
            $skill_mod = $diff - 20;
        }
        my $fumble = 20 + $skill_mod;
        $fumble = 20 if($fumble > 20);
        my $critical = 1 + $skill_mod;
        my ($dice_now, $dice_str) = &roll(1, 20);
        if($total_n >= $fumble || $total_n >= 20) {
            my $fum_num = $dice_now - $skill_mod;
            $fum_num = 20 if($fum_num > 20);
            $fum_num = 1 if($fum_num < 1);
            if($modeflg > 1) {
                my $fum_str = "${dice_now}";
                if($skill_mod < 0) {
                    $fum_str .= "+".-$skill_mod."=${fum_num}";
                } else {
                    $fum_str .= "-${skill_mod}=${fum_num}";
                }
                $output .= " ＞ 致命的失敗(".$fum_str.")";
            } else {
                $output .= " ＞ 致命的失敗(".$fum_num.")";
            }
        } elsif($total_n <= $critical || $total_n <= 1) {
            my $crit_num = $dice_now + $skill_mod;
            $crit_num = 20 if($crit_num > 20);
            $crit_num = 1 if($crit_num < 1);
            if($skill_mod < 0) {
                $output .= " ＞ 成功";
            } else {
                if($modeflg > 1) {
                    $output .= " ＞ 決定的成功(${dice_now}+${skill_mod}=".$crit_num.")";
                } else {
                    $output .= " ＞ 決定的成功(".$crit_num.")";
                }
            }
        } elsif($total_n <= $diff) {
            $output .= " ＞ 成功";
        } else {
            $output .= " ＞ 失敗";
        }
    }
    return $output;
}
sub check_1D10 {    # ゲーム別成功度判定(1D10)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if($game_type eq "ArsMagica") {
        if($ulflg eq ">=") {
            if($total_n >= $diff) {
                $output .= " ＞ 成功";
            } else {
                $output .= " ＞ 失敗";
            }
        }
    }
    return $output;
}
sub check_nD10 {    # ゲーム別成功度判定(nD10)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if($game_type eq "CthulhuTech") {
        if($ulflg eq ">=") {    # 通常のテスト
            if($n1 >= int($dice_cnt / 2 + 0.9)) {
                $output .= " ＞ ファンブル";
            } elsif($total_n >= $diff) {
                if($total_n >= $diff + 10) {
                    $output .= " ＞ クリティカル";
                } else {
                    $output .= " ＞ 成功";
                }
            } else {
                $output .= " ＞ 失敗";
            }
        }
        if($ulflg eq ">") { # コンバットテスト
            if($n1 >= int($dice_cnt / 2 + 0.9)) {
                $output .= " ＞ ファンブル";
            } elsif($total_n > $diff) {
                if($total_n >= $diff + 10) {
                    $output .= " ＞ クリティカル";
                } else {
                    $output .= " ＞ 成功";
                }
                my $damage_dice = int(($total_n - $diff) / 5 + 0.9);
                $output .= "(${damage_dice}d10)";   # ダメージダイスの表示
            } else {
                $output .= " ＞ 失敗";
            }
        }
    } elsif($game_type eq "DoubleCross" && $ulflg eq ">=") {
        if($n1 >= $dice_cnt) {
            $output .= " ＞ ファンブル";
        } elsif($total_n >= $diff) {
            $output .= " ＞ 成功";
        } else {
            $output .= " ＞ 失敗";
        }
    } elsif($game_type eq "ArsMagica") {
        if($ulflg eq ">=") {
            if($total_n >= $diff) {
                $output .= " ＞ 成功";
            } else {
                $output .= " ＞ 失敗";
            }
        }
    }
    return $output;
}
sub check_2D6 { # ゲーム別成功度判定(2D6)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if($game_type =~ /^SwordWorld/i) {
        if($dice_n >= 12) {
            $output .= " ＞ 自動的成功";
        } elsif($dice_n <=2) {
            $output .= " ＞ 自動的失敗";
        } elsif($ulflg eq ">=") {
            if($diff ne "?") {
                if($total_n >= $diff) {
                    $output .= " ＞ 成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        }
    } elsif($game_type eq "Chaos Flare") {
        if($ulflg eq ">=") {
            if($total_n >= $diff) {
                $output .= " ＞ 成功";
                if($total_n > $diff) {
                    $output .= " ＞ 差分値".int($total_n-$diff);
                }
            } else {
                $output .= " ＞ 失敗";
            }
        }
    } elsif($game_type eq "WARPS") {
        if($dice_n <= 2) {
            $output .= " ＞ クリティカル";
        } elsif($dice_n >= 12) {
            $output .= " ＞ ファンブル";
        } elsif($ulflg eq "<=") {
            if($diff ne "?") {
                if($total_n <= $diff) {
                    $output .= " ＞ ".int($diff-$total_n)."成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        }
    } elsif($game_type eq "Tunnels & Trolls") {
        if($ulflg eq ">=") {
            if($dice_n == 3) {
                $output .= " ＞ 自動失敗";
            } elsif($diff eq "?") {
                my $sucLv = 1;
                while($total_n >= $sucLv*5+15) { $sucLv += 1; }
                $sucLv -= 1;
                if($sucLv <= 0) {
                    $output .= " ＞ 失敗 ＞ 経験値".(1 * $dice_n);
                } else {
                    $output .= " ＞ ".$sucLv."Lv成功 ＞ 経験値".(1 * $dice_n);
                }
            } elsif($total_n >= $diff) {
                $output .= " ＞ 成功 ＞ 経験値".(($diff-15)/5*$dice_n);
            } else {
                $output .= " ＞ 失敗";
            }
        }
    } elsif($game_type eq "ShinobiGami") {
        if($ulflg eq ">=") {
            if($dice_n <= 2) {
                $output .= " ＞ ファンブル";
            } elsif($dice_n >= 12) {
                $output .= " ＞ スペシャル(生命点1点か変調1つ回復)";
            } elsif($total_n >= $diff) {
                $output .= " ＞ 成功";
            } else {
                $output .= " ＞ 失敗";
            }
        }
    }
    return $output;
}
sub check_nD6 { # ゲーム別成功度判定(nD6)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    if($game_type eq "Arianrhod") {
        if($n1 >= $dice_cnt) {  # 全部１の目ならファンブル
            $output .= " ＞ ファンブル";
        } elsif($n_max >= 2) {  # ２個以上６の目があったらクリティカル
            $output .= " ＞ クリティカル(+" . "$n_max" . "D6)";
        } elsif($ulflg eq ">=") {
            if($diff ne "?") {
                if($total_n >= $diff) {
                    $output .= " ＞ 成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        }
    }
    elsif($game_type eq "Demon Parasite") {
        if($n1 >= 2) {  # １の目が２個以上ならファンブル
            $output .= " ＞ 致命的失敗";
        } elsif($n_max >= 2) {  # ６の目が２個以上あったらクリティカル
            $output .= " ＞ 効果的成功";
        } elsif($ulflg eq ">=") {
            if($diff ne "?") {
                if($total_n >= $diff) {
                    $output .= " ＞ 成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        } elsif($ulflg eq ">") {
            if($diff ne "?") {
                if($total_n > $diff) {
                    $output .= " ＞ 成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        }
    }
    elsif($game_type eq "NightmareHunterDeep") {
        if($ulflg eq ">=") {
            if($diff eq "?") {
                my $sucLv = 1;
                my $sucNL = 0;
                while($total_n >= $sucLv*5-1) { $sucLv += 1; }
                while($total_n >= $sucNL*5+5) { $sucNL += 1; }
                $sucLv -= 1;
                $sucNL -= 1;
                if($sucLv <= 0) {
                    $output .= " ＞ 失敗";
                } else {
                    $output .= " ＞ Lv".$sucLv."/NL".$sucNL."成功";
                }
            } elsif($total_n >= $diff) {
                $output .= " ＞ 成功";
            } else {
                $output .= " ＞ 失敗";
            }
        }
    }
    elsif($game_type eq "TokumeiTenkousei") {
        if($ulflg eq ">=") {
            if($diff ne "?") {
                if($total_n >= $diff) {
                    $output .= " ＞ 成功";
                } else {
                    $output .= " ＞ 失敗";
                }
            }
        }
    }
    return $output;
}
sub check_nDx { # ゲーム別成功度判定(ダイスごちゃ混ぜ系)
    my($total_n, $dice_n, $ulflg, $diff, $dice_cnt, $dice_max, $n1, $n_max) = @_ ;
    my $output = "";

    my($suc) = &check_hit($total_n, $ulflg, $diff);
    if($suc >= 1) {
        $output .= " ＞ 成功";
    } else {
        $output .= " ＞ 失敗";
    }
    return $output;
}

#=========================================================================
#**                       汎用ポイントカウンタ
#=========================================================================

####################          カウンタ操作         ########################
sub set_point_counter {
    my $cmd = "\U$_[0]";
    my $p_nick = "\U$_[1]";
    my $p_chan = "\U$_[2]";
    my $mode = $_[3];   # 0=通常 1=シークレット
    my $output = '1';
    my $pc = "";

    $p_nick =~ /[_\d]*(.+)[_\d]*/;
    $p_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    if($cmd =~ /^#((\w+?[:：])?\w+?)[\s]*([\+\-\/\d]+)/){
        my $target = $1;
        my $point = $3;
        if($2) {
            ($pc, $target) = split /[:：]/, $target;
        } else {
            $pc = $p_nick;
        }
        if($point =~ /^[\+\-]/) {   # ポイント操作
            my $bonus = parren_killer("(0".$point.")");
            for(my $i = 0; $i <= 1; $i++) {
                if(exists $point_counter{"${p_nick},${pc},${target},$i"}) {
                    my $pre_point = $point_counter{"${p_nick},${pc},${target},$i"};
                    my $current_point = 0;
                    if($pre_point =~ /(\d+)[\/](\d+)/) {    # 現在値/最大値型
                        $current_point = ($1 + $bonus)."/".$2;
                    } else {    # 現在値型
                        $current_point = $pre_point + $bonus;
                    }
                    $point_counter{"${p_nick},${pc},${target},$i"} = $current_point;
                    $output = "(${target}) ${pre_point} -> ${current_point}";
                    $output = "\L\u${pc}"."${output}" if($pc ne $p_nick);
                    last;
                }
            }
        } else {    # ポイント登録
            if(!exists $point_counter{"${p_nick},${pc},${target},${mode}"}) {
                &add_plot_channel($p_nick, $p_chan) if(&get_plot_channel($p_nick) eq "1");
            }
            $point_counter{"${p_nick},${pc},${target},${mode}"} = $point;
            my $another_point = "${p_nick},${pc},${target},".($mode + 1) % 2;
            if(exists $point_counter{$another_point}) {
                delete $point_counter{$another_point};
            }
            &set_point_tree("${p_nick},${pc},${target}");
            my @new_mem;
            my $mem_list = $point_counter{"$p_chan"};
            if($mem_list) { # 既にチャンネルのユーザリストがある
                my @mem_arr = split /,/, $mem_list;
                foreach my $mem (@mem_arr) {
                    push @new_mem, $mem if($mem ne $p_nick);
                }
            }
            push @new_mem, $p_nick;
            $point_counter{"$p_chan"} = join ",", @new_mem;
            $output = "(${target}) ${point}";
            $output = "\L\u${pc}"."${output}" if($pc ne $p_nick);
        }
    }

    return $output;
}

####################          カウンタ一覧         ########################
sub get_point_list {
    my $cmd = "\U$_[0]";
    my $p_nick = "\U$_[1]";
    my $p_chan = "\U$_[2]";
    my $mode  = $_[3];      # 0=同一チャンネル 1=同一Nick
    my $output = "1";

    $p_nick =~ /[_\d]*(.+)[_\d]*/;
    $p_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    if($cmd =~ /^#OPEN![\s]*(\w*)(\s|$)/) {
        my $tag = $1;
        if($mode) { # 自キャラの一覧表示(パラメータ指定不要)
            my $pc_list = $point_counter{"$p_nick"};
            my $pc_out = "";
            if($pc_list) {
                my @pc_arr = split /,/, $pc_list;
                my %sort_pc;
                foreach my $pc_o (@pc_arr) {
                    if(exists $point_counter{"${p_nick},${pc_o}"}) {
                        my $tag_out = "";
                        if($tag) {
                            my $check_name = "${p_nick},${pc_o}";
                            if(exists $point_counter{"${check_name},${tag},0"}) {
                                $sort_pc{$check_name} = $point_counter{"${check_name},${tag},0"};
                            }
                            if(exists $point_counter{"${check_name},${tag},1"}) {
                                $sort_pc{$check_name} = $point_counter{"${check_name},${tag},1"};
                            }
                        } else {
                            my $tag_list = $point_counter{"${p_nick},${pc_o}"};
                            my @tag_arr = split /,/, $tag_list;
                            foreach my $tag_o (@tag_arr) {
                                my $check_name = "${p_nick},${pc_o},${tag_o}";
                                if(exists $point_counter{"${check_name},0"}) {
                                    $tag_out .= "$tag_o(".$point_counter{"${check_name},0"}.") ";
                                }
                                if(exists $point_counter{"${check_name},1"}) {
                                    $tag_out .= "${tag_o}[".$point_counter{"${check_name},1"}."] ";
                                }
                            }
                        }
                        if($tag_out) {  # 中身があるなら
                            $pc_out .= ", " if($pc_out);
                            $pc_out .= "\L\u${pc_o}".":${tag_out}";
                        }
                    }
                }
                if($tag) {
                    my @pc_sorted = sort_point_hash(\%sort_pc);
                    my $out_pc = "";
                    foreach my $pc_o (@pc_sorted) {
                        my @pc_name = split /,/, $pc_o;
                        $out_pc .= ", " if($out_pc);
                        if($pc_name[1]) {
                            if(exists $point_counter{"${pc_o},${tag},0"}) {
                                $out_pc .= "\L\u${pc_name[1]}(".$point_counter{"${pc_o},${tag},0"}.")";
                            }
                            if(exists $point_counter{"${pc_o},${tag},1"}) {
                                $out_pc .= "\L\u${pc_name[1]}[".$point_counter{"${pc_o},${tag},1"}."]";
                            }
                        } else {
                            if(exists $point_counter{"${pc_o},${tag},0"}) {
                                $out_pc .= "\L\u${pc_name[0]}(".$point_counter{"${pc_o},${tag},0"}.")";
                            }
                            if(exists $point_counter{"${pc_o},${tag},1"}) {
                                $out_pc .= "\L\u${pc_name[0]}[".$point_counter{"${pc_o},${tag},1"}."]";
                            }
                        }
                    }
                    $pc_out = "${tag}: ${out_pc}" if($out_pc);
                }
            } else {
                if(exists $point_counter{"$p_nick,"}) {
                    my $tag_list = $point_counter{"$p_nick,"};
                    my @tag_arr = split /,/, $tag_list;
                    my $tag_out = "";
                    foreach my $tag_o (@tag_arr) {
                        my $check_name = "${p_nick},,${tag_o}";
                        if(exists $point_counter{"${check_name},0"}) {
                            $tag_out .= "${tag_o}(".$point_counter{"${check_name},0"}.") ";
                        }
                        if(exists $point_counter{"${check_name},1"}) {
                            $tag_out .= "${tag_o}[".$point_counter{"${check_name},1"}."] ";
                        }
                    }
                    if($tag_out) {  # 中身があるなら
                        $pc_out .= ", " if($pc_out);
                        $pc_out .= "${tag_out}";
                    }
                }
            }
            $output = $pc_out if($pc_out);
        } elsif($tag) { # 同一チャンネル特定タグ(ポイント)の表示
            my $mem_list = $point_counter{"$p_chan"};
            if($mem_list) {
                my %sort_pc;
                my @mem_arr = split /,/, $mem_list;
                foreach my $mem (@mem_arr) {
                    my $pc_list = $point_counter{"$mem"};
                    if($pc_list) {
                        my @pc_arr = split /,/, $pc_list;
                        foreach my $pc_o (@pc_arr) {
                            if(exists $point_counter{"${mem},${pc_o},${tag},0"}) {
                                $sort_pc{"${mem},${pc_o}"} = $point_counter{"${mem},${pc_o},${tag},0"};
                            }
                        }
                    }
                }
                my @pc_sorted = sort_point_hash(\%sort_pc);
                my $out_pc = "";
                foreach my $pc_o (@pc_sorted) {
                    my @pc_name = split /,/, $pc_o;
                    $out_pc .= ", " if($out_pc);
                    if($pc_name[1]) {
                        $out_pc .= "\L\u${pc_name[1]}(".$point_counter{"${pc_o},${tag},0"}.")";
                    } else {
                        $out_pc .= "\L\u${pc_name[0]}(".$point_counter{"${pc_o},${tag},0"}.")";
                    }
                }
                $output = "${tag}: ${out_pc}" if($out_pc);
            }
        }
    }
    return $output;
}

####################          カウンタ削除         ########################
sub delete_point_list {
    my $cmd = "\U$_[0]";
    my $p_nick = "\U$_[1]";
    my $output = "";

    $p_nick =~ /[_\d]*(.+)[_\d]*/;
    $p_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    if($cmd =~ /^#(([\w!]+)[:：])?DIED!(\s|$)/) {
        my $target_pc = $2;
        $target_pc = "$p_nick" if(!$target_pc);
        my $tree_pc = $point_counter{"$p_nick"};
        if($tree_pc) {
            if($target_pc ne "ALL!") {
                my $tree_tag = $point_counter{"${p_nick},${target_pc}"};
                if($tree_tag) {
                    my @tag_arr = split /,/, $tree_tag;
                    foreach my $tag_o (@tag_arr) {
                        delete $point_counter{"${p_nick},${target_pc},${tag_o},0"};
                        delete $point_counter{"${p_nick},${target_pc},${tag_o},1"};
                    }
                }
                delete $point_counter{"${p_nick},${target_pc}"};
                my @pc_arr = split /,/, $tree_pc;
                my @pc_list;
                foreach my $pc_o (@pc_arr) {
                    push @pc_list, $pc_o if($pc_o ne $target_pc);
                }
                if(@pc_list) {
                    $point_counter{"${p_nick}"} = join ",", @pc_list;
                } else {
                    delete $point_counter{"${p_nick}"};
                }
                $output .= "$target_pc";
            } else {
                my @pc_arr = split /,/, $tree_pc;
                foreach my $pc_o (@pc_arr) {
                    my $tree_tag = $point_counter{"${p_nick},${pc_o}"};
                    if($tree_tag) {
                        my @tag_arr = split /,/, $tree_tag;
                        foreach my $tag_o (@tag_arr) {
                            delete $point_counter{"${p_nick},${pc_o},${tag_o},0"};
                            delete $point_counter{"${p_nick},${pc_o},${tag_o},1"};
                        }
                    }
                    delete $point_counter{"${p_nick},${pc_o}"};
                    $output .= "," if($output);
                    $output .= "\L\u$pc_o";
                }
                delete $point_counter{"${p_nick}"};
            }
            if(!exists $point_counter{"${p_nick}"}) {   # 登録PCが無い=カウンタが全て無くなった
                my $d_chan = get_plot_channel("${p_nick}");
                if($d_chan) {
                    my $tree_mem = $point_counter{"${d_chan}"};
                    if($tree_mem) {
                        my @mem_arr = split /,/, $tree_mem;
                        my @new_mem;
                        foreach my $mem_o (@mem_arr) {
                            push @new_mem ,$mem_o if($mem_o ne $p_nick);
                        }
                        if(scalar @new_mem) {
                            $point_counter{"${d_chan}"} = join ",", @new_mem;
                        } else {
                            delete $point_counter{"${d_chan}"};
                        }
                    }
                }
            }
        }
    }
    return $output; # 削除されたPC名(カンマ区切り)を返す
}

####################          識別名の交換         ########################
sub rename_point_counter {
    my $cmd = "\U$_[0]";
    my $p_nick = "\U$_[1]";
    my $output = "1";

    $p_nick =~ /[_\d]*(.+)[_\d]*/;
    $p_nick = $1;   # Nick端の数字はカウンター変わりに使われることが多いので除去
    if($cmd =~ /^#RENAME![\s]*(\w+)[\s]*->[\s]*(\w+)(\s|$)/) {
        my $pre_pc = $1;
        my $next_pc = $2;
        my $tag_list = $point_counter{"${p_nick},${pre_pc}"};
        if($tag_list) {
            my $pc_list = $point_counter{"${p_nick}"} .= ",${next_pc}"; # キャラリストに追加
            $point_counter{"${p_nick},${next_pc}"} = $tag_list; # タグリストのコピー
            my $change_flg = 0;
            my @tag_arr = split /,/, $tag_list;
            foreach my $tag_o (@tag_arr) {  # タグデータのコピーと旧キャラのデータ削除
                if(my $pre_point = $point_counter{"${p_nick},${pre_pc},${tag_o},0"}) {
                    $point_counter{"${p_nick},${next_pc},${tag_o},0"} = $pre_point;
                    delete $point_counter{"${p_nick},${pre_pc},${tag_o},0"};
                    $change_flg = 1;
                }
                if(my $pre_point = $point_counter{"${p_nick},${pre_pc},${tag_o},1"}) {
                    $point_counter{"${p_nick},${next_pc},${tag_o},1"} = $pre_point;
                    delete $point_counter{"${p_nick},${pre_pc},${tag_o},1"};
                    $change_flg = 1;
                }
            }
            if($change_flg) {   # 移動済みなら古い識別名の登録データを消す
                delete $point_counter{"${p_nick},${pre_pc}"};   # 古いキャラのタグリスト削除
                my @pc_arr = split /,/, $pc_list;
                my @new_pc_list;
                foreach my $pc_o (@pc_arr) {
                    push @new_pc_list, $pc_o if($pc_o ne $pre_pc);
                }
                if(@new_pc_list) {
                    $point_counter{"${p_nick}"} = join ",", @new_pc_list;
                }
                $output = "\L\u${pre_pc}->"."\L\u${next_pc}";   # 変更メッセージ
            }
        }
    }
    return $output;
}

####################          その他の処理         ########################
sub set_point_tree {
    my $tree_str = $_[0];

    my @tree_arr = split /,/, $tree_str;
    my $before_tree = "$tree_arr[0]";
    for (my $i = 1; $i < scalar @tree_arr; $i++) {
        if(exists $point_counter{"$before_tree"}) { # 既にある
            my @cnt_list = split /,/, $point_counter{"$before_tree"};
            my @new_list;
            foreach my $list_o (@cnt_list) {    # 重複が無かったら追加
                push @new_list, $list_o if($list_o ne $tree_arr[$i]);
            }
            push @new_list, $tree_arr[$i];
            $point_counter{"$before_tree"} = join ",", @new_list;
        } else {    # 新規作成
            $point_counter{"$before_tree"} = "$tree_arr[$i]";
        }
        $before_tree .= ",$tree_arr[$i]";
    }
}
sub sort_point_hash {
    my $base_hash = $_[0];

    my @pc_sorted = sort {
        my $a_crr = $$base_hash{$a};
        my $a_max = 0;
        my $b_crr = $$base_hash{$b};
        my $b_max = 0;
        
        if($a_crr =~ /(\d+)[\/](\d+)/) {
            $a_crr = $1;
            $a_max = $2;
        }
        if($b_crr =~ /(\d+)[\/](\d+)/) {
            $b_crr = $1;
            $b_max = $2;
        }
        if($a_max or $b_max) {  # 現在値が小さい方が後ろ、同じ時はダメージが大きい方が後ろ(後方が危険)
            $b_crr <=> $a_crr or $a_max <=> $b_max or $a cmp $b
        } else {    # 現在値が小さい方が後ろ(後方が危険)
            $b_crr <=> $a_crr or $a cmp $b
        }
    } keys %$base_hash;

    return @pc_sorted;
}

#==========================================================================
#**                         カード関係
#==========================================================================
####################             ドロウ            ########################
sub c_draw {
    my $out_msg = "";
    my $count = 1;
    my $output = "";
    my $dst = "\U$_[1]";

    if($_[0] =~ /(c-draw(\[([\d]+)\])?)/) {
        if($3) {
            $count = ($3);
        }
        if($card_m <= 0) {
            $out_msg = '1';
            $count = 0;
        }else{
            for(my $i=1; $i<=$count; $i++) {
                my($card_no, $dummy) = &roll(1,$card_m);
                $out_msg = $card_re[$card_no];
                splice @card_re,$card_no,1;
                $card_m--;
                $deal_cards{$dst} .= "$out_msg,";
                $output .= "," if($output ne "");
                $output .= $out_msg;
                if($card_m <= 0) {
                    $count = $i;
                    last;
                }
            }
        }
    } else {
        $output = '1';
        $count = 0;
    }
    return($count, "\U$output");
}
sub c_pick {
    my $card_c = 0;
    my $card_n = "";
    my $dst = "\U$_[1]";

    if($_[0] =~ /(c-pick\[((,)?${card_reg})+\])/) {
        if($1 =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_pick1("$card_o", $dst);
                if($string eq '_OK_') {
                    $card_c++;
                } else {
                    $card_n .= "," if($card_n ne "");
                    $card_n .= "$string";
                }
            }
        }
    }
    return($card_c, $card_n);   # 抜き出せた枚数とデッキに無かったカードを返す
}
sub c_pick1 {
    my($card_no, $out_msg);
    my $card_ok = 0;
    my $card_t = "\U$_[0]"; # デッキから抜き出すカードの指定
    my $dst = "\U$_[1]";    # デッキから抜き出した人

    if($card_m <= 0) {
        return '山札';
    }else{
        $card_no = 0;
        foreach my $card_o (@card_re) {
            if($card_o =~ /^${card_t}$/i) {
                splice @card_re,$card_no,1;
                $card_m--;
                $deal_cards{$dst} .= "${card_o},";
                $card_ok = 1;
                last;
            }
            $card_no++;
        }
        if($card_ok) {
            return '_OK_';
        } else {
            return "$card_t";   # 無かったカードを返す
        }
    }
}
sub c_back {
    my $card_c = 0;
    my $card_n = "";
    my $place = 0;
    my $dst = "\U$_[1]";

    if($_[0] =~ /(c-back(\d*)\[((,)?${card_reg})+\])/) {
        my $cmdset = $1;
        if($2 =~ /(\d+)/) {
            $place = $1;
        }
        if($cmdset =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_1back("${card_o}", $dst);
                if($string eq '_OK_') {
                    $card_c++;
                } else {
                    $card_n .= "," if($card_n ne "");
                    $card_n .= "$string";
                }
            }
        }
    }
    return($card_c, $card_n);   # 戻せた枚数とNGだったカードを返す
}
sub c_1back {
    my($card_no, $out_msg);
    my $card_ok = 0;
    my $place = 0;
    my $card_t = "\U$_[0]";
    my $dst = "\U$_[1]";

    $place = $1 if($1 =~ /(\d+)/);
    if($card_place > 0) {   # 場があるときのみ処理
        if($place > 0) {
            my $string = &c_1pass("${card_t}", "$dst", "${place}${dst}");   # 場から手札への移動
            return '_OK_' if($string eq '_OK_');
        }
    }
    if($card_buried <= 0) {
        return '捨て札';    # 捨て札が無い
    } else {
        my @sute_card = split(/,/, $deal_cards{'card_played'});
        $card_no = 0;
        foreach my $card_b (@sute_card) {
            if($card_b =~ /^${card_t}$/i) {
                splice @sute_card,$card_no,1;
                $card_buried--;
                $deal_cards{$dst} .= "${card_b},";
                $card_ok = 1;
                last;
            }
            $card_no++;
        }
        if($card_ok) {
            $deal_cards{'card_played'} = (join ",", @sute_card).',';
            return '_OK_';
        } else {
            return "${card_t}"; # 戻せるカードが無かったらNGのカードを返す
        }
    }
}

####################             プレイ            ########################
sub c_play {
    my $card_c = 0;
    my $card_ng = "";
    my $dst = "\U$_[1]";
    my $card_ok = "";
    my $place = 0;

    if($_[0] =~ /(c-play(\d*)\[((,)?${card_reg})+\])/) {
        $place = ($2) if($2);
        if($1 =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_1play("$card_o", $place, $dst);
                if($string eq '_OK_') {
                    $card_c++;
                    $card_ok .= "," if($card_ok);
                    $card_ok .= "$card_o";
                } else {
                    $card_ng .= "," if($card_ng ne "");
                    $card_ng .= "$string";
                }
            }
        }
    }
    return($card_c, $card_ng, $card_ok);    # 出せた枚数、NGだったカード、出せたカード
}
sub c_1play {
    my $this_card = "\U$_[0]";
    my $place = $_[1];
    my $dst = "\U$_[2]";
    my $string = "";

    if($place > 0) {
        $string = &c_1pass("${this_card}", "${place}${dst}", $dst); # 場に出す処理
    } else {
        $string = &c_1dis("${this_card}", $place, $dst);    # 場を使わないときは捨て札扱い
    }
    if($string ne '_OK_') {
        return($this_card);
    } else {
        return '_OK_';
    }
}
sub c_discard {
    my $card_c = 0;
    my $card_ng = "";
    my $place = 0;
    my $dst = "\U$_[1]";
    my $card_ok = "";

    if($_[0] =~ /(c-(dis|discard)(\d*)\[((,)?${card_reg})+\])/) {
        my $cmdset = $1;
        $place = ($3) if($3);
        if($cmdset =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_1dis("$card_o", $place, $dst);
                if($string eq '_OK_') {
                    $card_c++;
                    $card_ok .= "," if($card_ok);
                    $card_ok .= "$card_o";
                } else {
                    $card_ng .= "," if($card_ng ne "");
                    $card_ng .= "$string";
                }
            }
        }
    }
    return($card_c, $card_ng, $card_ok);
}
sub c_1dis {
    my $card_t = "\U$_[0]";
    my $place = $_[1];
    my $dst = "\U$_[2]";
    my $hand_ok = 0;
    my $res_card = "";
    my $this_card = "";

    $dst = $place.$dst if($place > 0);  # 場札から出すときは「出した人」を場札に書き替え
    my @temp_card = split(/,/, $deal_cards{$dst});

    foreach my $temp_c (@temp_card) {
        if ((! $hand_ok) && ($temp_c =~ /^${card_t}$/i)) {
            $hand_ok = 1;
            $this_card = "$temp_c";
        } else {
            $res_card .= "$temp_c,";
        }
    }
    if($hand_ok) {
        $deal_cards{$dst} = $res_card;
        $deal_cards{'card_played'} .= "$this_card,";
        $card_buried++;
        return '_OK_';
    }else{
        return "$card_t";   # 指定のカードが無いので、無いカードを返す
    }
}

####################              パス             ########################
sub c_pass {
    my $place = 0;
    my $card_c = 0;
    my $card_ng = "";
    my $nick_e = "\U$_[1]";

    if($_[0] =~ /(c-pass(\d*)(\[(((,)?${card_reg})+)\])?)\s*(${IRC_NICK_REG})/) {
        my $dst = "\U$7";
        my $cmdset = $1;
        $place = ($2) if($2);
        $nick_e = "$place".$nick_e if($place > 0);
        if($cmdset =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_1pass("$card_o", "$dst", $nick_e);
                if($string eq '_OK_') {
                    $card_c++;
                } elsif($string eq '_NG_') {
                    return(-1, '渡す相手が登録されていません');
                } else {
                    $card_ng .= "," if($card_ng ne "");
                    $card_ng .= "$string";
                }
            }
        }
    }
    return($card_c, $card_ng);  # 渡せた枚数とNGなカードを返す
}
sub c_1pass {
    my $card_t = "\U$_[0]";
    my $dst = "\U$_[1]";
    my $nick_e = "\U$_[2]";
    my $hand_ok = 0;
    my $res_card = "";
    my $this_card = "";

    my @temp_card = (split(/,/, $deal_cards{$nick_e}));
    if($card_t eq '') { # カード指定がないのでランダムで一枚渡す
        my ($card_no, $dummy) = &roll(1, scalar @temp_card);
        $card_no--;
        $card_t = $temp_card[$card_no];
        splice @temp_card,$card_no,1;
        $res_card = join ",", @temp_card;
        $res_card .= "," if($res_card ne "");
        $hand_ok = 1;
    } else {
        foreach my $temp_c (@temp_card) {
            if ((! $hand_ok) && ($temp_c =~ /^${card_t}$/i)) {
                $hand_ok = 1;
                $this_card = "$temp_c";
            } else { 
                $res_card .= "$temp_c,"; 
            }
        }
    }
    if(! $hand_ok) {
        return "$card_t";
    }else{
        if(exists $deal_cards{$dst}) {  # 相手は登録済み？
            $deal_cards{$dst} .= "$this_card,";
        } else {
            my $ex_flg = -1;
            if($card_place > 0) {
                if($dst =~/^\d+(.+)/) { #渡すNickが数字で始まっていたら、場に出す処理の最初の一枚目
                    if(exists $deal_cards{$1}) {    #手札は登録されていたら宛先間違いではない
                        $deal_cards{$dst} = "$this_card,";
                        $ex_flg = 0;
                    }
                }
            }
            return '_NG_' if($ex_flg < 0);  # 宛先間違い
        }
        $deal_cards{$nick_e} = $res_card;
        return '_OK_';
    }
}
sub c_place {   #相手の場にカードを置く
    my $nick_e = "\U$_[1]";
    my $card_c = 0;
    my $card_ng = "";
    my $card_ok = "";

    if($_[0] =~ /(c-place(\d*)(\[(((,)?${card_reg})+)\])?)\s*(${IRC_NICK_REG})/) {
        my $dst = "\U$7";
        my $cmdset = $1;
        $nick_e = $2.$nick_e if(($2) && ($2 > 0));
        $dst = "1".$dst;    #今のところ場が１つしかないので相手の場は決めうち
        if($cmdset =~ /\[(${card_reg}(,${card_reg})*)\]/) {
            my @CARDS = split(/,/, $1);
            foreach my $card_o (@CARDS) {
                my $string = &c_1pass("${card_o}", "$dst", $nick_e);
                if($string eq '_OK_') {
                    $card_c++;
                    $card_ok .= "," if($card_ok);
                    $card_ok .= "$card_o";
                } elsif($string eq '_NG_') {
                    return(-1, '渡す相手が登録されていません');
                } else {
                    $card_ng .= "," if($card_ng ne "");
                    $card_ng .= "$string";
                }
            }
        }
    }
    return($card_c, $card_ng, $card_ok);    # 置けたカードの枚数、NGなカード、置けたカード
}

####################             タップ            ########################
sub c_tap {
    my $card_c = 0;
    my $place = 0;
    my $dst = "\U$_[1]";
    my $card_ng = "";
    my $card_ok = "";
    my $tap_dir = 0;

    if($can_tap && $card_place) {
        if($_[0] =~ /(c-(un)?tap(\d+)\[((,)?${card_reg})+\])/) {
            $tap_dir = 1 if($2);
            my $place = ($3);
            if($1 =~ /\[(${card_reg}(,${card_reg})*)\]/) {
                my @CARDS = split(/,/, $1);
                foreach my $card_o (@CARDS) {
                    my $string = &c_1tap("$card_o", $place, $dst, $tap_dir);
                    if($string eq '_OK_') {
                        $card_c++;
                        $card_ok .= "," if($card_ok);
                        $card_ok .= "$card_o";
                    } else {
                        $card_ng .= "," if($card_ng ne "");
                        $card_ng .= "$string";
                    }
                }
            }
        }
    }
    return($card_c, $card_ng, $card_ok);    # タップ出来た枚数、NGのカード、タップ出来たカード
}
sub c_1tap {
    my $this_card = "\U$_[0]";
    my $place = $_[1];
    my $dst = "\U$_[2]";
    my $untap = $_[3];
    my $string = "";

    if($can_tap > 0) {  # タップ処理をカードの場の移動で扱う(90度タップ、180度タップが将来必要になるかも)
        if($untap) {
            $string = &c_1pass("$this_card", ($place*2-1)."${dst}", ($place*2).$dst);
        } else {
            $string = &c_1pass("$this_card", ($place*2)."${dst}", ($place*2-1).$dst);
        }
    }
    if($string ne '_OK_') {
        return($this_card);
    } else {
        return '_OK_';
    }
}

####################            山札関連           ########################
sub c_milstone {    # 山からカードをめくって即座に捨てる
    my $src = $_[0];
    my $dst = $_[1];
    my $cmd = "c-draw";

    if($src =~ /\[(\d+)\]/) {
        $cmd .= '['.$1.']';
    }
    my($count, $output) = &c_draw($cmd, $dst);
    if($count > 0) {
        &c_discard('c-discard['.$output.']', $dst);
    } else {
        $count = 0;
    }
    return($count, $output);    # めくれた枚数と出たカードを返す
}
sub c_shuffle { # デッキと手札の初期化
    @card_re = @card_val;
    $card_m = $CARD_MAX;
    undef %deal_cards;
    %deal_cards = ('card_played' => '');
    $card_buried = 0;
    return "シャッフルしました";
}
sub c_clean { # 全員の場に出たカードを捨てる（手札はそのまま）
    if($card_place > 0) {   #カードを出す場が無いなら処理しない
        while(my($place, $cards) = each %deal_cards) {
            if($place =~ /^\d+/) {  # 最初が数値=場に出ているカードなので、カードを全部捨てて場も削除
                $cards =~ /(.+),$/;
                my $cardset = $1;
                &c_discard("c-discard[${cardset}]", $place);
                delete $deal_cards{$place};
            }
        }
    }
    return '場のカードを捨てました';
}
sub c_rshuffle {    # 捨て札をデッキに戻す
    my @temp_card = split(/,/, $deal_cards{'card_played'});

    push @card_re,@temp_card;
    $deal_cards{'card_played'} = '';
    $card_m += $card_buried;
    $card_buried = 0;
    return "捨て札を山に戻しました";
}

####################             その他            ########################
sub c_review {
    my $out_msg = "";

    for(my $cou = 1; $cou <= $card_m; $cou++) {
        $out_msg .= "$card_re[$cou],";
    }
    return $out_msg;
}
sub c_check {   # 今のカード配置を見る
    my @place_msg;
    my $out_msg = '山札:'.$card_m.'枚 捨札:'.$card_buried.'枚';

    while (my($cnt, $values) = each %deal_cards) {
        if($cnt eq 'card_played') { next; }
        if($cnt =~ /^(\d+)(${IRC_NICK_REG})/) {
            my $pnum = $1;
            my $cnick = $2;
            if($can_tap && ($pnum & 1) == 0) {
                push @place_msg, ' '.$cnick.'のタップした場札:'.&c_look($values);
            } else {
                push @place_msg, ' '.$cnick.'の場札:'.&c_look($values);
            }
        } else {
            my @card_cnt = (split(/,/, $values));
            $out_msg .= ' '.$cnt.':'.scalar @card_cnt.'枚';
        }
    }
    return($out_msg, @place_msg);   # 山札＆捨て札＆各自の手札枚数表示 と 各自の場札表示の配列を返す。(表示レイアウトの関係)
}
sub c_hand {    # 自分の手札と場札の確認
    my $dst = "\U$_[1]";
    my $out_msg = $deal_cards{$dst};
    if ($out_msg eq '') {
        $out_msg = "カードを持っていません";
    } else {
        $out_msg =~ s/,$//g;
        $out_msg = join ",", sort by_number (split(/,/, $out_msg)) if($HAND_SRT);
        $out_msg = "[ ".&c_look($out_msg)." ]";
    }
    if($card_place > 0) {
        my $place_msg = "";
        my $place_max = $card_place;
        $place_max *= 2 if($can_tap);
        for(my $cnt = 1; $cnt <= $place_max; $cnt++) {
            my $cards = "";
            $cards = $deal_cards{"${cnt}${dst}"} if(exists $deal_cards{"${cnt}${dst}"});
            if($cards ne "") {
                $cards =~ s/,$//g;
                $cards = join ",", sort by_number (split(/,/, $cards)) if($HAND_SRT);
            }
            $cards = &c_look($cards);
            if($can_tap && ($cnt & 1) == 0) {
                $place_msg .= ' タップした場札'.":[ ".$cards." ]";
            } else {
                $place_msg .= ' 場札'.":[ ".$cards." ]";
            }
        }
        $out_msg .= $place_msg;
    }
    return $out_msg;    # 手札と場札表示を返す
}
sub by_number { # ソートサブルーチン
    if($a =~ /[^\d]/) {
        $a =~ /([^\d]+)(\d+)/;
        my $sa = $1;
        my $na = $2;
        $b =~ /([^\d]+)(\d+)/;
        my $sb = $1;
        my $nb = $2;
        "\U$sa" cmp "\U$sb" or $na <=> $nb
    } else {
        $a <=> $b
    }
}
sub c_look {    # 汎用カードセット用カードタイトルの表示
    my $card_str = $_[0];
    my $out_msg = "";

    if(%card_ttl) { # カードタイトルが定義されてないなら不要
        my @CARDS = split(/,/, $card_str);
        foreach my $card_o (@CARDS) {
            $out_msg .="," if($out_msg ne "");
            $out_msg .= $card_o."-".$card_ttl{"${card_o}"};
        }
        $out_msg = '無し' if($out_msg eq "");
    } else {
        $out_msg = $card_str;
    }
    return $out_msg;
}

####################           復活の呪文          ########################
sub c_spell {   # 復活の呪文
    $_[0] =~ /c-spell(\[(([\s,]?(${IRC_NICK_REG}:)?[A-Za-z0-9\+\-\/\*]+)+)\])?/;
    my $output = '';
    my $spell_chk = '';

    foreach my $dummy (@card_val) {
        $spell_chk .= "," if($spell_chk ne "");
        $spell_chk .= "0";
    }
    if(!$1) {   # 呪文の取得
        # まずは出たカードと呪文短縮用文字列の取得
        my ($out_now1, $out_now2);
        ($out_now1, $spell_chk) = &spell_make($deal_cards{'card_played'}, $spell_chk, @card_val);
        if($short_spell) {
            ($out_now2, $spell_chk) = &spell_make(join(",", @card_re), $spell_chk, @card_val);
            $out_now1 .= ",SPELL_SHORTER:".$out_now2;
        }
        $output = $out_now1.$output;

        while (my($cnt, $values) = each %deal_cards) {
            my $out_wk;
            if($cnt ne 'card_played') {
                if($values) {   # カードを持っていない人は除外(呪文短縮のため)
                    ($out_wk, $spell_chk) = &spell_make($values, $spell_chk, @card_val);
                    $output .= ','.$cnt.':'.$out_wk;
                }
            }
        }
        $output = '復活の呪文 ＞ ['.$output.']';    # 呪文表示を返す
    } else {    # 呪文の実行
        &c_shuffle;
        my $temp_c = $2;
        $temp_c =~ s/\s//g;
        my @spell_str = (split(/,/, $temp_c));
        foreach my $spell_str (@spell_str) {
            ($output, $spell_chk) = &spell_read(split(/:/, $spell_str), $spell_chk);
        }
    }
    return $output; # 結果を返す
}
sub spell_make {    # 実際の呪文作成
    my @dst_arr;
    my($card_str, $check_lst, @src) = @_;
    my @card_wk = (split(/,/, $card_str));
    my @chk_arr = (split(/,/, $check_lst));
    my @hit_arr = @chk_arr;
    my $dst = '';

    for(my $i=0; $i < scalar @src ; $i++) {
        push(@dst_arr, 0);
    }
    foreach my $card_wk (@card_wk) {
        for(my $i = 0; $i < scalar @src; $i++) {
            if($card_wk eq $src[$i]) {
                $dst_arr[$i] = 1;
                $hit_arr[$i] = 1;
                last;
            }
        }
    }
    if($short_spell) {  # 呪文を短くするために既出のカードのビットを抜く
        my @dst_now;
        for(my $i=0; $i < scalar @dst_arr; $i++) {
            push(@dst_now, $dst_arr[$i]) if($chk_arr[$i] ne "1");
        }
        @dst_arr = @dst_now;
        $check_lst = join(",", @hit_arr);
    }
    my $cnt = scalar @dst_arr / 6;
    for(my $i=0; $i < 6; $i++) {
        push(@dst_arr, 0);
    }
    for(my $i = 0; $i < $cnt; $i++) {   # 6bitごとに刻んで処理する
        my $bit6 = $dst_arr[$i*6+0] + $dst_arr[$i*6+1]*2 + $dst_arr[$i*6+2]*(2**2) + $dst_arr[$i*6+3]*(2**3) +
                $dst_arr[$i*6+4]*(2**4) + $dst_arr[$i*6+5]*(2**5);
        $dst .= $card_spell[$bit6];
    }
    return($dst, $check_lst);
}
sub spell_read {    # 呪文の実行
    my($dst, $card, $card_lst, @card_arr);
    if($_[2]) {
        $dst = "\U$_[0]";
        $card = $_[1];
        $card_lst = $_[2];
    } else {
        $dst = 'card_played';
        $card = $_[0];
        $card_lst = $_[1];
    }
    my @card_src = split(/,/, $card_lst);
    my @card_dst = @card_src;
    my $out_msg = '0';

    for(my $i=0; $i<length($card); $i++) {
        my $word = substr($card, $i, 1);
        my $bit6 = 0;
        for(my $i2=0; $i2 < scalar @card_spell; $i2++) {
            if($card_spell[$i2] eq $word) {
                $bit6 = $i2;
                last;
            }
        }
        my $work = int($bit6 / 2);
        for(my $i2=0; $i2 < 6; $i2++) {
            if($bit6-$work*2 >= 1) {
                $card_arr[$i*6 + $i2] = 1;
            } else {
                $card_arr[$i*6 + $i2] = 0;
            }
            $bit6 = $work;
            $work = int($bit6 / 2);
        }
    }
    if($short_spell) {  # 短くなっている呪文を戻す
        my @dst_now;
        for(my $i3=0; $i3 < scalar @card_val; $i3++) {
            if($card_src[$i3] ne "0") {
                push(@dst_now, 0);
            } else {
                push(@dst_now, shift @card_arr);
            }
        }
        @card_arr = @dst_now;
    }
    for(my $i = 0; $i < (scalar @card_val); $i++) {
        if($card_arr[$i] == 1) {
            my $card_no = 0;
            my $card_ok = 0;
            foreach my $card_re (@card_re) {
                if($card_val[$i] eq $card_re) {
                    $card_ok = 1;
                    $card_dst[$i] = "1";
                    last;
                }
                $card_no++;
            }
            if($card_ok) {
                if($dst ne 'SPELL_SHORTER') {   # 呪文短縮用データはカード配置処理不要
                    $deal_cards{$dst} .= "$card_val[$i],";
                    splice @card_re,$card_no,1;
                    $card_m--;
                    if($dst eq 'card_played') {
                        $card_buried++;
                    }
                }
            } else {
                $out_msg = '呪文が違います';
            }
        }
    }
    $card_lst = join(",", @card_dst) if($short_spell);
    return($out_msg, $card_lst);    # 結果と今まで出たカードリストを返す(短縮呪文展開用)
}

###########################################################################
#**                              出力関連
###########################################################################
sub broadmsg {
    my($self, $output_msg, $nick) = @_;

    if($output_msg ne "1") {
        if(!$DodontoFlg) {
            &send_msg($self,$nick, $output_msg);
        } else {
            $self->privmsg("", encode($IRC_CODE, $output_msg));
        }
    }
}
sub send_msg {
    my($self, $to ,$msgs) = @_;

    if(length($msgs) > $SEND_STR_MAX) {         # 長すぎる出力はイタズラと見なす
        $msgs = '結果が長くなりすぎました';
    }
    &debug_out("$to [$nick] ${msgs}\n");
    if($NOTICE_SW) {
        $self->notice(encode($IRC_CODE ,$to), encode($IRC_CODE ,$msgs));        # noticeで送信
    } else {
        $self->privmsg(encode($IRC_CODE ,$to), encode($IRC_CODE ,$msgs));       # privmsgで送信
    }
}
sub debug_out {
    if(!$DodontoFlg) {
        if(scalar @_ > 1) {
            printf @_ ;
        } else {
            print @_ ;
        }
    }
}
####################         テキスト前処理        ########################
sub parren_killer {
    my($string) = @_;

    while($string =~ /^(.*?)\[(\d+)[.]{3}(\d+)\](.*)/) {
        my $str_before = $1;
        my $rand_s = $2;
        my $rand_e = $3;
        my $str_after = $4;
        if($rand_s < $rand_e) {
            my ($rolled, $dmy) = &roll(1, int($rand_e - $rand_s + 1));
            $rolled += $rand_s - 1;
            $string = "${str_before}${rolled}${str_after}";
        }
    }
    while($string =~ /^(.*?)(\([\d\/*+-]+?\))(.*)/) {
        my $par_i = $2;
        my $str_b = $1;
        my $str_a = $3;
        my $par_o = paren_k($par_i);
        if($par_o != 0) {
            if($par_o < 0) {
                if($str_b =~ /(.+?)(\+)$/) {
                    $str_b = $1;
                } elsif($str_b =~ /(.+?)(-)$/) {
                    $str_b = "$1+";
                    $par_o =~ /([\d]+)/;
                    $par_o = $1;
                }
            }
            $string = "$str_b$par_o$str_a";
        } else {
            if($str_a =~ /^([DBRUdbru][\d]+)(.*)/) {
                $str_a = $2;
            }
            $string = "${str_b}0${str_a}";
        }
    }

    # ゲーム特有のダイス表記の読み替え処理
    if($d66_on) {
        if($string =~ /(\d)*[dD]66/) {
            $string =~ s/(\d)*[dD]66/2B6/g;
        }
    }
    if($game_type eq "Tunnels & Trolls") {
        if($string =~ /(\d+)LV/i) {
            my $level_diff = ($1) * 5 + 15;
            $string =~ s/(\d+)LV/$level_diff/i;
        }
        if($string =~ /BS/i){
            $string =~ s/(\d+)HBS([^\d\s][\+\-\d]+)/${1}R6${2}[H]/ig;
            $string =~ s/(\d+)HBS/${1}R6[H]/ig;
            $string =~ s/(\d+)BS([^\d\s][\+\-\d]+)/${1}R6${2}/ig;
            $string =~ s/(\d+)BS/${1}R6/ig;
        }
    }
    elsif($game_type eq "NightmareHunterDeep") {
        if($string =~ /^(.+?)Lv(\d+)(.*)/i) {
            $string = $1.($2 * 5 - 1).$3;
        }
        if($string =~ /^(.+?)NL(\d+)(.*)/i) {
            $string = $1.($2 * 5 + 5).$3;
        }
    }
    elsif($game_type eq "ShadowRun4") {
        if($string =~ /(\d+)S6/i) {
            $string =~ s/(\d+)S6/${1}B6/ig;
        }
    }
    elsif($game_type eq "DoubleCross") {
        if($string =~ /(\d+)DX/i) {
            $string =~ s/(\d+)DX(\d*)([^\d\s][\+\-\d]+)/${1}R10${3}[${2}]/ig;
            if($string =~ /\@(\d+)/) {
                my $crit = $1;
                $string =~ s/\[\]/\[${crit}\]/;
                $string =~ s/\@(\d+)//;
            }
        }
    }
    elsif($game_type eq "ArsMagica") {
        if($string =~ /ArS/i) {
            $string =~ s/ArS(\d+)([^\d\s][\+\-\d]+)/1R10${2}[${1}]/ig;
            $string =~ s/ArS([^\d\s][\+\-\d]+)/1R10${1}/ig;
            $string =~ s/ArS(\d+)/1R10[${1}]/ig;
            $string =~ s/ArS/1R10/ig;
        }
    }
    $string =~ s/([\d]+[dD])([^\d]|$)/${1}6${2}/g;

    return $string;
}
sub paren_k {
    my($string) = @_;
    my $kazu_o = 0;

    if($string =~ /([\d\/*+-]+)/) {
        $string = $1;
        my @KAZU_P = split(/\+/, $string);
        foreach my $kazu_a (@KAZU_P) {
            my $work = 0;
            my $dec_p = "";
            if($kazu_a =~ /(.*?)(-)(.*)/) {
                $kazu_a = $1;
                $dec_p = $3;
            }
            my $mul = 1;
            my $dev = 1;
            while($kazu_a =~ /(.*?)(\*[\d]+)(.*)/) {
                my $par_b = $1;
                my $par_a = $3;
                my $par_c = $2;
                $kazu_a = "$par_b$par_a";
                if($par_c =~ /([\d]+)/) {
                    $mul = $mul * $1;
                }
            }
            while($kazu_a =~ /(.*?)(\/[\d]+)(.*)/) {
                my $par_b = $1;
                my $par_a = $3;
                my $par_c = $2;
                $kazu_a = "$par_b$par_a";
                if($par_c =~ /([\d]+)/) {
                    $dev = $dev * $1;
                }
            }
            if($kazu_a =~ /([\d]+)/) {
                $work = ($1) * $mul;
                if($round_flg == 1){
                    $kazu_o += int($work / $dev + 0.999) if($dev);
                } elsif($round_flg >= 2){
                    $kazu_o += int($work / $dev + 0.5) if($dev);
                } else {
                    $kazu_o += int($work / $dev) if($dev);
                }
            }
            if($dec_p ne "") {
                my @KAZU_M = split(/-/, $dec_p);
                foreach my $kazu_s (@KAZU_M) {
                    $mul = 1;
                    $dev = 1;
                    while($kazu_s =~ /(.*?)(\*[\d]+)(.*)/) {
                        my $par_b = $1;
                        my $par_a = $3;
                        my $par_c = $2;
                        $kazu_s = "$par_b$par_a";
                        if($par_c =~ /([\d]+)/) {
                            $mul = $mul * $1;
                        }
                    }
                    while($kazu_s =~ /(.*?)(\/[\d]+)(.*)/) {
                        my $par_b = $1;
                        my $par_a = $3;
                        my $par_c = $2;
                        $kazu_s = "$par_b$par_a";
                        if($par_c =~ /([\d]+)/) {
                            $dev = $dev * $1;
                        }
                    }
                    if($kazu_s =~ /([\d]+)/) {
                        $work = ($1) * $mul;
                        if($round_flg == 1){
                            $kazu_o -= int($work / $dev + 0.999) if($dev);
                        } elsif($round_flg >= 2){
                            $kazu_o -= int($work / $dev + 0.5) if($dev);
                        } else {
                            $kazu_o -= int($work / $dev) if($dev);
                        }
                    }
                }
            }
        }
    }
    return $kazu_o;
}

###########################################################################
#**                        ゲーム設定関連
###########################################################################
sub card_setup {
    my $card_file = $_[0];

    if($card_file) { # 専用カードセットのロード
        &debug_out("Loading Cardset『${card_file}』...\n");

        @card_val = ('-1',);
        open(FILE , encode(CHARCODE, "< ${card_file}")) || return "カードデータを開けません :『${card_file}』$!";
        while(my $line_raw = <FILE>) {
            my $line = decode(CHARCODE, "$line_raw");   # カードデータの文字コードはOSの文字コードと一致とする
            if($line =~ /^(\d+)->(.+)$/) {  # 番号->タイトル
                my $cardnum = "$1";
                my $card_t = "$2";
                push(@card_val, $cardnum);
                $card_ttl{"${cardnum}"} = $card_t;
            } else {
                next;
            }
        }
        close(FILE);
        $card_reg = '[\d]+';    #カード指定文字列の正規表現
        @card_re = @card_val;
        $CARD_MAX = scalar @card_val - 1;
        $card_m = $CARD_MAX;
        $card_buried = 0;
        undef %deal_cards;
        %deal_cards = ('card_played' => '');

        &debug_out("Load Finished...\n");
    }
    return '_OK_';
}

sub game_clear {
    $upperinf = 0;      #上方無限
    $upper_dice = 0;    #無限ロールのダイス
    $max_dice = 0;      #最大値表示
    $min_dice = 0;      #最小値表示
    $reroll_cnt = 0;    #振り足し回数上限
    $reroll_n = 0;      #振り足しする条件
    $d66_on = 0;        #d66の差し替え
    $sort_flg = 0;      #ソート設定
    $double_up = 0;     #ゾロ目で振り足し(0=無し, 1=全部同じ目, 2=ダイスのうち2個以上同じ目)
    $suc_def = "";      #目標値が空欄の時の目標値
    $round_flg = 0;     #端数の処理(0=切り捨て, 1=切り上げ, 2=四捨五入)
    $double_type = 0;   #ゾロ目で振り足しのロール種別(0=判定のみ, 1=ダメージのみ, 2=両方)
    $modeflg = $SEND_MODE;
    &c_set_default;
}
sub c_set_default { # カードをデフォルトに戻す
    @card_val = ('0',
    'S1','S2','S3','S4','S5','S6','S7','S8','S9','S10','S11','S12','S13',
    'H1','H2','H3','H4','H5','H6','H7','H8','H9','H10','H11','H12','H13',
    'D1','D2','D3','D4','D5','D6','D7','D8','D9','D10','D11','D12','D13',
    'C1','C2','C3','C4','C5','C6','C7','C8','C9','C10','C11','C12','C13',
    'J1',
        );
    @card_re = @card_val;
    $CARD_MAX = scalar @card_val - 1;
    $card_m = $CARD_MAX;
    $card_buried = 0;
    undef %deal_cards;
    %deal_cards = ('card_played' => '');
    $card_reg = '[DHSCJdhscj][\d]+';    #カード指定文字列の正規表現
    undef %card_ttl;

    $card_place = 1;    #手札の他のカード置き場
    $can_tap = 1;       #場札のタップ処理の必要があるか？
}

sub game_set {  # 各種ゲームモードの設定
    my $tnick = $_[0];

    if($tnick =~ /((Cthulhu)|(COC))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Cthulhu";
        return('Game設定をCall of Cthulhu(BRP)に設定しました');
    }
    elsif($tnick =~ /((Hieizan)|(COCH))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = 'Hieizan';
        return('Game設定を比叡山炎上(CoC)に設定しました');
    }
    elsif($tnick =~ /((Elric!)|(EL))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = 'Elric!';
        return('Game設定をElric!に設定しました');
    }
    elsif($tnick =~ /((RuneQuest)|(RQ))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "RuneQuest";
        return('Game設定をRuneQuestに設定しました');
    }
    elsif($tnick =~ /((Chill)|(CH))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Chill";
        return('Game設定をChillに設定しました');
    }
    elsif($tnick =~ /((RoleMaster)|(RM))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "RoleMaster";
        $upperinf = 96;
        $upper_dice = 100;
        return('Game設定をRoleMasterに設定しました');
    }
    elsif($tnick =~ /((ShadowRun)|(SR))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "ShadowRun";
        $upperinf = 6;
        $upper_dice = 6;
        $sort_flg = 3;
        return('Game設定をShadowRunに設定しました');
    }
    elsif($tnick =~ /((ShadowRun4)|(SR4))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "ShadowRun4";
        $sort_flg = 3;
        $reroll_n = 6;      #振り足しする出目
        $suc_def = ">=5";   #目標値が空欄の時の目標値
        return('Game設定をShadowRun4版に設定しました');
    }
    elsif($tnick =~ /((Pendragon)|(PD))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Pendragon";
        return('Game設定をPendragonに設定しました');
    }
    elsif($tnick =~ /((SwordWorld)|(SW))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "SwordWorld";
        $rating_table = 0;  # レーティング表を文庫版モードに
        return('Game設定をソードワールドに設定しました');
    }
    elsif($tnick =~ /((SwordWorld)\s*2\.0|(SW)\s*2\.0)$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "SwordWorld2.0";
        $rating_table = 2;
        return('Game設定をソードワールド2.0に設定しました');
    }
    elsif($tnick =~ /((Arianrhod)|(AR))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Arianrhod";
        $modeflg = 2;
        $d66_on = 1;
        $sort_flg = 1;
        return('Game設定をアリアンロッドに設定しました');
    }
    elsif($tnick =~ /((Infinite[\s]*Fantasia)|(IF))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Infinite Fantasia";
        return('Game設定を無限のファンタジアに設定しました');
    }
    elsif($tnick =~ /(WARPS)$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "WARPS";
        return('Game設定をWARPSに設定しました');
    }
    elsif($tnick =~ /((Demon[\s]*Parasite)|(DP))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Demon Parasite";
        $modeflg = 2;
        $d66_on = 1;
        $sort_flg = 1;
        return('Game設定をデモンパラサイトに設定しました');
    }
    elsif($tnick =~ /((Gun[\s]*Dog)|(GD))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Gundog";
        return('Game設定をガンドッグに設定しました');
    }
    elsif($tnick =~ /((Tunnels[\s]*&[\s]*Trolls)|(TuT))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Tunnels & Trolls";
        $modeflg = 2;
        $sort_flg = 1;
        $double_up = 1;
        return('Game設定をトンネルズ＆トロールズに設定しました');
    }
    elsif($tnick =~ /((Nightmare[\s]*Hunter[=\s]*Deep)|(NHD))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "NightmareHunterDeep";
        $modeflg = 2;
        $sort_flg = 1;
        return('Game設定をナイトメアハンター・ディープに設定しました');
    }
    elsif($tnick =~ /((War[\s]*Hammer(FRP)?)|(WH))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Warhammer";
        $modeflg = 2;
        $round_flg = 1;
        return('Game設定をウォーハンマーFRPに設定しました');
    }
    elsif($tnick =~ /((Phantasm[\s]*Adventure)|(PA))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "PhantasmAdventure";
        $modeflg = 2;
        return('Game設定をファンタズムアドベンチャーに設定しました');
    }
    elsif($tnick =~ /((Chaos[\s]*Flare)|(CF))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Chaos Flare";
        @card_val = ('0',
        'S1','S2','S3','S4','S5','S6','S7','S8','S9','S10','S11','S12','S13',
        's1','s2','s3','s4','s5','s6','s7','s8','s9','s10','s11','s12','s13',
        'H1','H2','H3','H4','H5','H6','H7','H8','H9','H10','H11','H12','H13',
        'h1','h2','h3','h4','h5','h6','h7','h8','h9','h10','h11','h12','h13',
        'D1','D2','D3','D4','D5','D6','D7','D8','D9','D10','D11','D12','D13',
        'd1','d2','d3','d4','d5','d6','d7','d8','d9','d10','d11','d12','d13',
        'C1','C2','C3','C4','C5','C6','C7','C8','C9','C10','C11','C12','C13',
        'c1','c2','c3','c4','c5','c6','c7','c8','c9','c10','c11','c12','c13',
        'J1','J2','J3','J4',
            );
        @card_re = @card_val;
        $CARD_MAX = (scalar @card_val) - 1;
        $card_m = $CARD_MAX;
        $card_buried = 0;
        undef %deal_cards;
        %deal_cards = ('card_played' => '');
        $card_place = 0;    #手札の他のカード置き場
        $can_tap = 0;       #場札のタップ処理の必要があるか？
        return('Game設定をカオスフレアに設定しました');
    }
    elsif($tnick =~ /((Cthulhu[\s]*Tech)|(CT))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "CthulhuTech";
        $modeflg = 2;
        $sort_flg = 1;
        return('Game設定をクトゥルフ・テックに設定しました');
    }
    elsif($tnick =~ /((Tokumei[\s]*Tenkousei)|(ToT))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "TokumeiTenkousei";
        $modeflg = 2;
        $sort_flg = 1;
        $double_up = 1;
        $double_type = 2;
        return('Game設定を特命転攻生に設定しました');
    }
    elsif($tnick =~ /((Shinobi[\s]*Gami)|(SG))$/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "ShinobiGami";
        $modeflg = 2;
        $sort_flg = 1;
        $d66_on = 1;
        return('Game設定を忍神に設定しました');
    }
    elsif($tnick =~ /((Double[\s]*Cross)|(DX))/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "DoubleCross";
        $modeflg = 2;
        $sort_flg = 2;
        $reroll_n = 10;     #振り足しする条件
        $upperinf = 10;     #上方無限
        $upper_dice = 10;   #無限ロールのダイス
        $max_dice = 1;      #最大値表示
        return('Game設定をダブルクロス3に設定しました');
    }
    elsif($tnick =~ /((Sata[\s]*Supe)|(SS))/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "Satasupe";
        $modeflg = 2;
        $sort_flg = 2;
        $d66_on = 1;
        return('Game設定をサタスペに設定しました');
    }
    elsif($tnick =~ /((Ars[\s]*Magica)|(AM))/i) {
        &game_clear;        # 諸設定のクリア
        $game_type = "ArsMagica";
        $modeflg = 2;
        return('Game設定をArsMagicaに設定しました');
    }

    elsif($tnick =~ /(None)$/i || $tnick eq "") {   # ゲーム設定を解除する
        &game_clear;        # 諸設定のクリア
        $game_type = "";
        return('Game設定を解除しました');
    } else {
        return('そのゲームは未実装です');
    }
}

###########################################################################
#**                             IRC起動
###########################################################################
&debug_out("Installing handler routines...");
$conn->add_handler('cping',   \&on_ping);
$conn->add_handler('crping',  \&on_ping_reply);
$conn->add_handler('msg',     \&on_msg);
$conn->add_handler('public',  \&on_public);
$conn->add_handler('caction', \&on_action);
$conn->add_handler('join',    \&on_join);
$conn->add_handler('part',    \&on_part);
$conn->add_handler('topic',   \&on_topic);
$conn->add_handler('notopic', \&on_topic);
$conn->add_handler('invite',  \&on_invite);
$conn->add_handler('kick',    \&on_kick);

$conn->add_global_handler([ 251,252,253,254,302,255 ], \&on_init);
$conn->add_global_handler('disconnect', \&on_disconnect);
$conn->add_global_handler([ 376,422 ], \&on_connect);   # 376 = EndofMOTD, 422 = no MOTD
$conn->add_global_handler(433, \&on_nick_taken);
$conn->add_global_handler(353, \&on_names);
&debug_out(" done.\n");
&debug_out("starting...\n");
$irc->start;

print("###customBot END###");
